# Class: DevUtilsContract


##   Constructors



\+ **new DevUtilsContract**(`address`: string, `supportedProvider`: [SupportedProvider](#supportedprovider), `txDefaults?`: `Partial<TxData>`, `logDecodeDependencies?`: undefined | object, `deployedBytecode`: string | undefined): *[DevUtilsContract](#class-devutilscontract)*

*Overrides void*

*Defined in [abi-gen-wrappers/src/generated-wrappers/dev_utils.ts:2798](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/dev_utils.ts#L2798)*

**Parameters:**

Name | Type | Default |
------ | ------ | ------ |
`address` | string | - |
`supportedProvider` | [SupportedProvider](#supportedprovider) | - |
`txDefaults?` | `Partial<TxData>` | - |
`logDecodeDependencies?` | undefined \| object | - |
`deployedBytecode` | string \| undefined |  DevUtilsContract.deployedBytecode |

**Returns:** *[DevUtilsContract](#class-devutilscontract)*

## Properties

### `Optional` _deployedBytecodeIfExists

• **_deployedBytecodeIfExists**? : *`Buffer`*



Defined in base-contract/lib/src/index.d.ts:33

___

###  abi

• **abi**: *[ContractAbi](#contractabi)*



Defined in base-contract/lib/src/index.d.ts:29

___

###  address

• **address**: *string*



Defined in base-contract/lib/src/index.d.ts:30

___

Args

• **constructorArgs**: *any[]*



Defined in base-contract/lib/src/index.d.ts:32

___

###  contractName

• **contractName**: *string*



Defined in base-contract/lib/src/index.d.ts:31

## Methods

###  decodeAssetProxyDispatchError

▸ **decodeAssetProxyDispatchError**(`encoded`: string): *`ContractFunctionObj<[number, string, string]>`*

*Defined in [abi-gen-wrappers/src/generated-wrappers/dev_utils.ts:1518](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/dev_utils.ts#L1518)*

Decompose an ABI-encoded AssetProxyDispatchError.

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`encoded` | string | ABI-encoded revert error. |

**Returns:** *`ContractFunctionObj<[number, string, string]>`*

errorCode The error code.orderHash Hash of the order being dispatched.assetData Asset data of the order being dispatched.

___

###  decodeAssetProxyExistsError

▸ **decodeAssetProxyExistsError**(`encoded`: string): *`ContractFunctionObj<[string, string]>`*

*Defined in [abi-gen-wrappers/src/generated-wrappers/dev_utils.ts:1543](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/dev_utils.ts#L1543)*

Decompose an ABI-encoded AssetProxyExistsError.

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`encoded` | string | ABI-encoded revert error. |

**Returns:** *`ContractFunctionObj<[string, string]>`*

assetProxyId Id of asset proxy.assetProxyAddress The address of the asset proxy.

___

###  decodeAssetProxyId

▸ **decodeAssetProxyId**(`assetData`: string): *`ContractFunctionObj<string>`*

*Defined in [abi-gen-wrappers/src/generated-wrappers/dev_utils.ts:1566](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/dev_utils.ts#L1566)*

Decode AssetProxy identifier

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`assetData` | string | AssetProxy-compliant asset data describing an ERC-20, ERC-     721, ERC1155, or MultiAsset asset. |

**Returns:** *`ContractFunctionObj<string>`*

The AssetProxy identifier

___

###  decodeAssetProxyTransferError

▸ **decodeAssetProxyTransferError**(`encoded`: string): *`ContractFunctionObj<[string, string, string]>`*

*Defined in [abi-gen-wrappers/src/generated-wrappers/dev_utils.ts:1588](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/dev_utils.ts#L1588)*

Decompose an ABI-encoded AssetProxyTransferError.

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`encoded` | string | ABI-encoded revert error. |

**Returns:** *`ContractFunctionObj<[string, string, string]>`*

orderHash Hash of the order being dispatched.assetData Asset data of the order being dispatched.errorData ABI-encoded revert data from the asset proxy.

___

###  decodeEIP1271SignatureError

▸ **decodeEIP1271SignatureError**(`encoded`: string): *`ContractFunctionObj<[string, string, string, string]>`*

*Defined in [abi-gen-wrappers/src/generated-wrappers/dev_utils.ts:1613](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/dev_utils.ts#L1613)*

Decompose an ABI-encoded SignatureValidatorError.

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`encoded` | string | ABI-encoded revert error. |

**Returns:** *`ContractFunctionObj<[string, string, string, string]>`*

signerAddress The expected signer of the hash.signature The full signature bytes.errorData The revert data thrown by the validator contract.

___

###  decodeERC1155AssetData

▸ **decodeERC1155AssetData**(`assetData`: string): *`ContractFunctionObj<[string, string, BigNumber[], BigNumber[], string]>`*

*Defined in [abi-gen-wrappers/src/generated-wrappers/dev_utils.ts:1639](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/dev_utils.ts#L1639)*

Decode ERC-1155 asset data from the format described in the AssetProxy contract specification.

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`assetData` | string | AssetProxy-compliant asset data describing an ERC-1155 set     of assets. |

**Returns:** *`ContractFunctionObj<[string, string, BigNumber[], BigNumber[], string]>`*

The ERC-1155 AssetProxy identifier, the address of the ERC-1155 contract hosting the assets, an array of the identifiers of the assets to be traded, an array of asset amounts to be traded, and callback data.  Each element of the arrays corresponds to the same-indexed element of the other array.  Return values specified as &#x60;memory&#x60; are returned as pointers to locations within the memory of the input parameter &#x60;assetData&#x60;.

___

###  decodeERC20AssetData

▸ **decodeERC20AssetData**(`assetData`: string): *`ContractFunctionObj<[string, string]>`*

*Defined in [abi-gen-wrappers/src/generated-wrappers/dev_utils.ts:1668](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/dev_utils.ts#L1668)*

Decode ERC-20 asset data from the format described in the AssetProxy contract specification.

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`assetData` | string | AssetProxy-compliant asset data describing an ERC-20 asset. |

**Returns:** *`ContractFunctionObj<[string, string]>`*

The AssetProxy identifier, and the address of the ERC-20  contract hosting this asset.

___

###  decodeERC721AssetData

▸ **decodeERC721AssetData**(`assetData`: string): *`ContractFunctionObj<[string, string, BigNumber]>`*

*Defined in [abi-gen-wrappers/src/generated-wrappers/dev_utils.ts:1691](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/dev_utils.ts#L1691)*

Decode ERC-721 asset data from the format described in the AssetProxy contract specification.

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`assetData` | string | AssetProxy-compliant asset data describing an ERC-721     asset. |

**Returns:** *`ContractFunctionObj<[string, string, BigNumber]>`*

The ERC-721 AssetProxy identifier, the address of the ERC-721 contract hosting this asset, and the identifier of the specific asset to be traded.

___

###  decodeExchangeInvalidContextError

▸ **decodeExchangeInvalidContextError**(`encoded`: string): *`ContractFunctionObj<[number, string, string]>`*

*Defined in [abi-gen-wrappers/src/generated-wrappers/dev_utils.ts:1716](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/dev_utils.ts#L1716)*

Decompose an ABI-encoded OrderStatusError.

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`encoded` | string | ABI-encoded revert error. |

**Returns:** *`ContractFunctionObj<[number, string, string]>`*

errorCode Error code that corresponds to invalid maker, taker, or sender.orderHash The order hash.contextAddress The maker, taker, or sender address

___

###  decodeFillError

▸ **decodeFillError**(`encoded`: string): *`ContractFunctionObj<[number, string]>`*

*Defined in [abi-gen-wrappers/src/generated-wrappers/dev_utils.ts:1741](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/dev_utils.ts#L1741)*

Decompose an ABI-encoded FillError.

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`encoded` | string | ABI-encoded revert error. |

**Returns:** *`ContractFunctionObj<[number, string]>`*

errorCode The error code.orderHash The order hash.

___

###  decodeIncompleteFillError

▸ **decodeIncompleteFillError**(`encoded`: string): *`ContractFunctionObj<[number, BigNumber, BigNumber]>`*

*Defined in [abi-gen-wrappers/src/generated-wrappers/dev_utils.ts:1763](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/dev_utils.ts#L1763)*

Decompose an ABI-encoded IncompleteFillError.

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`encoded` | string | ABI-encoded revert error. |

**Returns:** *`ContractFunctionObj<[number, BigNumber, BigNumber]>`*

orderHash Hash of the order being filled.

___

###  decodeMultiAssetData

▸ **decodeMultiAssetData**(`assetData`: string): *`ContractFunctionObj<[string, BigNumber[], string[]]>`*

*Defined in [abi-gen-wrappers/src/generated-wrappers/dev_utils.ts:1788](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/dev_utils.ts#L1788)*

Decode multi-asset data from the format described in the AssetProxy contract specification.

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`assetData` | string | AssetProxy-compliant data describing a multi-asset basket. |

**Returns:** *`ContractFunctionObj<[string, BigNumber[], string[]]>`*

The Multi-Asset AssetProxy identifier, an array of the amounts of the assets to be traded, and an array of the AssetProxy-compliant data describing each asset to be traded.  Each element of the arrays corresponds to the same-indexed element of the other array.

___

###  decodeNegativeSpreadError

▸ **decodeNegativeSpreadError**(`encoded`: string): *`ContractFunctionObj<[string, string]>`*

*Defined in [abi-gen-wrappers/src/generated-wrappers/dev_utils.ts:1813](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/dev_utils.ts#L1813)*

Decompose an ABI-encoded NegativeSpreadError.

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`encoded` | string | ABI-encoded revert error. |

**Returns:** *`ContractFunctionObj<[string, string]>`*

leftOrderHash Hash of the left order being matched.rightOrderHash Hash of the right order being matched.

___

###  decodeOrderEpochError

▸ **decodeOrderEpochError**(`encoded`: string): *`ContractFunctionObj<[string, string, BigNumber]>`*

*Defined in [abi-gen-wrappers/src/generated-wrappers/dev_utils.ts:1835](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/dev_utils.ts#L1835)*

Decompose an ABI-encoded OrderEpochError.

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`encoded` | string | ABI-encoded revert error. |

**Returns:** *`ContractFunctionObj<[string, string, BigNumber]>`*

makerAddress The order maker.orderSenderAddress The order sender.currentEpoch The current epoch for the maker.

___

###  decodeOrderStatusError

▸ **decodeOrderStatusError**(`encoded`: string): *`ContractFunctionObj<[string, number]>`*

*Defined in [abi-gen-wrappers/src/generated-wrappers/dev_utils.ts:1860](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/dev_utils.ts#L1860)*

Decompose an ABI-encoded OrderStatusError.

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`encoded` | string | ABI-encoded revert error. |

**Returns:** *`ContractFunctionObj<[string, number]>`*

orderHash The order hash.orderStatus The order status.

___

###  decodeSignatureError

▸ **decodeSignatureError**(`encoded`: string): *`ContractFunctionObj<[number, string, string, string]>`*

*Defined in [abi-gen-wrappers/src/generated-wrappers/dev_utils.ts:1882](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/dev_utils.ts#L1882)*

Decompose an ABI-encoded SignatureError.

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`encoded` | string | ABI-encoded revert error. |

**Returns:** *`ContractFunctionObj<[number, string, string, string]>`*

errorCode The error code.signerAddress The expected signer of the hash.signature The full signature.

___

###  decodeSignatureValidatorNotApprovedError

▸ **decodeSignatureValidatorNotApprovedError**(`encoded`: string): *`ContractFunctionObj<[string, string]>`*

*Defined in [abi-gen-wrappers/src/generated-wrappers/dev_utils.ts:1907](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/dev_utils.ts#L1907)*

Decompose an ABI-encoded SignatureValidatorNotApprovedError.

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`encoded` | string | ABI-encoded revert error. |

**Returns:** *`ContractFunctionObj<[string, string]>`*

signerAddress The expected signer of the hash.validatorAddress The expected validator.

___

###  decodeSignatureWalletError

▸ **decodeSignatureWalletError**(`encoded`: string): *`ContractFunctionObj<[string, string, string, string]>`*

*Defined in [abi-gen-wrappers/src/generated-wrappers/dev_utils.ts:1929](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/dev_utils.ts#L1929)*

Decompose an ABI-encoded SignatureWalletError.

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`encoded` | string | ABI-encoded revert error. |

**Returns:** *`ContractFunctionObj<[string, string, string, string]>`*

errorCode The error code.signerAddress The expected signer of the hash.signature The full signature bytes.errorData The revert data thrown by the validator contract.

___

###  decodeStaticCallAssetData

▸ **decodeStaticCallAssetData**(`assetData`: string): *`ContractFunctionObj<[string, string, string, string]>`*

*Defined in [abi-gen-wrappers/src/generated-wrappers/dev_utils.ts:1955](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/dev_utils.ts#L1955)*

Decode StaticCall asset data from the format described in the AssetProxy contract specification.

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`assetData` | string | AssetProxy-compliant asset data describing a StaticCall     asset |

**Returns:** *`ContractFunctionObj<[string, string, string, string]>`*

The StaticCall AssetProxy identifier, the target address of the StaticCAll, the data to be passed to the target address, and the expected Keccak-256 hash of the static call return data.

___

###  decodeTransactionError

▸ **decodeTransactionError**(`encoded`: string): *`ContractFunctionObj<[number, string]>`*

*Defined in [abi-gen-wrappers/src/generated-wrappers/dev_utils.ts:1980](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/dev_utils.ts#L1980)*

Decompose an ABI-encoded TransactionError.

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`encoded` | string | ABI-encoded revert error. |

**Returns:** *`ContractFunctionObj<[number, string]>`*

errorCode The error code.transactionHash Hash of the transaction.

___

###  decodeTransactionExecutionError

▸ **decodeTransactionExecutionError**(`encoded`: string): *`ContractFunctionObj<[string, string]>`*

*Defined in [abi-gen-wrappers/src/generated-wrappers/dev_utils.ts:2002](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/dev_utils.ts#L2002)*

Decompose an ABI-encoded TransactionExecutionError.

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`encoded` | string | ABI-encoded revert error. |

**Returns:** *`ContractFunctionObj<[string, string]>`*

transactionHash Hash of the transaction.errorData Error thrown by exeucteTransaction().

___

###  decodeZeroExTransactionData

▸ **decodeZeroExTransactionData**(`transactionData`: string): *`ContractFunctionObj<[string, Array<object>, BigNumber[], string[]]>`*

*Defined in [abi-gen-wrappers/src/generated-wrappers/dev_utils.ts:2025](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/dev_utils.ts#L2025)*

Decodes the call data for an Exchange contract method call.

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`transactionData` | string | ABI-encoded calldata for an Exchange     contract     method call. |

**Returns:** *`ContractFunctionObj<[string, Array<object>, BigNumber[], string[]]>`*

The name of the function called, and the parameters it was     given.  For single-order fills and cancels, the arrays will have     just one element.

___

###  encodeERC1155AssetData

▸ **encodeERC1155AssetData**(`tokenAddress`: string, `tokenIds`: `BigNumber`[], `tokenValues`: `BigNumber`[], `callbackData`: string): *`ContractFunctionObj<string>`*

*Defined in [abi-gen-wrappers/src/generated-wrappers/dev_utils.ts:2123](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/dev_utils.ts#L2123)*

Encode ERC-1155 asset data into the format described in the AssetProxy contract specification.

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`tokenAddress` | string | The address of the ERC-1155 contract hosting the     asset(s) to be traded. |
`tokenIds` | `BigNumber`[] | The identifiers of the specific assets to be traded. |
`tokenValues` | `BigNumber`[] | The amounts of each asset to be traded. |
`callbackData` | string | Data to be passed to receiving contracts when a transfer     is performed. |

**Returns:** *`ContractFunctionObj<string>`*

AssetProxy-compliant asset data describing the set of assets.

___

###  encodeERC20AssetData

▸ **encodeERC20AssetData**(`tokenAddress`: string): *`ContractFunctionObj<string>`*

*Defined in [abi-gen-wrappers/src/generated-wrappers/dev_utils.ts:2159](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/dev_utils.ts#L2159)*

Encode ERC-20 asset data into the format described in the AssetProxy contract specification.

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`tokenAddress` | string | The address of the ERC-20 contract hosting the asset to     be traded. |

**Returns:** *`ContractFunctionObj<string>`*

AssetProxy-compliant data describing the asset.

___

###  encodeERC721AssetData

▸ **encodeERC721AssetData**(`tokenAddress`: string, `tokenId`: `BigNumber`): *`ContractFunctionObj<string>`*

*Defined in [abi-gen-wrappers/src/generated-wrappers/dev_utils.ts:2183](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/dev_utils.ts#L2183)*

Encode ERC-721 asset data into the format described in the AssetProxy specification.

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`tokenAddress` | string | The address of the ERC-721 contract hosting the asset to     be traded. |
`tokenId` | `BigNumber` | The identifier of the specific asset to be traded. |

**Returns:** *`ContractFunctionObj<string>`*

AssetProxy-compliant asset data describing the asset.

___

###  encodeMultiAssetData

▸ **encodeMultiAssetData**(`amounts`: `BigNumber`[], `nestedAssetData`: string[]): *`ContractFunctionObj<string>`*

*Defined in [abi-gen-wrappers/src/generated-wrappers/dev_utils.ts:2208](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/dev_utils.ts#L2208)*

Encode data for multiple assets, per the AssetProxy contract specification.

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`amounts` | `BigNumber`[] | The amounts of each asset to be traded. |
`nestedAssetData` | string[] | AssetProxy-compliant data describing each asset to be     traded. |

**Returns:** *`ContractFunctionObj<string>`*

AssetProxy-compliant data describing the set of assets.

___

###  encodeStaticCallAssetData

▸ **encodeStaticCallAssetData**(`staticCallTargetAddress`: string, `staticCallData`: string, `expectedReturnDataHash`: string): *`ContractFunctionObj<string>`*

*Defined in [abi-gen-wrappers/src/generated-wrappers/dev_utils.ts:2235](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/dev_utils.ts#L2235)*

Encode StaticCall asset data into the format described in the AssetProxy contract specification.

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`staticCallTargetAddress` | string | Target address of StaticCall. |
`staticCallData` | string | Data that will be passed to staticCallTargetAddress in     the StaticCall. |
`expectedReturnDataHash` | string | Expected Keccak-256 hash of the StaticCall     return data. |

**Returns:** *`ContractFunctionObj<string>`*

AssetProxy-compliant asset data describing the set of assets.

___

###  getABIDecodedReturnData

▸ **getABIDecodedReturnData**<**T**>(`methodName`: string, `callData`: string): *`T`*

*Defined in [abi-gen-wrappers/src/generated-wrappers/dev_utils.ts:1499](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/dev_utils.ts#L1499)*

**Type parameters:**

▪ **T**

**Parameters:**

Name | Type |
------ | ------ |
`methodName` | string |
`callData` | string |

**Returns:** *`T`*

___

###  getABIDecodedTransactionData

▸ **getABIDecodedTransactionData**<**T**>(`methodName`: string, `callData`: string): *`T`*

*Defined in [abi-gen-wrappers/src/generated-wrappers/dev_utils.ts:1492](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/dev_utils.ts#L1492)*

**Type parameters:**

▪ **T**

**Parameters:**

Name | Type |
------ | ------ |
`methodName` | string |
`callData` | string |

**Returns:** *`T`*

___

###  getAssetProxyAllowance

▸ **getAssetProxyAllowance**(`ownerAddress`: string, `assetData`: string): *`ContractFunctionObj<BigNumber>`*

*Defined in [abi-gen-wrappers/src/generated-wrappers/dev_utils.ts:2269](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/dev_utils.ts#L2269)*

Returns the number of asset(s) (described by assetData) that the corresponding AssetProxy contract is authorized to spend.  When the asset data contains multiple assets (eg for Multi-Asset), the return value indicates how many complete "baskets" of those assets may be spent by all of the corresponding AssetProxy contracts.

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`ownerAddress` | string | Owner of the assets specified by assetData. |
`assetData` | string | Details of asset, encoded per the AssetProxy contract     specification. |

**Returns:** *`ContractFunctionObj<BigNumber>`*

Number of assets (or asset baskets) that the corresponding AssetProxy is authorized to spend.

___

###  getBalance

▸ **getBalance**(`ownerAddress`: string, `assetData`: string): *`ContractFunctionObj<BigNumber>`*

*Defined in [abi-gen-wrappers/src/generated-wrappers/dev_utils.ts:2297](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/dev_utils.ts#L2297)*

Returns the owner's balance of the assets(s) specified in assetData.  When the asset data contains multiple assets (eg in ERC1155 or Multi-Asset), the return value indicates how many complete "baskets" of those assets are owned by owner.

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`ownerAddress` | string | Owner of the assets specified by assetData. |
`assetData` | string | Details of asset, encoded per the AssetProxy contract     specification. |

**Returns:** *`ContractFunctionObj<BigNumber>`*

Number of assets (or asset baskets) held by owner.

___

###  getBalanceAndAssetProxyAllowance

▸ **getBalanceAndAssetProxyAllowance**(`ownerAddress`: string, `assetData`: string): *`ContractFunctionObj<[BigNumber, BigNumber]>`*

*Defined in [abi-gen-wrappers/src/generated-wrappers/dev_utils.ts:2325](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/dev_utils.ts#L2325)*

Calls getBalance() and getAllowance() for assetData.

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`ownerAddress` | string | Owner of the assets specified by assetData. |
`assetData` | string | Details of asset, encoded per the AssetProxy contract     specification. |

**Returns:** *`ContractFunctionObj<[BigNumber, BigNumber]>`*

Number of assets (or asset baskets) held by owner, and number of assets (or asset baskets) that the corresponding AssetProxy is authorized to spend.

___

###  getBatchAssetProxyAllowances

▸ **getBatchAssetProxyAllowances**(`ownerAddress`: string, `assetData`: string[]): *`ContractFunctionObj<BigNumber[]>`*

*Defined in [abi-gen-wrappers/src/generated-wrappers/dev_utils.ts:2359](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/dev_utils.ts#L2359)*

Calls getAssetProxyAllowance() for each element of assetData.

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`ownerAddress` | string | Owner of the assets specified by assetData. |
`assetData` | string[] | Array of asset details, each encoded per the AssetProxy     contract specification. |

**Returns:** *`ContractFunctionObj<BigNumber[]>`*

An array of asset allowances from getAllowance(), with each element corresponding to the same-indexed element in the assetData input.

___

###  getBatchBalances

▸ **getBatchBalances**(`ownerAddress`: string, `assetData`: string[]): *`ContractFunctionObj<BigNumber[]>`*

*Defined in [abi-gen-wrappers/src/generated-wrappers/dev_utils.ts:2387](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/dev_utils.ts#L2387)*

Calls getBalance() for each element of assetData.

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`ownerAddress` | string | Owner of the assets specified by assetData. |
`assetData` | string[] | Array of asset details, each encoded per the AssetProxy     contract specification. |

**Returns:** *`ContractFunctionObj<BigNumber[]>`*

Array of asset balances from getBalance(), with each element corresponding to the same-indexed element in the assetData input.

___

###  getBatchBalancesAndAssetProxyAllowances

▸ **getBatchBalancesAndAssetProxyAllowances**(`ownerAddress`: string, `assetData`: string[]): *`ContractFunctionObj<[BigNumber[], BigNumber[]]>`*

*Defined in [abi-gen-wrappers/src/generated-wrappers/dev_utils.ts:2415](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/dev_utils.ts#L2415)*

Calls getBatchBalances() and getBatchAllowances() for each element of assetData.

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`ownerAddress` | string | Owner of the assets specified by assetData. |
`assetData` | string[] | Array of asset details, each encoded per the AssetProxy     contract specification. |

**Returns:** *`ContractFunctionObj<[BigNumber[], BigNumber[]]>`*

An array of asset balances from getBalance(), and an array of asset allowances from getAllowance(), with each element corresponding to the same-indexed element in the assetData input.

___

###  getEthBalances

▸ **getEthBalances**(`addresses`: string[]): *`ContractFunctionObj<BigNumber[]>`*

*Defined in [abi-gen-wrappers/src/generated-wrappers/dev_utils.ts:2447](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/dev_utils.ts#L2447)*

Batch fetches ETH balances

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`addresses` | string[] | Array of addresses. |

**Returns:** *`ContractFunctionObj<BigNumber[]>`*

Array of ETH balances.

___

###  getFunctionSignature

▸ **getFunctionSignature**(`methodName`: string): *string*

*Defined in [abi-gen-wrappers/src/generated-wrappers/dev_utils.ts:1486](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/dev_utils.ts#L1486)*

**Parameters:**

Name | Type |
------ | ------ |
`methodName` | string |

**Returns:** *string*

___

###  getOrderRelevantState

▸ **getOrderRelevantState**(`order`: object, `signature`: string): *`ContractFunctionObj<[object, BigNumber, boolean]>`*

*Defined in [abi-gen-wrappers/src/generated-wrappers/dev_utils.ts:2475](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/dev_utils.ts#L2475)*

Fetches all order-relevant information needed to validate if the supplied order is fillable.

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`order` | object | The order structure. |
`signature` | string | Signature provided by maker that proves the order's     authenticity. `0x01` can always be provided if the signature does not     need to be validated. |

**Returns:** *`ContractFunctionObj<[object, BigNumber, boolean]>`*

The orderInfo (hash, status, and &#x60;takerAssetAmount&#x60; already filled for the given order), fillableTakerAssetAmount (amount of the order&#x27;s &#x60;takerAssetAmount&#x60; that is fillable given all on-chain state), and isValidSignature (validity of the provided signature). NOTE: If the &#x60;takerAssetData&#x60; encodes data for multiple assets, &#x60;fillableTakerAssetAmount&#x60; will represent a &quot;scaled&quot; amount, meaning it must be multiplied by all the individual asset amounts within the &#x60;takerAssetData&#x60; to get the final amount of each asset that can be filled.

___

###  getOrderRelevantStates

▸ **getOrderRelevantStates**(`orders`: `Array<object>`, `signatures`: string[]): *`ContractFunctionObj<[Array<object>, BigNumber[], boolean[]]>`*

*Defined in [abi-gen-wrappers/src/generated-wrappers/dev_utils.ts:2536](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/dev_utils.ts#L2536)*

Fetches all order-relevant information needed to validate if the supplied orders are fillable.

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`orders` | `Array<object>` | Array of order structures. |
`signatures` | string[] | Array of signatures provided by makers that prove the     authenticity of the orders. `0x01` can always be provided if a signature     does not need to be validated. |

**Returns:** *`ContractFunctionObj<[Array<object>, BigNumber[], boolean[]]>`*

The ordersInfo (array of the hash, status, and &#x60;takerAssetAmount&#x60; already filled for each order), fillableTakerAssetAmounts (array of amounts for each order&#x27;s &#x60;takerAssetAmount&#x60; that is fillable given all on-chain state), and isValidSignature (array containing the validity of each provided signature). NOTE: If the &#x60;takerAssetData&#x60; encodes data for multiple assets, each element of &#x60;fillableTakerAssetAmounts&#x60; will represent a &quot;scaled&quot; amount, meaning it must be multiplied by all the individual asset amounts within the &#x60;takerAssetData&#x60; to get the final amount of each asset that can be filled.

___

###  getSelector

▸ **getSelector**(`methodName`: string): *string*

*Defined in [abi-gen-wrappers/src/generated-wrappers/dev_utils.ts:1506](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/dev_utils.ts#L1506)*

**Parameters:**

Name | Type |
------ | ------ |
`methodName` | string |

**Returns:** *string*

___

###  getSimulatedOrderTransferResults

▸ **getSimulatedOrderTransferResults**(`order`: object, `takerAddress`: string, `takerAssetFillAmount`: `BigNumber`): *`ContractTxFunctionObj<number>`*

*Defined in [abi-gen-wrappers/src/generated-wrappers/dev_utils.ts:2605](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/dev_utils.ts#L2605)*

Simulates all of the transfers within an order and returns the index of the first failed transfer.

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`order` | object | The order to simulate transfers for. |
`takerAddress` | string | The address of the taker that will fill the order. |
`takerAssetFillAmount` | `BigNumber` | The amount of takerAsset that the taker wished     to fill. |

**Returns:** *`ContractTxFunctionObj<number>`*

The index of the first failed transfer (or 4 if all transfers are successful).

___

###  getSimulatedOrdersTransferResults

▸ **getSimulatedOrdersTransferResults**(`orders`: `Array<object>`, `takerAddresses`: string[], `takerAssetFillAmounts`: `BigNumber`[]): *`ContractTxFunctionObj<number[]>`*

*Defined in [abi-gen-wrappers/src/generated-wrappers/dev_utils.ts:2686](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/dev_utils.ts#L2686)*

Simulates all of the transfers for each given order and returns the indices of each first failed transfer.

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`orders` | `Array<object>` | Array of orders to individually simulate transfers for. |
`takerAddresses` | string[] | Array of addresses of takers that will fill each     order. |
`takerAssetFillAmounts` | `BigNumber`[] | Array of amounts of takerAsset that will be     filled for each order. |

**Returns:** *`ContractTxFunctionObj<number[]>`*

The indices of the first failed transfer (or 4 if all transfers are successful) for each order.

___

###  getTransferableAssetAmount

▸ **getTransferableAssetAmount**(`ownerAddress`: string, `assetData`: string): *`ContractFunctionObj<BigNumber>`*

*Defined in [abi-gen-wrappers/src/generated-wrappers/dev_utils.ts:2761](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/dev_utils.ts#L2761)*

Gets the amount of an asset transferable by the owner.

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`ownerAddress` | string | Address of the owner of the asset. |
`assetData` | string | Description of tokens, per the AssetProxy contract     specification. |

**Returns:** *`ContractFunctionObj<BigNumber>`*

The amount of the asset tranferable by the owner. NOTE: If the &#x60;assetData&#x60; encodes data for multiple assets, the &#x60;transferableAssetAmount&#x60; will represent the amount of times the entire &#x60;assetData&#x60; can be transferred. To calculate the total individual transferable amounts, this scaled &#x60;transferableAmount&#x60; must be multiplied by the individual asset amounts located within the &#x60;assetData&#x60;.

___

###  revertIfInvalidAssetData

▸ **revertIfInvalidAssetData**(`assetData`: string): *`ContractFunctionObj<void>`*

*Defined in [abi-gen-wrappers/src/generated-wrappers/dev_utils.ts:2782](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/dev_utils.ts#L2782)*

**Parameters:**

Name | Type |
------ | ------ |
`assetData` | string |

**Returns:** *`ContractFunctionObj<void>`*

___

### `Static` ABI

▸ **ABI**(): *[ContractAbi](#contractabi)*

*Defined in [abi-gen-wrappers/src/generated-wrappers/dev_utils.ts:127](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/dev_utils.ts#L127)*

**Returns:** *[ContractAbi](#contractabi)*

The contract ABI

___

### `Static` deployAsync

▸ **deployAsync**(`bytecode`: string, `abi`: [ContractAbi](#contractabi), `supportedProvider`: [SupportedProvider](#supportedprovider), `txDefaults`: `Partial<TxData>`, `logDecodeDependencies`: object, `_exchange`: string): *`Promise<DevUtilsContract>`*

*Defined in [abi-gen-wrappers/src/generated-wrappers/dev_utils.ts:78](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/dev_utils.ts#L78)*

**Parameters:**

Name | Type |
------ | ------ |
`bytecode` | string |
`abi` | [ContractAbi](#contractabi) |
`supportedProvider` | [SupportedProvider](#supportedprovider) |
`txDefaults` | `Partial<TxData>` |
`logDecodeDependencies` | object |
`_exchange` | string |

**Returns:** *`Promise<DevUtilsContract>`*

___

### `Static` deployFrom0xArtifactAsync

▸ **deployFrom0xArtifactAsync**(`artifact`: `ContractArtifact` | `SimpleContractArtifact`, `supportedProvider`: [SupportedProvider](#supportedprovider), `txDefaults`: `Partial<TxData>`, `logDecodeDependencies`: object, `_exchange`: string): *`Promise<DevUtilsContract>`*

*Defined in [abi-gen-wrappers/src/generated-wrappers/dev_utils.ts:45](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/dev_utils.ts#L45)*

**Parameters:**

Name | Type |
------ | ------ |
`artifact` | `ContractArtifact` \| `SimpleContractArtifact` |
`supportedProvider` | [SupportedProvider](#supportedprovider) |
`txDefaults` | `Partial<TxData>` |
`logDecodeDependencies` | object |
`_exchange` | string |

**Returns:** *`Promise<DevUtilsContract>`*

___

### `Static` strictArgumentEncodingCheck

▸ **strictArgumentEncodingCheck**(`inputAbi`: `DataItem`[], `args`: any[]): *string*



Defined in base-contract/lib/src/index.d.ts:42

**Parameters:**

Name | Type |
------ | ------ |
`inputAbi` | `DataItem`[] |
`args` | any[] |

**Returns:** *string*

<hr />

# Class: ERC20TokenContract


##   Constructors



\+ **new ERC20TokenContract**(`address`: string, `supportedProvider`: [SupportedProvider](#supportedprovider), `txDefaults?`: `Partial<TxData>`, `logDecodeDependencies?`: undefined | object, `deployedBytecode`: string | undefined): *[ERC20TokenContract](#class-erc20tokencontract)*

*Overrides void*

*Defined in [abi-gen-wrappers/src/generated-wrappers/erc20_token.ts:641](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/erc20_token.ts#L641)*

**Parameters:**

Name | Type | Default |
------ | ------ | ------ |
`address` | string | - |
`supportedProvider` | [SupportedProvider](#supportedprovider) | - |
`txDefaults?` | `Partial<TxData>` | - |
`logDecodeDependencies?` | undefined \| object | - |
`deployedBytecode` | string \| undefined |  ERC20TokenContract.deployedBytecode |

**Returns:** *[ERC20TokenContract](#class-erc20tokencontract)*

## Properties

### `Optional` _deployedBytecodeIfExists

• **_deployedBytecodeIfExists**? : *`Buffer`*



Defined in base-contract/lib/src/index.d.ts:33

___

###  abi

• **abi**: *[ContractAbi](#contractabi)*



Defined in base-contract/lib/src/index.d.ts:29

___

###  address

• **address**: *string*



Defined in base-contract/lib/src/index.d.ts:30

___

Args

• **constructorArgs**: *any[]*



Defined in base-contract/lib/src/index.d.ts:32

___

###  contractName

• **contractName**: *string*



Defined in base-contract/lib/src/index.d.ts:31

## Methods

###  allowance

▸ **allowance**(`_owner`: string, `_spender`: string): *`ContractFunctionObj<BigNumber>`*

*Defined in [abi-gen-wrappers/src/generated-wrappers/erc20_token.ts:552](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/erc20_token.ts#L552)*

**Parameters:**

Name | Type |
------ | ------ |
`_owner` | string |
`_spender` | string |

**Returns:** *`ContractFunctionObj<BigNumber>`*

___

###  approve

▸ **approve**(`_spender`: string, `_value`: `BigNumber`): *`ContractTxFunctionObj<boolean>`*

*Defined in [abi-gen-wrappers/src/generated-wrappers/erc20_token.ts:349](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/erc20_token.ts#L349)*

`msg.sender` approves `_spender` to spend `_value` tokens

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`_spender` | string | The address of the account able to transfer the tokens |
`_value` | `BigNumber` | The amount of wei to be approved for transfer |

**Returns:** *`ContractTxFunctionObj<boolean>`*

Always true if the call has enough gas to complete execution

___

###  balanceOf

▸ **balanceOf**(`_owner`: string): *`ContractFunctionObj<BigNumber>`*

*Defined in [abi-gen-wrappers/src/generated-wrappers/erc20_token.ts:479](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/erc20_token.ts#L479)*

Query the balance of owner

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`_owner` | string | The address from which the balance will be retrieved |

**Returns:** *`ContractFunctionObj<BigNumber>`*

Balance of owner

___

###  getABIDecodedReturnData

▸ **getABIDecodedReturnData**<**T**>(`methodName`: string, `callData`: string): *`T`*

*Defined in [abi-gen-wrappers/src/generated-wrappers/erc20_token.ts:329](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/erc20_token.ts#L329)*

**Type parameters:**

▪ **T**

**Parameters:**

Name | Type |
------ | ------ |
`methodName` | string |
`callData` | string |

**Returns:** *`T`*

___

###  getABIDecodedTransactionData

▸ **getABIDecodedTransactionData**<**T**>(`methodName`: string, `callData`: string): *`T`*

*Defined in [abi-gen-wrappers/src/generated-wrappers/erc20_token.ts:322](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/erc20_token.ts#L322)*

**Type parameters:**

▪ **T**

**Parameters:**

Name | Type |
------ | ------ |
`methodName` | string |
`callData` | string |

**Returns:** *`T`*

___

###  getFunctionSignature

▸ **getFunctionSignature**(`methodName`: string): *string*

*Defined in [abi-gen-wrappers/src/generated-wrappers/erc20_token.ts:316](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/erc20_token.ts#L316)*

**Parameters:**

Name | Type |
------ | ------ |
`methodName` | string |

**Returns:** *string*

___

###  getLogsAsync

▸ **getLogsAsync**<**ArgsType**>(`eventName`: [ERC20TokenEvents](#enumeration-erc20tokenevents), `blockRange`: `BlockRange`, `indexFilterValues`: `IndexedFilterValues`): *`Promise<Array<LogWithDecodedArgs<ArgsType>>>`*

*Defined in [abi-gen-wrappers/src/generated-wrappers/erc20_token.ts:625](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/erc20_token.ts#L625)*

Gets historical logs without creating a subscription

**Type parameters:**

▪ **ArgsType**: *[ERC20TokenEventArgs](#erc20tokeneventargs)*

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`eventName` | [ERC20TokenEvents](#enumeration-erc20tokenevents) | The ERC20Token contract event you would like to subscribe to. |
`blockRange` | `BlockRange` | Block range to get logs from. |
`indexFilterValues` | `IndexedFilterValues` | An object where the keys are indexed args returned by the event and the value is the value you are interested in. E.g `{_from: aUserAddressHex}` |

**Returns:** *`Promise<Array<LogWithDecodedArgs<ArgsType>>>`*

Array of logs that match the parameters

___

###  getSelector

▸ **getSelector**(`methodName`: string): *string*

*Defined in [abi-gen-wrappers/src/generated-wrappers/erc20_token.ts:336](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/erc20_token.ts#L336)*

**Parameters:**

Name | Type |
------ | ------ |
`methodName` | string |

**Returns:** *string*

___

###  subscribe

▸ **subscribe**<**ArgsType**>(`eventName`: [ERC20TokenEvents](#enumeration-erc20tokenevents), `indexFilterValues`: `IndexedFilterValues`, `callback`: [EventCallback](#eventcallback)‹*`ArgsType`*›, `isVerbose`: boolean, `blockPollingIntervalMs?`: undefined | number): *string*

*Defined in [abi-gen-wrappers/src/generated-wrappers/erc20_token.ts:583](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/erc20_token.ts#L583)*

Subscribe to an event type emitted by the ERC20Token contract.

**Type parameters:**

▪ **ArgsType**: *[ERC20TokenEventArgs](#erc20tokeneventargs)*

**Parameters:**

Name | Type | Default | Description |
------ | ------ | ------ | ------ |
`eventName` | [ERC20TokenEvents](#enumeration-erc20tokenevents) | - | The ERC20Token contract event you would like to subscribe to. |
`indexFilterValues` | `IndexedFilterValues` | - | An object where the keys are indexed args returned by the event and the value is the value you are interested in. E.g `{maker: aUserAddressHex}` |
`callback` | [EventCallback](#eventcallback)‹*`ArgsType`*› | - | Callback that gets called when a log is added/removed |
`isVerbose` | boolean | false | Enable verbose subscription warnings (e.g recoverable network issues encountered) |
`blockPollingIntervalMs?` | undefined \| number | - | - |

**Returns:** *string*

Subscription token used later to unsubscribe

___

###  totalSupply

▸ **totalSupply**(): *`ContractFunctionObj<BigNumber>`*

*Defined in [abi-gen-wrappers/src/generated-wrappers/erc20_token.ts:400](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/erc20_token.ts#L400)*

Query total supply of token

**Returns:** *`ContractFunctionObj<BigNumber>`*

Total supply of token

___

###  transfer

▸ **transfer**(`_to`: string, `_value`: `BigNumber`): *`ContractTxFunctionObj<boolean>`*

*Defined in [abi-gen-wrappers/src/generated-wrappers/erc20_token.ts:505](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/erc20_token.ts#L505)*

send `value` token to `to` from `msg.sender`

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`_to` | string | The address of the recipient |
`_value` | `BigNumber` | The amount of token to be transferred |

**Returns:** *`ContractTxFunctionObj<boolean>`*

True if transfer was successful

___

###  transferFrom

▸ **transferFrom**(`_from`: string, `_to`: string, `_value`: `BigNumber`): *`ContractTxFunctionObj<boolean>`*

*Defined in [abi-gen-wrappers/src/generated-wrappers/erc20_token.ts:426](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/erc20_token.ts#L426)*

send `value` token to `to` from `from` on the condition it is approved by `from`

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`_from` | string | The address of the sender |
`_to` | string | The address of the recipient |
`_value` | `BigNumber` | The amount of token to be transferred |

**Returns:** *`ContractTxFunctionObj<boolean>`*

True if transfer was successful

___

###  unsubscribe

▸ **unsubscribe**(`subscriptionToken`: string): *void*

*Defined in [abi-gen-wrappers/src/generated-wrappers/erc20_token.ts:608](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/erc20_token.ts#L608)*

Cancel a subscription

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`subscriptionToken` | string | Subscription token returned by `subscribe()`  |

**Returns:** *void*

___

###  unsubscribeAll

▸ **unsubscribeAll**(): *void*

*Defined in [abi-gen-wrappers/src/generated-wrappers/erc20_token.ts:614](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/erc20_token.ts#L614)*

Cancels all existing subscriptions

**Returns:** *void*

___

### `Static` ABI

▸ **ABI**(): *[ContractAbi](#contractabi)*

*Defined in [abi-gen-wrappers/src/generated-wrappers/erc20_token.ts:135](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/erc20_token.ts#L135)*

**Returns:** *[ContractAbi](#contractabi)*

The contract ABI

___

### `Static` deployAsync

▸ **deployAsync**(`bytecode`: string, `abi`: [ContractAbi](#contractabi), `supportedProvider`: [SupportedProvider](#supportedprovider), `txDefaults`: `Partial<TxData>`, `logDecodeDependencies`: object): *`Promise<ERC20TokenContract>`*

*Defined in [abi-gen-wrappers/src/generated-wrappers/erc20_token.ts:91](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/erc20_token.ts#L91)*

**Parameters:**

Name | Type |
------ | ------ |
`bytecode` | string |
`abi` | [ContractAbi](#contractabi) |
`supportedProvider` | [SupportedProvider](#supportedprovider) |
`txDefaults` | `Partial<TxData>` |
`logDecodeDependencies` | object |

**Returns:** *`Promise<ERC20TokenContract>`*

___

### `Static` deployFrom0xArtifactAsync

▸ **deployFrom0xArtifactAsync**(`artifact`: `ContractArtifact` | `SimpleContractArtifact`, `supportedProvider`: [SupportedProvider](#supportedprovider), `txDefaults`: `Partial<TxData>`, `logDecodeDependencies`: object): *`Promise<ERC20TokenContract>`*

*Defined in [abi-gen-wrappers/src/generated-wrappers/erc20_token.ts:66](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/erc20_token.ts#L66)*

**Parameters:**

Name | Type |
------ | ------ |
`artifact` | `ContractArtifact` \| `SimpleContractArtifact` |
`supportedProvider` | [SupportedProvider](#supportedprovider) |
`txDefaults` | `Partial<TxData>` |
`logDecodeDependencies` | object |

**Returns:** *`Promise<ERC20TokenContract>`*

___

### `Static` strictArgumentEncodingCheck

▸ **strictArgumentEncodingCheck**(`inputAbi`: `DataItem`[], `args`: any[]): *string*



Defined in base-contract/lib/src/index.d.ts:42

**Parameters:**

Name | Type |
------ | ------ |
`inputAbi` | `DataItem`[] |
`args` | any[] |

**Returns:** *string*

<hr />

# Class: ERC721TokenContract


##   Constructors



\+ **new ERC721TokenContract**(`address`: string, `supportedProvider`: [SupportedProvider](#supportedprovider), `txDefaults?`: `Partial<TxData>`, `logDecodeDependencies?`: undefined | object, `deployedBytecode`: string | undefined): *[ERC721TokenContract](#class-erc721tokencontract)*

*Overrides void*

*Defined in [abi-gen-wrappers/src/generated-wrappers/erc721_token.ts:898](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/erc721_token.ts#L898)*

**Parameters:**

Name | Type | Default |
------ | ------ | ------ |
`address` | string | - |
`supportedProvider` | [SupportedProvider](#supportedprovider) | - |
`txDefaults?` | `Partial<TxData>` | - |
`logDecodeDependencies?` | undefined \| object | - |
`deployedBytecode` | string \| undefined |  ERC721TokenContract.deployedBytecode |

**Returns:** *[ERC721TokenContract](#class-erc721tokencontract)*

## Properties

### `Optional` _deployedBytecodeIfExists

• **_deployedBytecodeIfExists**? : *`Buffer`*



Defined in base-contract/lib/src/index.d.ts:33

___

###  abi

• **abi**: *[ContractAbi](#contractabi)*



Defined in base-contract/lib/src/index.d.ts:29

___

###  address

• **address**: *string*



Defined in base-contract/lib/src/index.d.ts:30

___

Args

• **constructorArgs**: *any[]*



Defined in base-contract/lib/src/index.d.ts:32

___

###  contractName

• **contractName**: *string*



Defined in base-contract/lib/src/index.d.ts:31

## Methods

###  approve

▸ **approve**(`_approved`: string, `_tokenId`: `BigNumber`): *`ContractTxFunctionObj<void>`*

*Defined in [abi-gen-wrappers/src/generated-wrappers/erc721_token.ts:440](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/erc721_token.ts#L440)*

The zero address indicates there is no approved address.
Throws unless `msg.sender` is the current NFT owner, or an authorized
operator of the current owner.

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`_approved` | string | The new approved NFT controller |
`_tokenId` | `BigNumber` | The NFT to approve  |

**Returns:** *`ContractTxFunctionObj<void>`*

___

###  balanceOf

▸ **balanceOf**(`_owner`: string): *`ContractFunctionObj<BigNumber>`*

*Defined in [abi-gen-wrappers/src/generated-wrappers/erc721_token.ts:493](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/erc721_token.ts#L493)*

NFTs assigned to the zero address are considered invalid, and this
function throws for queries about the zero address.

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`_owner` | string | An address for whom to query the balance |

**Returns:** *`ContractFunctionObj<BigNumber>`*

The number of NFTs owned by &#x60;_owner&#x60;, possibly zero

___

###  getABIDecodedReturnData

▸ **getABIDecodedReturnData**<**T**>(`methodName`: string, `callData`: string): *`T`*

*Defined in [abi-gen-wrappers/src/generated-wrappers/erc721_token.ts:419](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/erc721_token.ts#L419)*

**Type parameters:**

▪ **T**

**Parameters:**

Name | Type |
------ | ------ |
`methodName` | string |
`callData` | string |

**Returns:** *`T`*

___

###  getABIDecodedTransactionData

▸ **getABIDecodedTransactionData**<**T**>(`methodName`: string, `callData`: string): *`T`*

*Defined in [abi-gen-wrappers/src/generated-wrappers/erc721_token.ts:412](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/erc721_token.ts#L412)*

**Type parameters:**

▪ **T**

**Parameters:**

Name | Type |
------ | ------ |
`methodName` | string |
`callData` | string |

**Returns:** *`T`*

___

###  getApproved

▸ **getApproved**(`_tokenId`: `BigNumber`): *`ContractFunctionObj<string>`*

*Defined in [abi-gen-wrappers/src/generated-wrappers/erc721_token.ts:518](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/erc721_token.ts#L518)*

Throws if `_tokenId` is not a valid NFT.

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`_tokenId` | `BigNumber` | The NFT to find the approved address for |

**Returns:** *`ContractFunctionObj<string>`*

The approved address for this NFT, or the zero address if there is none

___

###  getFunctionSignature

▸ **getFunctionSignature**(`methodName`: string): *string*

*Defined in [abi-gen-wrappers/src/generated-wrappers/erc721_token.ts:406](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/erc721_token.ts#L406)*

**Parameters:**

Name | Type |
------ | ------ |
`methodName` | string |

**Returns:** *string*

___

###  getLogsAsync

▸ **getLogsAsync**<**ArgsType**>(`eventName`: [ERC721TokenEvents](#enumeration-erc721tokenevents), `blockRange`: `BlockRange`, `indexFilterValues`: `IndexedFilterValues`): *`Promise<Array<LogWithDecodedArgs<ArgsType>>>`*

*Defined in [abi-gen-wrappers/src/generated-wrappers/erc721_token.ts:882](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/erc721_token.ts#L882)*

Gets historical logs without creating a subscription

**Type parameters:**

▪ **ArgsType**: *[ERC721TokenEventArgs](#erc721tokeneventargs)*

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`eventName` | [ERC721TokenEvents](#enumeration-erc721tokenevents) | The ERC721Token contract event you would like to subscribe to. |
`blockRange` | `BlockRange` | Block range to get logs from. |
`indexFilterValues` | `IndexedFilterValues` | An object where the keys are indexed args returned by the event and the value is the value you are interested in. E.g `{_from: aUserAddressHex}` |

**Returns:** *`Promise<Array<LogWithDecodedArgs<ArgsType>>>`*

Array of logs that match the parameters

___

###  getSelector

▸ **getSelector**(`methodName`: string): *string*

*Defined in [abi-gen-wrappers/src/generated-wrappers/erc721_token.ts:426](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/erc721_token.ts#L426)*

**Parameters:**

Name | Type |
------ | ------ |
`methodName` | string |

**Returns:** *string*

___

###  isApprovedForAll

▸ **isApprovedForAll**(`_owner`: string, `_operator`: string): *`ContractFunctionObj<boolean>`*

*Defined in [abi-gen-wrappers/src/generated-wrappers/erc721_token.ts:538](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/erc721_token.ts#L538)*

**Parameters:**

Name | Type |
------ | ------ |
`_owner` | string |
`_operator` | string |

**Returns:** *`ContractFunctionObj<boolean>`*

___

###  ownerOf

▸ **ownerOf**(`_tokenId`: `BigNumber`): *`ContractFunctionObj<string>`*

*Defined in [abi-gen-wrappers/src/generated-wrappers/erc721_token.ts:565](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/erc721_token.ts#L565)*

NFTs assigned to zero address are considered invalid, and queries
about them do throw.

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`_tokenId` | `BigNumber` | The identifier for an NFT |

**Returns:** *`ContractFunctionObj<string>`*

The address of the owner of the NFT

___

###  safeTransferFrom1

▸ **safeTransferFrom1**(`_from`: string, `_to`: string, `_tokenId`: `BigNumber`): *`ContractTxFunctionObj<void>`*

*Defined in [abi-gen-wrappers/src/generated-wrappers/erc721_token.ts:592](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/erc721_token.ts#L592)*

This works identically to the other function with an extra data parameter,
except this function just sets data to "".

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`_from` | string | The current owner of the NFT |
`_to` | string | The new owner |
`_tokenId` | `BigNumber` | The NFT to transfer  |

**Returns:** *`ContractTxFunctionObj<void>`*

___

###  safeTransferFrom2

▸ **safeTransferFrom2**(`_from`: string, `_to`: string, `_tokenId`: `BigNumber`, `_data`: string): *`ContractTxFunctionObj<void>`*

*Defined in [abi-gen-wrappers/src/generated-wrappers/erc721_token.ts:657](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/erc721_token.ts#L657)*

Throws unless `msg.sender` is the current owner, an authorized
operator, or the approved address for this NFT. Throws if `_from` is
not the current owner. Throws if `_to` is the zero address. Throws if
`_tokenId` is not a valid NFT. When transfer is complete, this function
checks if `_to` is a smart contract (code size > 0). If so, it calls
`onERC721Received` on `_to` and throws if the return value is not
`bytes4(keccak256("onERC721Received(address,address,uint256,bytes)"))`.

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`_from` | string | The current owner of the NFT |
`_to` | string | The new owner |
`_tokenId` | `BigNumber` | The NFT to transfer |
`_data` | string | Additional data with no specified format, sent in call to `_to`  |

**Returns:** *`ContractTxFunctionObj<void>`*

___

###  setApprovalForAll

▸ **setApprovalForAll**(`_operator`: string, `_approved`: boolean): *`ContractTxFunctionObj<void>`*

*Defined in [abi-gen-wrappers/src/generated-wrappers/erc721_token.ts:722](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/erc721_token.ts#L722)*

Emits the ApprovalForAll event. The contract MUST allow
multiple operators per owner.

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`_operator` | string | Address to add to the set of authorized operators |
`_approved` | boolean | True if the operator is approved, false to revoke approval  |

**Returns:** *`ContractTxFunctionObj<void>`*

___

###  subscribe

▸ **subscribe**<**ArgsType**>(`eventName`: [ERC721TokenEvents](#enumeration-erc721tokenevents), `indexFilterValues`: `IndexedFilterValues`, `callback`: [EventCallback](#eventcallback)‹*`ArgsType`*›, `isVerbose`: boolean, `blockPollingIntervalMs?`: undefined | number): *string*

*Defined in [abi-gen-wrappers/src/generated-wrappers/erc721_token.ts:840](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/erc721_token.ts#L840)*

Subscribe to an event type emitted by the ERC721Token contract.

**Type parameters:**

▪ **ArgsType**: *[ERC721TokenEventArgs](#erc721tokeneventargs)*

**Parameters:**

Name | Type | Default | Description |
------ | ------ | ------ | ------ |
`eventName` | [ERC721TokenEvents](#enumeration-erc721tokenevents) | - | The ERC721Token contract event you would like to subscribe to. |
`indexFilterValues` | `IndexedFilterValues` | - | An object where the keys are indexed args returned by the event and the value is the value you are interested in. E.g `{maker: aUserAddressHex}` |
`callback` | [EventCallback](#eventcallback)‹*`ArgsType`*› | - | Callback that gets called when a log is added/removed |
`isVerbose` | boolean | false | Enable verbose subscription warnings (e.g recoverable network issues encountered) |
`blockPollingIntervalMs?` | undefined \| number | - | - |

**Returns:** *string*

Subscription token used later to unsubscribe

___

###  transferFrom

▸ **transferFrom**(`_from`: string, `_to`: string, `_tokenId`: `BigNumber`): *`ContractTxFunctionObj<void>`*

*Defined in [abi-gen-wrappers/src/generated-wrappers/erc721_token.ts:778](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/erc721_token.ts#L778)*

Throws unless `msg.sender` is the current owner, an authorized
operator, or the approved address for this NFT. Throws if `_from` is
not the current owner. Throws if `_to` is the zero address. Throws if
`_tokenId` is not a valid NFT.

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`_from` | string | The current owner of the NFT |
`_to` | string | The new owner |
`_tokenId` | `BigNumber` | The NFT to transfer  |

**Returns:** *`ContractTxFunctionObj<void>`*

___

###  unsubscribe

▸ **unsubscribe**(`subscriptionToken`: string): *void*

*Defined in [abi-gen-wrappers/src/generated-wrappers/erc721_token.ts:865](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/erc721_token.ts#L865)*

Cancel a subscription

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`subscriptionToken` | string | Subscription token returned by `subscribe()`  |

**Returns:** *void*

___

###  unsubscribeAll

▸ **unsubscribeAll**(): *void*

*Defined in [abi-gen-wrappers/src/generated-wrappers/erc721_token.ts:871](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/erc721_token.ts#L871)*

Cancels all existing subscriptions

**Returns:** *void*

___

### `Static` ABI

▸ **ABI**(): *[ContractAbi](#contractabi)*

*Defined in [abi-gen-wrappers/src/generated-wrappers/erc721_token.ts:145](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/erc721_token.ts#L145)*

**Returns:** *[ContractAbi](#contractabi)*

The contract ABI

___

### `Static` deployAsync

▸ **deployAsync**(`bytecode`: string, `abi`: [ContractAbi](#contractabi), `supportedProvider`: [SupportedProvider](#supportedprovider), `txDefaults`: `Partial<TxData>`, `logDecodeDependencies`: object): *`Promise<ERC721TokenContract>`*

*Defined in [abi-gen-wrappers/src/generated-wrappers/erc721_token.ts:101](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/erc721_token.ts#L101)*

**Parameters:**

Name | Type |
------ | ------ |
`bytecode` | string |
`abi` | [ContractAbi](#contractabi) |
`supportedProvider` | [SupportedProvider](#supportedprovider) |
`txDefaults` | `Partial<TxData>` |
`logDecodeDependencies` | object |

**Returns:** *`Promise<ERC721TokenContract>`*

___

### `Static` deployFrom0xArtifactAsync

▸ **deployFrom0xArtifactAsync**(`artifact`: `ContractArtifact` | `SimpleContractArtifact`, `supportedProvider`: [SupportedProvider](#supportedprovider), `txDefaults`: `Partial<TxData>`, `logDecodeDependencies`: object): *`Promise<ERC721TokenContract>`*

*Defined in [abi-gen-wrappers/src/generated-wrappers/erc721_token.ts:76](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/erc721_token.ts#L76)*

**Parameters:**

Name | Type |
------ | ------ |
`artifact` | `ContractArtifact` \| `SimpleContractArtifact` |
`supportedProvider` | [SupportedProvider](#supportedprovider) |
`txDefaults` | `Partial<TxData>` |
`logDecodeDependencies` | object |

**Returns:** *`Promise<ERC721TokenContract>`*

___

### `Static` strictArgumentEncodingCheck

▸ **strictArgumentEncodingCheck**(`inputAbi`: `DataItem`[], `args`: any[]): *string*



Defined in base-contract/lib/src/index.d.ts:42

**Parameters:**

Name | Type |
------ | ------ |
`inputAbi` | `DataItem`[] |
`args` | any[] |

**Returns:** *string*

<hr />

# Class: ExchangeContract


##   Constructors



\+ **new ExchangeContract**(`address`: string, `supportedProvider`: [SupportedProvider](#supportedprovider), `txDefaults?`: `Partial<TxData>`, `logDecodeDependencies?`: undefined | object, `deployedBytecode`: string | undefined): *[ExchangeContract](#class-exchangecontract)*

*Overrides void*

*Defined in [abi-gen-wrappers/src/generated-wrappers/exchange.ts:5787](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/exchange.ts#L5787)*

**Parameters:**

Name | Type | Default |
------ | ------ | ------ |
`address` | string | - |
`supportedProvider` | [SupportedProvider](#supportedprovider) | - |
`txDefaults?` | `Partial<TxData>` | - |
`logDecodeDependencies?` | undefined \| object | - |
`deployedBytecode` | string \| undefined |  ExchangeContract.deployedBytecode |

**Returns:** *[ExchangeContract](#class-exchangecontract)*

## Properties

### `Optional` _deployedBytecodeIfExists

• **_deployedBytecodeIfExists**? : *`Buffer`*



Defined in base-contract/lib/src/index.d.ts:33

___

###  abi

• **abi**: *[ContractAbi](#contractabi)*



Defined in base-contract/lib/src/index.d.ts:29

___

###  address

• **address**: *string*



Defined in base-contract/lib/src/index.d.ts:30

___

Args

• **constructorArgs**: *any[]*



Defined in base-contract/lib/src/index.d.ts:32

___

###  contractName

• **contractName**: *string*



Defined in base-contract/lib/src/index.d.ts:31

## Methods

###  EIP1271_MAGIC_VALUE

▸ **EIP1271_MAGIC_VALUE**(): *`ContractFunctionObj<string>`*

*Defined in [abi-gen-wrappers/src/generated-wrappers/exchange.ts:3108](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/exchange.ts#L3108)*

**Returns:** *`ContractFunctionObj<string>`*

___

###  EIP712_EXCHANGE_DOMAIN_HASH

▸ **EIP712_EXCHANGE_DOMAIN_HASH**(): *`ContractFunctionObj<string>`*

*Defined in [abi-gen-wrappers/src/generated-wrappers/exchange.ts:3127](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/exchange.ts#L3127)*

**Returns:** *`ContractFunctionObj<string>`*

___

###  allowedValidators

▸ **allowedValidators**(`index_0`: string, `index_1`: string): *`ContractFunctionObj<boolean>`*

*Defined in [abi-gen-wrappers/src/generated-wrappers/exchange.ts:3146](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/exchange.ts#L3146)*

**Parameters:**

Name | Type |
------ | ------ |
`index_0` | string |
`index_1` | string |

**Returns:** *`ContractFunctionObj<boolean>`*

___

###  batchCancelOrders

▸ **batchCancelOrders**(`orders`: `Array<object>`): *`ContractTxFunctionObj<void>`*

*Defined in [abi-gen-wrappers/src/generated-wrappers/exchange.ts:3171](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/exchange.ts#L3171)*

Executes multiple calls of cancelOrder.

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`orders` | `Array<object>` | Array of order specifications.  |

**Returns:** *`ContractTxFunctionObj<void>`*

___

###  batchExecuteTransactions

▸ **batchExecuteTransactions**(`transactions`: `Array<object>`, `signatures`: string[]): *`ContractTxFunctionObj<string[]>`*

*Defined in [abi-gen-wrappers/src/generated-wrappers/exchange.ts:3242](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/exchange.ts#L3242)*

Executes a batch of Exchange method calls in the context of signer(s).

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`transactions` | `Array<object>` | Array of 0x transaction structures. |
`signatures` | string[] | Array of proofs that transactions have been signed by     signer(s). |

**Returns:** *`ContractTxFunctionObj<string[]>`*

Array containing ABI encoded return data for each of the underlying Exchange function calls.

___

###  batchFillOrKillOrders

▸ **batchFillOrKillOrders**(`orders`: `Array<object>`, `takerAssetFillAmounts`: `BigNumber`[], `signatures`: string[]): *`ContractTxFunctionObj<Array<object>>`*

*Defined in [abi-gen-wrappers/src/generated-wrappers/exchange.ts:3306](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/exchange.ts#L3306)*

Executes multiple calls of fillOrKillOrder.

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`orders` | `Array<object>` | Array of order specifications. |
`takerAssetFillAmounts` | `BigNumber`[] | Array of desired amounts of takerAsset to sell     in orders. |
`signatures` | string[] | Proofs that orders have been created by makers. |

**Returns:** *`ContractTxFunctionObj<Array<object>>`*

Array of amounts filled and fees paid by makers and taker.

___

###  batchFillOrders

▸ **batchFillOrders**(`orders`: `Array<object>`, `takerAssetFillAmounts`: `BigNumber`[], `signatures`: string[]): *`ContractTxFunctionObj<Array<object>>`*

*Defined in [abi-gen-wrappers/src/generated-wrappers/exchange.ts:3409](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/exchange.ts#L3409)*

Executes multiple calls of fillOrder.

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`orders` | `Array<object>` | Array of order specifications. |
`takerAssetFillAmounts` | `BigNumber`[] | Array of desired amounts of takerAsset to sell     in orders. |
`signatures` | string[] | Proofs that orders have been created by makers. |

**Returns:** *`ContractTxFunctionObj<Array<object>>`*

Array of amounts filled and fees paid by makers and taker.

___

###  batchFillOrdersNoThrow

▸ **batchFillOrdersNoThrow**(`orders`: `Array<object>`, `takerAssetFillAmounts`: `BigNumber`[], `signatures`: string[]): *`ContractTxFunctionObj<Array<object>>`*

*Defined in [abi-gen-wrappers/src/generated-wrappers/exchange.ts:3512](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/exchange.ts#L3512)*

Executes multiple calls of fillOrder. If any fill reverts, the error is caught and ignored.

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`orders` | `Array<object>` | Array of order specifications. |
`takerAssetFillAmounts` | `BigNumber`[] | Array of desired amounts of takerAsset to sell     in orders. |
`signatures` | string[] | Proofs that orders have been created by makers. |

**Returns:** *`ContractTxFunctionObj<Array<object>>`*

Array of amounts filled and fees paid by makers and taker.

___

###  batchMatchOrders

▸ **batchMatchOrders**(`leftOrders`: `Array<object>`, `rightOrders`: `Array<object>`, `leftSignatures`: string[], `rightSignatures`: string[]): *`ContractTxFunctionObj<object>`*

*Defined in [abi-gen-wrappers/src/generated-wrappers/exchange.ts:3619](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/exchange.ts#L3619)*

Match complementary orders that have a profitable spread.
Each order is filled at their respective price point, and
the matcher receives a profit denominated in the left maker asset.

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`leftOrders` | `Array<object>` | Set of orders with the same maker / taker asset. |
`rightOrders` | `Array<object>` | Set of orders to match against `leftOrders` |
`leftSignatures` | string[] | Proof that left orders were created by the left     makers. |
`rightSignatures` | string[] | Proof that right orders were created by the right     makers. |

**Returns:** *`ContractTxFunctionObj<object>`*

batchMatchedFillResults Amounts filled and profit generated.

___

###  batchMatchOrdersWithMaximalFill

▸ **batchMatchOrdersWithMaximalFill**(`leftOrders`: `Array<object>`, `rightOrders`: `Array<object>`, `leftSignatures`: string[], `rightSignatures`: string[]): *`ContractTxFunctionObj<object>`*

*Defined in [abi-gen-wrappers/src/generated-wrappers/exchange.ts:3776](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/exchange.ts#L3776)*

Match complementary orders that have a profitable spread.
Each order is maximally filled at their respective price point, and
the matcher receives a profit denominated in either the left maker asset,
right maker asset, or a combination of both.

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`leftOrders` | `Array<object>` | Set of orders with the same maker / taker asset. |
`rightOrders` | `Array<object>` | Set of orders to match against `leftOrders` |
`leftSignatures` | string[] | Proof that left orders were created by the left     makers. |
`rightSignatures` | string[] | Proof that right orders were created by the right     makers. |

**Returns:** *`ContractTxFunctionObj<object>`*

batchMatchedFillResults Amounts filled and profit generated.

___

###  cancelOrder

▸ **cancelOrder**(`order`: object): *`ContractTxFunctionObj<void>`*

*Defined in [abi-gen-wrappers/src/generated-wrappers/exchange.ts:3924](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/exchange.ts#L3924)*

After calling, the order can not be filled anymore.

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`order` | object | Order struct containing order specifications.  |

**Returns:** *`ContractTxFunctionObj<void>`*

___

###  cancelOrdersUpTo

▸ **cancelOrdersUpTo**(`targetOrderEpoch`: `BigNumber`): *`ContractTxFunctionObj<void>`*

*Defined in [abi-gen-wrappers/src/generated-wrappers/exchange.ts:3992](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/exchange.ts#L3992)*

Cancels all orders created by makerAddress with a salt less than or equal to the targetOrderEpoch
and senderAddress equal to msg.sender (or null address if msg.sender == makerAddress).

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`targetOrderEpoch` | `BigNumber` | Orders created with a salt less or equal to this     value will be cancelled.  |

**Returns:** *`ContractTxFunctionObj<void>`*

___

###  cancelled

▸ **cancelled**(`index_0`: string): *`ContractFunctionObj<boolean>`*

*Defined in [abi-gen-wrappers/src/generated-wrappers/exchange.ts:4038](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/exchange.ts#L4038)*

**Parameters:**

Name | Type |
------ | ------ |
`index_0` | string |

**Returns:** *`ContractFunctionObj<boolean>`*

___

###  currentContextAddress

▸ **currentContextAddress**(): *`ContractFunctionObj<string>`*

*Defined in [abi-gen-wrappers/src/generated-wrappers/exchange.ts:4058](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/exchange.ts#L4058)*

**Returns:** *`ContractFunctionObj<string>`*

___

###  executeTransaction

▸ **executeTransaction**(`transaction`: object, `signature`: string): *`ContractTxFunctionObj<string>`*

*Defined in [abi-gen-wrappers/src/generated-wrappers/exchange.ts:4083](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/exchange.ts#L4083)*

Executes an Exchange method call in the context of signer.

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`transaction` | object | 0x transaction structure. |
`signature` | string | Proof that transaction has been signed by signer. |

**Returns:** *`ContractTxFunctionObj<string>`*

ABI encoded return data of the underlying Exchange function call.

___

###  fillOrKillOrder

▸ **fillOrKillOrder**(`order`: object, `takerAssetFillAmount`: `BigNumber`, `signature`: string): *`ContractTxFunctionObj<object>`*

*Defined in [abi-gen-wrappers/src/generated-wrappers/exchange.ts:4145](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/exchange.ts#L4145)*

Fills the input order. Reverts if exact takerAssetFillAmount not filled.

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`order` | object | Order struct containing order specifications. |
`takerAssetFillAmount` | `BigNumber` | Desired amount of takerAsset to sell. |
`signature` | string | Proof that order has been created by maker.  |

**Returns:** *`ContractTxFunctionObj<object>`*

___

###  fillOrder

▸ **fillOrder**(`order`: object, `takerAssetFillAmount`: `BigNumber`, `signature`: string): *`ContractTxFunctionObj<object>`*

*Defined in [abi-gen-wrappers/src/generated-wrappers/exchange.ts:4241](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/exchange.ts#L4241)*

Fills the input order.

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`order` | object | Order struct containing order specifications. |
`takerAssetFillAmount` | `BigNumber` | Desired amount of takerAsset to sell. |
`signature` | string | Proof that order has been created by maker. |

**Returns:** *`ContractTxFunctionObj<object>`*

Amounts filled and fees paid by maker and taker.

___

###  filled

▸ **filled**(`index_0`: string): *`ContractFunctionObj<BigNumber>`*

*Defined in [abi-gen-wrappers/src/generated-wrappers/exchange.ts:4330](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/exchange.ts#L4330)*

**Parameters:**

Name | Type |
------ | ------ |
`index_0` | string |

**Returns:** *`ContractFunctionObj<BigNumber>`*

___

###  getABIDecodedReturnData

▸ **getABIDecodedReturnData**<**T**>(`methodName`: string, `callData`: string): *`T`*

*Defined in [abi-gen-wrappers/src/generated-wrappers/exchange.ts:3094](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/exchange.ts#L3094)*

**Type parameters:**

▪ **T**

**Parameters:**

Name | Type |
------ | ------ |
`methodName` | string |
`callData` | string |

**Returns:** *`T`*

___

###  getABIDecodedTransactionData

▸ **getABIDecodedTransactionData**<**T**>(`methodName`: string, `callData`: string): *`T`*

*Defined in [abi-gen-wrappers/src/generated-wrappers/exchange.ts:3087](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/exchange.ts#L3087)*

**Type parameters:**

▪ **T**

**Parameters:**

Name | Type |
------ | ------ |
`methodName` | string |
`callData` | string |

**Returns:** *`T`*

___

###  getAssetProxy

▸ **getAssetProxy**(`assetProxyId`: string): *`ContractFunctionObj<string>`*

*Defined in [abi-gen-wrappers/src/generated-wrappers/exchange.ts:4355](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/exchange.ts#L4355)*

Gets an asset proxy.

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`assetProxyId` | string | Id of the asset proxy. |

**Returns:** *`ContractFunctionObj<string>`*

The asset proxy registered to assetProxyId. Returns 0x0 if no proxy is registered.

___

###  getFunctionSignature

▸ **getFunctionSignature**(`methodName`: string): *string*

*Defined in [abi-gen-wrappers/src/generated-wrappers/exchange.ts:3081](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/exchange.ts#L3081)*

**Parameters:**

Name | Type |
------ | ------ |
`methodName` | string |

**Returns:** *string*

___

###  getLogsAsync

▸ **getLogsAsync**<**ArgsType**>(`eventName`: [ExchangeEvents](#enumeration-exchangeevents), `blockRange`: `BlockRange`, `indexFilterValues`: `IndexedFilterValues`): *`Promise<Array<LogWithDecodedArgs<ArgsType>>>`*

*Defined in [abi-gen-wrappers/src/generated-wrappers/exchange.ts:5771](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/exchange.ts#L5771)*

Gets historical logs without creating a subscription

**Type parameters:**

▪ **ArgsType**: *[ExchangeEventArgs](#exchangeeventargs)*

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`eventName` | [ExchangeEvents](#enumeration-exchangeevents) | The Exchange contract event you would like to subscribe to. |
`blockRange` | `BlockRange` | Block range to get logs from. |
`indexFilterValues` | `IndexedFilterValues` | An object where the keys are indexed args returned by the event and the value is the value you are interested in. E.g `{_from: aUserAddressHex}` |

**Returns:** *`Promise<Array<LogWithDecodedArgs<ArgsType>>>`*

Array of logs that match the parameters

___

###  getOrderInfo

▸ **getOrderInfo**(`order`: object): *`ContractFunctionObj<object>`*

*Defined in [abi-gen-wrappers/src/generated-wrappers/exchange.ts:4380](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/exchange.ts#L4380)*

Gets information about an order: status, hash, and amount filled.

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`order` | object | Order to gather information on. |

**Returns:** *`ContractFunctionObj<object>`*

OrderInfo Information about the order and its state.         See LibOrder.OrderInfo for a complete description.

___

###  getSelector

▸ **getSelector**(`methodName`: string): *string*

*Defined in [abi-gen-wrappers/src/generated-wrappers/exchange.ts:3101](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/exchange.ts#L3101)*

**Parameters:**

Name | Type |
------ | ------ |
`methodName` | string |

**Returns:** *string*

___

###  isValidHashSignature

▸ **isValidHashSignature**(`hash`: string, `signerAddress`: string, `signature`: string): *`ContractFunctionObj<boolean>`*

*Defined in [abi-gen-wrappers/src/generated-wrappers/exchange.ts:4430](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/exchange.ts#L4430)*

Verifies that a hash has been signed by the given signer.

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`hash` | string | Any 32-byte hash. |
`signerAddress` | string | Address that should have signed the given hash. |
`signature` | string | Proof that the hash has been signed by signer. |

**Returns:** *`ContractFunctionObj<boolean>`*

isValid &#x60;true&#x60; if the signature is valid for the given hash and signer.

___

###  isValidOrderSignature

▸ **isValidOrderSignature**(`order`: object, `signature`: string): *`ContractFunctionObj<boolean>`*

*Defined in [abi-gen-wrappers/src/generated-wrappers/exchange.ts:4458](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/exchange.ts#L4458)*

Verifies that a signature for an order is valid.

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`order` | object | The order. |
`signature` | string | Proof that the order has been signed by signer. |

**Returns:** *`ContractFunctionObj<boolean>`*

isValid &#x60;true&#x60; if the signature is valid for the given order and signer.

___

###  isValidTransactionSignature

▸ **isValidTransactionSignature**(`transaction`: object, `signature`: string): *`ContractFunctionObj<boolean>`*

*Defined in [abi-gen-wrappers/src/generated-wrappers/exchange.ts:4504](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/exchange.ts#L4504)*

Verifies that a signature for a transaction is valid.

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`transaction` | object | The transaction. |
`signature` | string | Proof that the order has been signed by signer. |

**Returns:** *`ContractFunctionObj<boolean>`*

isValid &#x60;true&#x60; if the signature is valid for the given transaction and signer.

___

###  marketBuyOrdersFillOrKill

▸ **marketBuyOrdersFillOrKill**(`orders`: `Array<object>`, `makerAssetFillAmount`: `BigNumber`, `signatures`: string[]): *`ContractTxFunctionObj<object>`*

*Defined in [abi-gen-wrappers/src/generated-wrappers/exchange.ts:4542](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/exchange.ts#L4542)*

Calls marketBuyOrdersNoThrow then reverts if < makerAssetFillAmount has been bought.
NOTE: This function does not enforce that the makerAsset is the same for each order.

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`orders` | `Array<object>` | Array of order specifications. |
`makerAssetFillAmount` | `BigNumber` | Minimum amount of makerAsset to buy. |
`signatures` | string[] | Proofs that orders have been signed by makers. |

**Returns:** *`ContractTxFunctionObj<object>`*

Amounts filled and fees paid by makers and taker.

___

###  marketBuyOrdersNoThrow

▸ **marketBuyOrdersNoThrow**(`orders`: `Array<object>`, `makerAssetFillAmount`: `BigNumber`, `signatures`: string[]): *`ContractTxFunctionObj<object>`*

*Defined in [abi-gen-wrappers/src/generated-wrappers/exchange.ts:4640](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/exchange.ts#L4640)*

Executes multiple calls of fillOrder until total amount of makerAsset is bought by taker.
If any fill reverts, the error is caught and ignored.
NOTE: This function does not enforce that the makerAsset is the same for each order.

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`orders` | `Array<object>` | Array of order specifications. |
`makerAssetFillAmount` | `BigNumber` | Desired amount of makerAsset to buy. |
`signatures` | string[] | Proofs that orders have been signed by makers. |

**Returns:** *`ContractTxFunctionObj<object>`*

Amounts filled and fees paid by makers and taker.

___

###  marketSellOrdersFillOrKill

▸ **marketSellOrdersFillOrKill**(`orders`: `Array<object>`, `takerAssetFillAmount`: `BigNumber`, `signatures`: string[]): *`ContractTxFunctionObj<object>`*

*Defined in [abi-gen-wrappers/src/generated-wrappers/exchange.ts:4737](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/exchange.ts#L4737)*

Calls marketSellOrdersNoThrow then reverts if < takerAssetFillAmount has been sold.
NOTE: This function does not enforce that the takerAsset is the same for each order.

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`orders` | `Array<object>` | Array of order specifications. |
`takerAssetFillAmount` | `BigNumber` | Minimum amount of takerAsset to sell. |
`signatures` | string[] | Proofs that orders have been signed by makers. |

**Returns:** *`ContractTxFunctionObj<object>`*

Amounts filled and fees paid by makers and taker.

___

###  marketSellOrdersNoThrow

▸ **marketSellOrdersNoThrow**(`orders`: `Array<object>`, `takerAssetFillAmount`: `BigNumber`, `signatures`: string[]): *`ContractTxFunctionObj<object>`*

*Defined in [abi-gen-wrappers/src/generated-wrappers/exchange.ts:4835](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/exchange.ts#L4835)*

Executes multiple calls of fillOrder until total amount of takerAsset is sold by taker.
If any fill reverts, the error is caught and ignored.
NOTE: This function does not enforce that the takerAsset is the same for each order.

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`orders` | `Array<object>` | Array of order specifications. |
`takerAssetFillAmount` | `BigNumber` | Desired amount of takerAsset to sell. |
`signatures` | string[] | Proofs that orders have been signed by makers. |

**Returns:** *`ContractTxFunctionObj<object>`*

Amounts filled and fees paid by makers and taker.

___

###  matchOrders

▸ **matchOrders**(`leftOrder`: object, `rightOrder`: object, `leftSignature`: string, `rightSignature`: string): *`ContractTxFunctionObj<object>`*

*Defined in [abi-gen-wrappers/src/generated-wrappers/exchange.ts:4935](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/exchange.ts#L4935)*

Match two complementary orders that have a profitable spread.
Each order is filled at their respective price point. However, the calculations are
carried out as though the orders are both being filled at the right order's price point.
The profit made by the left order goes to the taker (who matched the two orders).

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`leftOrder` | object | First order to match. |
`rightOrder` | object | Second order to match. |
`leftSignature` | string | Proof that order was created by the left maker. |
`rightSignature` | string | Proof that order was created by the right maker. |

**Returns:** *`ContractTxFunctionObj<object>`*

matchedFillResults Amounts filled and fees paid by maker and taker of matched orders.

___

###  matchOrdersWithMaximalFill

▸ **matchOrdersWithMaximalFill**(`leftOrder`: object, `rightOrder`: object, `leftSignature`: string, `rightSignature`: string): *`ContractTxFunctionObj<object>`*

*Defined in [abi-gen-wrappers/src/generated-wrappers/exchange.ts:5089](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/exchange.ts#L5089)*

Match two complementary orders that have a profitable spread.
Each order is maximally filled at their respective price point, and
the matcher receives a profit denominated in either the left maker asset,
right maker asset, or a combination of both.

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`leftOrder` | object | First order to match. |
`rightOrder` | object | Second order to match. |
`leftSignature` | string | Proof that order was created by the left maker. |
`rightSignature` | string | Proof that order was created by the right maker. |

**Returns:** *`ContractTxFunctionObj<object>`*

matchedFillResults Amounts filled by maker and taker of matched orders.

___

###  orderEpoch

▸ **orderEpoch**(`index_0`: string, `index_1`: string): *`ContractFunctionObj<BigNumber>`*

*Defined in [abi-gen-wrappers/src/generated-wrappers/exchange.ts:5232](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/exchange.ts#L5232)*

**Parameters:**

Name | Type |
------ | ------ |
`index_0` | string |
`index_1` | string |

**Returns:** *`ContractFunctionObj<BigNumber>`*

___

###  owner

▸ **owner**(): *`ContractFunctionObj<string>`*

*Defined in [abi-gen-wrappers/src/generated-wrappers/exchange.ts:5253](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/exchange.ts#L5253)*

**Returns:** *`ContractFunctionObj<string>`*

___

###  preSign

▸ **preSign**(`hash`: string): *`ContractTxFunctionObj<void>`*

*Defined in [abi-gen-wrappers/src/generated-wrappers/exchange.ts:5277](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/exchange.ts#L5277)*

Approves a hash on-chain.
After presigning a hash, the preSign signature type will become valid for that hash and signer.

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`hash` | string | Any 32-byte hash.  |

**Returns:** *`ContractTxFunctionObj<void>`*

___

###  preSigned

▸ **preSigned**(`index_0`: string, `index_1`: string): *`ContractFunctionObj<boolean>`*

*Defined in [abi-gen-wrappers/src/generated-wrappers/exchange.ts:5323](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/exchange.ts#L5323)*

**Parameters:**

Name | Type |
------ | ------ |
`index_0` | string |
`index_1` | string |

**Returns:** *`ContractFunctionObj<boolean>`*

___

###  protocolFeeCollector

▸ **protocolFeeCollector**(): *`ContractFunctionObj<string>`*

*Defined in [abi-gen-wrappers/src/generated-wrappers/exchange.ts:5344](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/exchange.ts#L5344)*

**Returns:** *`ContractFunctionObj<string>`*

___

###  protocolFeeMultiplier

▸ **protocolFeeMultiplier**(): *`ContractFunctionObj<BigNumber>`*

*Defined in [abi-gen-wrappers/src/generated-wrappers/exchange.ts:5363](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/exchange.ts#L5363)*

**Returns:** *`ContractFunctionObj<BigNumber>`*

___

###  registerAssetProxy

▸ **registerAssetProxy**(`assetProxy`: string): *`ContractTxFunctionObj<void>`*

*Defined in [abi-gen-wrappers/src/generated-wrappers/exchange.ts:5387](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/exchange.ts#L5387)*

Registers an asset proxy to its asset proxy id.
Once an asset proxy is registered, it cannot be unregistered.

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`assetProxy` | string | Address of new asset proxy to register.  |

**Returns:** *`ContractTxFunctionObj<void>`*

___

###  setProtocolFeeCollectorAddress

▸ **setProtocolFeeCollectorAddress**(`updatedProtocolFeeCollector`: string): *`ContractTxFunctionObj<void>`*

*Defined in [abi-gen-wrappers/src/generated-wrappers/exchange.ts:5438](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/exchange.ts#L5438)*

Allows the owner to update the protocolFeeCollector address.

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`updatedProtocolFeeCollector` | string | The updated protocolFeeCollector contract     address.  |

**Returns:** *`ContractTxFunctionObj<void>`*

___

###  setProtocolFeeMultiplier

▸ **setProtocolFeeMultiplier**(`updatedProtocolFeeMultiplier`: `BigNumber`): *`ContractTxFunctionObj<void>`*

*Defined in [abi-gen-wrappers/src/generated-wrappers/exchange.ts:5488](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/exchange.ts#L5488)*

Allows the owner to update the protocol fee multiplier.

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`updatedProtocolFeeMultiplier` | `BigNumber` | The updated protocol fee multiplier.  |

**Returns:** *`ContractTxFunctionObj<void>`*

___

###  setSignatureValidatorApproval

▸ **setSignatureValidatorApproval**(`validatorAddress`: string, `approval`: boolean): *`ContractTxFunctionObj<void>`*

*Defined in [abi-gen-wrappers/src/generated-wrappers/exchange.ts:5540](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/exchange.ts#L5540)*

Approves/unnapproves a Validator contract to verify signatures on signer's behalf
using the `Validator` signature type.

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`validatorAddress` | string | Address of Validator contract. |
`approval` | boolean | Approval or disapproval of  Validator contract.  |

**Returns:** *`ContractTxFunctionObj<void>`*

___

###  simulateDispatchTransferFromCalls

▸ **simulateDispatchTransferFromCalls**(`assetData`: string[], `fromAddresses`: string[], `toAddresses`: string[], `amounts`: `BigNumber`[]): *`ContractTxFunctionObj<void>`*

*Defined in [abi-gen-wrappers/src/generated-wrappers/exchange.ts:5599](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/exchange.ts#L5599)*

This function may be used to simulate any amount of transfers As they would occur through the Exchange contract. Note that this function will always revert, even if all transfers are successful. However, it may be used with eth_call or with a try/catch pattern in order to simulate the results of the transfers.

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`assetData` | string[] | Array of asset details, each encoded per the AssetProxy     contract specification. |
`fromAddresses` | string[] | Array containing the `from` addresses that correspond     with each transfer. |
`toAddresses` | string[] | Array containing the `to` addresses that correspond with     each transfer. |
`amounts` | `BigNumber`[] | Array containing the amounts that correspond to each     transfer. |

**Returns:** *`ContractTxFunctionObj<void>`*

This function does not return a value. However, it will always revert with &#x60;Error(&quot;TRANSFERS_SUCCESSFUL&quot;)&#x60; if all of the transfers were successful.

___

###  subscribe

▸ **subscribe**<**ArgsType**>(`eventName`: [ExchangeEvents](#enumeration-exchangeevents), `indexFilterValues`: `IndexedFilterValues`, `callback`: [EventCallback](#eventcallback)‹*`ArgsType`*›, `isVerbose`: boolean, `blockPollingIntervalMs?`: undefined | number): *string*

*Defined in [abi-gen-wrappers/src/generated-wrappers/exchange.ts:5729](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/exchange.ts#L5729)*

Subscribe to an event type emitted by the Exchange contract.

**Type parameters:**

▪ **ArgsType**: *[ExchangeEventArgs](#exchangeeventargs)*

**Parameters:**

Name | Type | Default | Description |
------ | ------ | ------ | ------ |
`eventName` | [ExchangeEvents](#enumeration-exchangeevents) | - | The Exchange contract event you would like to subscribe to. |
`indexFilterValues` | `IndexedFilterValues` | - | An object where the keys are indexed args returned by the event and the value is the value you are interested in. E.g `{maker: aUserAddressHex}` |
`callback` | [EventCallback](#eventcallback)‹*`ArgsType`*› | - | Callback that gets called when a log is added/removed |
`isVerbose` | boolean | false | Enable verbose subscription warnings (e.g recoverable network issues encountered) |
`blockPollingIntervalMs?` | undefined \| number | - | - |

**Returns:** *string*

Subscription token used later to unsubscribe

___

###  transactionsExecuted

▸ **transactionsExecuted**(`index_0`: string): *`ContractFunctionObj<boolean>`*

*Defined in [abi-gen-wrappers/src/generated-wrappers/exchange.ts:5653](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/exchange.ts#L5653)*

**Parameters:**

Name | Type |
------ | ------ |
`index_0` | string |

**Returns:** *`ContractFunctionObj<boolean>`*

___

###  transferOwnership

▸ **transferOwnership**(`newOwner`: string): *`ContractTxFunctionObj<void>`*

*Defined in [abi-gen-wrappers/src/generated-wrappers/exchange.ts:5673](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/exchange.ts#L5673)*

**Parameters:**

Name | Type |
------ | ------ |
`newOwner` | string |

**Returns:** *`ContractTxFunctionObj<void>`*

___

###  unsubscribe

▸ **unsubscribe**(`subscriptionToken`: string): *void*

*Defined in [abi-gen-wrappers/src/generated-wrappers/exchange.ts:5754](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/exchange.ts#L5754)*

Cancel a subscription

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`subscriptionToken` | string | Subscription token returned by `subscribe()`  |

**Returns:** *void*

___

###  unsubscribeAll

▸ **unsubscribeAll**(): *void*

*Defined in [abi-gen-wrappers/src/generated-wrappers/exchange.ts:5760](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/exchange.ts#L5760)*

Cancels all existing subscriptions

**Returns:** *void*

___

### `Static` ABI

▸ **ABI**(): *[ContractAbi](#contractabi)*

*Defined in [abi-gen-wrappers/src/generated-wrappers/exchange.ts:200](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/exchange.ts#L200)*

**Returns:** *[ContractAbi](#contractabi)*

The contract ABI

___

### `Static` deployAsync

▸ **deployAsync**(`bytecode`: string, `abi`: [ContractAbi](#contractabi), `supportedProvider`: [SupportedProvider](#supportedprovider), `txDefaults`: `Partial<TxData>`, `logDecodeDependencies`: object, `chainId`: `BigNumber`): *`Promise<ExchangeContract>`*

*Defined in [abi-gen-wrappers/src/generated-wrappers/exchange.ts:151](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/exchange.ts#L151)*

**Parameters:**

Name | Type |
------ | ------ |
`bytecode` | string |
`abi` | [ContractAbi](#contractabi) |
`supportedProvider` | [SupportedProvider](#supportedprovider) |
`txDefaults` | `Partial<TxData>` |
`logDecodeDependencies` | object |
`chainId` | `BigNumber` |

**Returns:** *`Promise<ExchangeContract>`*

___

### `Static` deployFrom0xArtifactAsync

▸ **deployFrom0xArtifactAsync**(`artifact`: `ContractArtifact` | `SimpleContractArtifact`, `supportedProvider`: [SupportedProvider](#supportedprovider), `txDefaults`: `Partial<TxData>`, `logDecodeDependencies`: object, `chainId`: `BigNumber`): *`Promise<ExchangeContract>`*

*Defined in [abi-gen-wrappers/src/generated-wrappers/exchange.ts:125](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/exchange.ts#L125)*

**Parameters:**

Name | Type |
------ | ------ |
`artifact` | `ContractArtifact` \| `SimpleContractArtifact` |
`supportedProvider` | [SupportedProvider](#supportedprovider) |
`txDefaults` | `Partial<TxData>` |
`logDecodeDependencies` | object |
`chainId` | `BigNumber` |

**Returns:** *`Promise<ExchangeContract>`*

___

### `Static` strictArgumentEncodingCheck

▸ **strictArgumentEncodingCheck**(`inputAbi`: `DataItem`[], `args`: any[]): *string*



Defined in base-contract/lib/src/index.d.ts:42

**Parameters:**

Name | Type |
------ | ------ |
`inputAbi` | `DataItem`[] |
`args` | any[] |

**Returns:** *string*

<hr />

# Class: WETH9Contract


##   Constructors



\+ **new WETH9Contract**(`address`: string, `supportedProvider`: [SupportedProvider](#supportedprovider), `txDefaults?`: `Partial<TxData>`, `logDecodeDependencies?`: undefined | object, `deployedBytecode`: string | undefined): *[WETH9Contract](#class-weth9contract)*

*Overrides void*

*Defined in [abi-gen-wrappers/src/generated-wrappers/weth9.ts:885](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/weth9.ts#L885)*

**Parameters:**

Name | Type | Default |
------ | ------ | ------ |
`address` | string | - |
`supportedProvider` | [SupportedProvider](#supportedprovider) | - |
`txDefaults?` | `Partial<TxData>` | - |
`logDecodeDependencies?` | undefined \| object | - |
`deployedBytecode` | string \| undefined |  WETH9Contract.deployedBytecode |

**Returns:** *[WETH9Contract](#class-weth9contract)*

## Properties

### `Optional` _deployedBytecodeIfExists

• **_deployedBytecodeIfExists**? : *`Buffer`*



Defined in base-contract/lib/src/index.d.ts:33

___

###  abi

• **abi**: *[ContractAbi](#contractabi)*



Defined in base-contract/lib/src/index.d.ts:29

___

###  address

• **address**: *string*



Defined in base-contract/lib/src/index.d.ts:30

___

Args

• **constructorArgs**: *any[]*



Defined in base-contract/lib/src/index.d.ts:32

___

###  contractName

• **contractName**: *string*



Defined in base-contract/lib/src/index.d.ts:31

## Methods

###  allowance

▸ **allowance**(`index_0`: string, `index_1`: string): *`ContractFunctionObj<BigNumber>`*

*Defined in [abi-gen-wrappers/src/generated-wrappers/weth9.ts:796](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/weth9.ts#L796)*

**Parameters:**

Name | Type |
------ | ------ |
`index_0` | string |
`index_1` | string |

**Returns:** *`ContractFunctionObj<BigNumber>`*

___

###  approve

▸ **approve**(`guy`: string, `wad`: `BigNumber`): *`ContractTxFunctionObj<boolean>`*

*Defined in [abi-gen-wrappers/src/generated-wrappers/weth9.ts:486](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/weth9.ts#L486)*

**Parameters:**

Name | Type |
------ | ------ |
`guy` | string |
`wad` | `BigNumber` |

**Returns:** *`ContractTxFunctionObj<boolean>`*

___

###  balanceOf

▸ **balanceOf**(`index_0`: string): *`ContractFunctionObj<BigNumber>`*

*Defined in [abi-gen-wrappers/src/generated-wrappers/weth9.ts:665](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/weth9.ts#L665)*

**Parameters:**

Name | Type |
------ | ------ |
`index_0` | string |

**Returns:** *`ContractFunctionObj<BigNumber>`*

___

###  decimals

▸ **decimals**(): *`ContractFunctionObj<number>`*

*Defined in [abi-gen-wrappers/src/generated-wrappers/weth9.ts:646](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/weth9.ts#L646)*

**Returns:** *`ContractFunctionObj<number>`*

___

###  deposit

▸ **deposit**(): *`ContractTxFunctionObj<void>`*

*Defined in [abi-gen-wrappers/src/generated-wrappers/weth9.ts:751](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/weth9.ts#L751)*

**Returns:** *`ContractTxFunctionObj<void>`*

___

###  getABIDecodedReturnData

▸ **getABIDecodedReturnData**<**T**>(`methodName`: string, `callData`: string): *`T`*

*Defined in [abi-gen-wrappers/src/generated-wrappers/weth9.ts:453](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/weth9.ts#L453)*

**Type parameters:**

▪ **T**

**Parameters:**

Name | Type |
------ | ------ |
`methodName` | string |
`callData` | string |

**Returns:** *`T`*

___

###  getABIDecodedTransactionData

▸ **getABIDecodedTransactionData**<**T**>(`methodName`: string, `callData`: string): *`T`*

*Defined in [abi-gen-wrappers/src/generated-wrappers/weth9.ts:446](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/weth9.ts#L446)*

**Type parameters:**

▪ **T**

**Parameters:**

Name | Type |
------ | ------ |
`methodName` | string |
`callData` | string |

**Returns:** *`T`*

___

###  getFunctionSignature

▸ **getFunctionSignature**(`methodName`: string): *string*

*Defined in [abi-gen-wrappers/src/generated-wrappers/weth9.ts:440](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/weth9.ts#L440)*

**Parameters:**

Name | Type |
------ | ------ |
`methodName` | string |

**Returns:** *string*

___

###  getLogsAsync

▸ **getLogsAsync**<**ArgsType**>(`eventName`: [WETH9Events](#enumeration-weth9events), `blockRange`: `BlockRange`, `indexFilterValues`: `IndexedFilterValues`): *`Promise<Array<LogWithDecodedArgs<ArgsType>>>`*

*Defined in [abi-gen-wrappers/src/generated-wrappers/weth9.ts:869](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/weth9.ts#L869)*

Gets historical logs without creating a subscription

**Type parameters:**

▪ **ArgsType**: *[WETH9EventArgs](#weth9eventargs)*

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`eventName` | [WETH9Events](#enumeration-weth9events) | The WETH9 contract event you would like to subscribe to. |
`blockRange` | `BlockRange` | Block range to get logs from. |
`indexFilterValues` | `IndexedFilterValues` | An object where the keys are indexed args returned by the event and the value is the value you are interested in. E.g `{_from: aUserAddressHex}` |

**Returns:** *`Promise<Array<LogWithDecodedArgs<ArgsType>>>`*

Array of logs that match the parameters

___

###  getSelector

▸ **getSelector**(`methodName`: string): *string*

*Defined in [abi-gen-wrappers/src/generated-wrappers/weth9.ts:460](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/weth9.ts#L460)*

**Parameters:**

Name | Type |
------ | ------ |
`methodName` | string |

**Returns:** *string*

___

###  name

▸ **name**(): *`ContractFunctionObj<string>`*

*Defined in [abi-gen-wrappers/src/generated-wrappers/weth9.ts:467](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/weth9.ts#L467)*

**Returns:** *`ContractFunctionObj<string>`*

___

###  subscribe

▸ **subscribe**<**ArgsType**>(`eventName`: [WETH9Events](#enumeration-weth9events), `indexFilterValues`: `IndexedFilterValues`, `callback`: [EventCallback](#eventcallback)‹*`ArgsType`*›, `isVerbose`: boolean, `blockPollingIntervalMs?`: undefined | number): *string*

*Defined in [abi-gen-wrappers/src/generated-wrappers/weth9.ts:827](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/weth9.ts#L827)*

Subscribe to an event type emitted by the WETH9 contract.

**Type parameters:**

▪ **ArgsType**: *[WETH9EventArgs](#weth9eventargs)*

**Parameters:**

Name | Type | Default | Description |
------ | ------ | ------ | ------ |
`eventName` | [WETH9Events](#enumeration-weth9events) | - | The WETH9 contract event you would like to subscribe to. |
`indexFilterValues` | `IndexedFilterValues` | - | An object where the keys are indexed args returned by the event and the value is the value you are interested in. E.g `{maker: aUserAddressHex}` |
`callback` | [EventCallback](#eventcallback)‹*`ArgsType`*› | - | Callback that gets called when a log is added/removed |
`isVerbose` | boolean | false | Enable verbose subscription warnings (e.g recoverable network issues encountered) |
`blockPollingIntervalMs?` | undefined \| number | - | - |

**Returns:** *string*

Subscription token used later to unsubscribe

___

###  symbol

▸ **symbol**(): *`ContractFunctionObj<string>`*

*Defined in [abi-gen-wrappers/src/generated-wrappers/weth9.ts:685](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/weth9.ts#L685)*

**Returns:** *`ContractFunctionObj<string>`*

___

###  totalSupply

▸ **totalSupply**(): *`ContractFunctionObj<BigNumber>`*

*Defined in [abi-gen-wrappers/src/generated-wrappers/weth9.ts:533](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/weth9.ts#L533)*

**Returns:** *`ContractFunctionObj<BigNumber>`*

___

###  transfer

▸ **transfer**(`dst`: string, `wad`: `BigNumber`): *`ContractTxFunctionObj<boolean>`*

*Defined in [abi-gen-wrappers/src/generated-wrappers/weth9.ts:704](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/weth9.ts#L704)*

**Parameters:**

Name | Type |
------ | ------ |
`dst` | string |
`wad` | `BigNumber` |

**Returns:** *`ContractTxFunctionObj<boolean>`*

___

###  transferFrom

▸ **transferFrom**(`src`: string, `dst`: string, `wad`: `BigNumber`): *`ContractTxFunctionObj<boolean>`*

*Defined in [abi-gen-wrappers/src/generated-wrappers/weth9.ts:552](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/weth9.ts#L552)*

**Parameters:**

Name | Type |
------ | ------ |
`src` | string |
`dst` | string |
`wad` | `BigNumber` |

**Returns:** *`ContractTxFunctionObj<boolean>`*

___

###  unsubscribe

▸ **unsubscribe**(`subscriptionToken`: string): *void*

*Defined in [abi-gen-wrappers/src/generated-wrappers/weth9.ts:852](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/weth9.ts#L852)*

Cancel a subscription

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`subscriptionToken` | string | Subscription token returned by `subscribe()`  |

**Returns:** *void*

___

###  unsubscribeAll

▸ **unsubscribeAll**(): *void*

*Defined in [abi-gen-wrappers/src/generated-wrappers/weth9.ts:858](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/weth9.ts#L858)*

Cancels all existing subscriptions

**Returns:** *void*

___

###  withdraw

▸ **withdraw**(`wad`: `BigNumber`): *`ContractTxFunctionObj<void>`*

*Defined in [abi-gen-wrappers/src/generated-wrappers/weth9.ts:600](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/weth9.ts#L600)*

**Parameters:**

Name | Type |
------ | ------ |
`wad` | `BigNumber` |

**Returns:** *`ContractTxFunctionObj<void>`*

___

### `Static` ABI

▸ **ABI**(): *[ContractAbi](#contractabi)*

*Defined in [abi-gen-wrappers/src/generated-wrappers/weth9.ts:151](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/weth9.ts#L151)*

**Returns:** *[ContractAbi](#contractabi)*

The contract ABI

___

### `Static` deployAsync

▸ **deployAsync**(`bytecode`: string, `abi`: [ContractAbi](#contractabi), `supportedProvider`: [SupportedProvider](#supportedprovider), `txDefaults`: `Partial<TxData>`, `logDecodeDependencies`: object): *`Promise<WETH9Contract>`*

*Defined in [abi-gen-wrappers/src/generated-wrappers/weth9.ts:107](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/weth9.ts#L107)*

**Parameters:**

Name | Type |
------ | ------ |
`bytecode` | string |
`abi` | [ContractAbi](#contractabi) |
`supportedProvider` | [SupportedProvider](#supportedprovider) |
`txDefaults` | `Partial<TxData>` |
`logDecodeDependencies` | object |

**Returns:** *`Promise<WETH9Contract>`*

___

### `Static` deployFrom0xArtifactAsync

▸ **deployFrom0xArtifactAsync**(`artifact`: `ContractArtifact` | `SimpleContractArtifact`, `supportedProvider`: [SupportedProvider](#supportedprovider), `txDefaults`: `Partial<TxData>`, `logDecodeDependencies`: object): *`Promise<WETH9Contract>`*

*Defined in [abi-gen-wrappers/src/generated-wrappers/weth9.ts:82](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/weth9.ts#L82)*

**Parameters:**

Name | Type |
------ | ------ |
`artifact` | `ContractArtifact` \| `SimpleContractArtifact` |
`supportedProvider` | [SupportedProvider](#supportedprovider) |
`txDefaults` | `Partial<TxData>` |
`logDecodeDependencies` | object |

**Returns:** *`Promise<WETH9Contract>`*

___

### `Static` strictArgumentEncodingCheck

▸ **strictArgumentEncodingCheck**(`inputAbi`: `DataItem`[], `args`: any[]): *string*



Defined in base-contract/lib/src/index.d.ts:42

**Parameters:**

Name | Type |
------ | ------ |
`inputAbi` | `DataItem`[] |
`args` | any[] |

**Returns:** *string*

<hr />

# Class: MetamaskSubprovider

This class implements the [web3-provider-engine](https://github.com/MetaMask/provider-engine)
subprovider interface and the provider sendAsync interface.
It handles inconsistencies with Metamask implementations of various JSON RPC methods.
It forwards JSON RPC requests involving the domain of a signer (getAccounts,
sendTransaction, signMessage etc...) to the provider instance supplied at instantiation. All other requests
are passed onwards for subsequent subproviders to handle.


##   Constructors



\+ **new MetamaskSubprovider**(`supportedProvider`: [SupportedProvider](#supportedprovider)): *[MetamaskSubprovider](#class-metamasksubprovider)*

*Defined in [subproviders/src/subproviders/metamask_subprovider.ts:19](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/subproviders/src/subproviders/metamask_subprovider.ts#L19)*

Instantiates a new MetamaskSubprovider

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`supportedProvider` | [SupportedProvider](#supportedprovider) | Web3 provider that should handle  all user account related requests  |

**Returns:** *[MetamaskSubprovider](#class-metamasksubprovider)*

## Methods

###  emitPayloadAsync

▸ **emitPayloadAsync**(`payload`: `Partial<JSONRPCRequestPayloadWithMethod>`): *`Promise<JSONRPCResponsePayload>`*



*Defined in [subproviders/src/subproviders/subprovider.ts:55](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/subproviders/src/subproviders/subprovider.ts#L55)*

Emits a JSON RPC payload that will then be handled by the ProviderEngine instance
this subprovider is a part of. The payload will cascade down the subprovider middleware
stack until finding the responsible entity for handling the request.

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`payload` | `Partial<JSONRPCRequestPayloadWithMethod>` | JSON RPC payload |

**Returns:** *`Promise<JSONRPCResponsePayload>`*

JSON RPC response payload

___

###  handleRequest

▸ **handleRequest**(`payload`: `JSONRPCRequestPayload`, `next`: [Callback](#callback), `end`: [ErrorCallback](#errorcallback)): *`Promise<void>`*

*Overrides void*

*Defined in [subproviders/src/subproviders/metamask_subprovider.ts:39](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/subproviders/src/subproviders/metamask_subprovider.ts#L39)*

This method conforms to the web3-provider-engine interface.
It is called internally by the ProviderEngine when it is this subproviders
turn to handle a JSON RPC request.

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`payload` | `JSONRPCRequestPayload` | JSON RPC payload |
`next` | [Callback](#callback) | Callback to call if this subprovider decides not to handle the request |
`end` | [ErrorCallback](#errorcallback) | Callback to call if subprovider handled the request and wants to pass back the request.  |

**Returns:** *`Promise<void>`*

___

###  sendAsync

▸ **sendAsync**(`payload`: `JSONRPCRequestPayload`, `callback`: [ErrorCallback](#errorcallback)): *void*

*Defined in [subproviders/src/subproviders/metamask_subprovider.ts:117](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/subproviders/src/subproviders/metamask_subprovider.ts#L117)*

This method conforms to the provider sendAsync interface.
Allowing the MetamaskSubprovider to be used as a generic provider (outside of Web3ProviderEngine) with the
addition of wrapping the inconsistent Metamask behaviour

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`payload` | `JSONRPCRequestPayload` | JSON RPC payload |
`callback` | [ErrorCallback](#errorcallback) | - |

**Returns:** *void*

The contents nested under the result key of the response body

___

###  setEngine

▸ **setEngine**(`engine`: `Web3ProviderEngine`): *void*



*Defined in [subproviders/src/subproviders/subprovider.ts:68](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/subproviders/src/subproviders/subprovider.ts#L68)*

Set's the subprovider's engine to the ProviderEngine it is added to.
This is only called within the ProviderEngine source code, do not call
directly.

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`engine` | `Web3ProviderEngine` | The ProviderEngine this subprovider is added to  |

**Returns:** *void*

<hr />

# Class: RPCSubprovider

This class implements the [web3-provider-engine](https://github.com/MetaMask/provider-engine) subprovider interface.
It forwards on JSON RPC requests to the supplied `rpcUrl` endpoint


##   Constructors



\+ **new RPCSubprovider**(`rpcUrl`: string, `requestTimeoutMs`: number): *[RPCSubprovider](#class-rpcsubprovider)*

*Defined in [subproviders/src/subproviders/rpc_subprovider.ts:17](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/subproviders/src/subproviders/rpc_subprovider.ts#L17)*

**Parameters:**

Name | Type | Default | Description |
------ | ------ | ------ | ------ |
`rpcUrl` | string | - | URL to the backing Ethereum node to which JSON RPC requests should be sent |
`requestTimeoutMs` | number | 20000 | Amount of miliseconds to wait before timing out the JSON RPC request  |

**Returns:** *[RPCSubprovider](#class-rpcsubprovider)*

## Methods

###  emitPayloadAsync

▸ **emitPayloadAsync**(`payload`: `Partial<JSONRPCRequestPayloadWithMethod>`): *`Promise<JSONRPCResponsePayload>`*



*Defined in [subproviders/src/subproviders/subprovider.ts:55](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/subproviders/src/subproviders/subprovider.ts#L55)*

Emits a JSON RPC payload that will then be handled by the ProviderEngine instance
this subprovider is a part of. The payload will cascade down the subprovider middleware
stack until finding the responsible entity for handling the request.

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`payload` | `Partial<JSONRPCRequestPayloadWithMethod>` | JSON RPC payload |

**Returns:** *`Promise<JSONRPCResponsePayload>`*

JSON RPC response payload

___

###  handleRequest

▸ **handleRequest**(`payload`: `JSONRPCRequestPayload`, `_next`: [Callback](#callback), `end`: [ErrorCallback](#errorcallback)): *`Promise<void>`*

*Overrides void*

*Defined in [subproviders/src/subproviders/rpc_subprovider.ts:38](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/subproviders/src/subproviders/rpc_subprovider.ts#L38)*

This method conforms to the web3-provider-engine interface.
It is called internally by the ProviderEngine when it is this subproviders
turn to handle a JSON RPC request.

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`payload` | `JSONRPCRequestPayload` | JSON RPC payload |
`_next` | [Callback](#callback) | Callback to call if this subprovider decides not to handle the request |
`end` | [ErrorCallback](#errorcallback) | Callback to call if subprovider handled the request and wants to pass back the request.  |

**Returns:** *`Promise<void>`*

___

###  setEngine

▸ **setEngine**(`engine`: `Web3ProviderEngine`): *void*



*Defined in [subproviders/src/subproviders/subprovider.ts:68](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/subproviders/src/subproviders/subprovider.ts#L68)*

Set's the subprovider's engine to the ProviderEngine it is added to.
This is only called within the ProviderEngine source code, do not call
directly.

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`engine` | `Web3ProviderEngine` | The ProviderEngine this subprovider is added to  |

**Returns:** *void*

<hr />

# Enumeration: ERC20TokenEvents


##  Enumeration members

###  Approval

• **Approval**: = "Approval"

*Defined in [abi-gen-wrappers/src/generated-wrappers/erc20_token.ts:41](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/erc20_token.ts#L41)*

___

###  Transfer

• **Transfer**: = "Transfer"

*Defined in [abi-gen-wrappers/src/generated-wrappers/erc20_token.ts:40](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/erc20_token.ts#L40)*

<hr />

# Enumeration: ERC721TokenEvents


##  Enumeration members

###  Approval

• **Approval**: = "Approval"

*Defined in [abi-gen-wrappers/src/generated-wrappers/erc721_token.ts:43](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/erc721_token.ts#L43)*

___

###  ApprovalForAll

• **ApprovalForAll**: = "ApprovalForAll"

*Defined in [abi-gen-wrappers/src/generated-wrappers/erc721_token.ts:44](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/erc721_token.ts#L44)*

___

###  Transfer

• **Transfer**: = "Transfer"

*Defined in [abi-gen-wrappers/src/generated-wrappers/erc721_token.ts:45](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/erc721_token.ts#L45)*

<hr />

# Enumeration: ExchangeEvents


##  Enumeration members

###  AssetProxyRegistered

• **AssetProxyRegistered**: = "AssetProxyRegistered"

*Defined in [abi-gen-wrappers/src/generated-wrappers/exchange.ts:48](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/exchange.ts#L48)*

___

###  Cancel

• **Cancel**: = "Cancel"

*Defined in [abi-gen-wrappers/src/generated-wrappers/exchange.ts:49](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/exchange.ts#L49)*

___

###  CancelUpTo

• **CancelUpTo**: = "CancelUpTo"

*Defined in [abi-gen-wrappers/src/generated-wrappers/exchange.ts:50](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/exchange.ts#L50)*

___

###  Fill

• **Fill**: = "Fill"

*Defined in [abi-gen-wrappers/src/generated-wrappers/exchange.ts:51](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/exchange.ts#L51)*

___

###  ProtocolFeeCollectorAddress

• **ProtocolFeeCollectorAddress**: = "ProtocolFeeCollectorAddress"

*Defined in [abi-gen-wrappers/src/generated-wrappers/exchange.ts:52](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/exchange.ts#L52)*

___

###  ProtocolFeeMultiplier

• **ProtocolFeeMultiplier**: = "ProtocolFeeMultiplier"

*Defined in [abi-gen-wrappers/src/generated-wrappers/exchange.ts:53](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/exchange.ts#L53)*

___

###  SignatureValidatorApproval

• **SignatureValidatorApproval**: = "SignatureValidatorApproval"

*Defined in [abi-gen-wrappers/src/generated-wrappers/exchange.ts:54](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/exchange.ts#L54)*

___

###  TransactionExecution

• **TransactionExecution**: = "TransactionExecution"

*Defined in [abi-gen-wrappers/src/generated-wrappers/exchange.ts:55](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/exchange.ts#L55)*

<hr />

# Enumeration: WETH9Events


##  Enumeration members

###  Approval

• **Approval**: = "Approval"

*Defined in [abi-gen-wrappers/src/generated-wrappers/weth9.ts:44](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/weth9.ts#L44)*

___

###  Deposit

• **Deposit**: = "Deposit"

*Defined in [abi-gen-wrappers/src/generated-wrappers/weth9.ts:46](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/weth9.ts#L46)*

___

###  Transfer

• **Transfer**: = "Transfer"

*Defined in [abi-gen-wrappers/src/generated-wrappers/weth9.ts:45](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/weth9.ts#L45)*

___

###  Withdrawal

• **Withdrawal**: = "Withdrawal"

*Defined in [abi-gen-wrappers/src/generated-wrappers/weth9.ts:47](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/weth9.ts#L47)*

<hr />

# Enumeration: SubscriptionErrors


##  Enumeration members

###  SubscriptionAlreadyPresent

• **SubscriptionAlreadyPresent**: = "SUBSCRIPTION_ALREADY_PRESENT"

*Defined in [base-contract/src/types.ts:21](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/base-contract/src/types.ts#L21)*

___

###  SubscriptionNotFound

• **SubscriptionNotFound**: = "SUBSCRIPTION_NOT_FOUND"

*Defined in [base-contract/src/types.ts:20](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/base-contract/src/types.ts#L20)*

<hr />

# Enumeration: ChainId


##  Enumeration members

###  Ganache

• **Ganache**: = 1337

*Defined in [contract-addresses/src/index.ts:36](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/contract-addresses/src/index.ts#L36)*

___

###  Kovan

• **Kovan**: = 42

*Defined in [contract-addresses/src/index.ts:35](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/contract-addresses/src/index.ts#L35)*

___

###  Mainnet

• **Mainnet**: = 1

*Defined in [contract-addresses/src/index.ts:32](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/contract-addresses/src/index.ts#L32)*

___

###  Rinkeby

• **Rinkeby**: = 4

*Defined in [contract-addresses/src/index.ts:34](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/contract-addresses/src/index.ts#L34)*

___

###  Ropsten

• **Ropsten**: = 3

*Defined in [contract-addresses/src/index.ts:33](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/contract-addresses/src/index.ts#L33)*

<hr />



# Enumeration: BlockParamLiteral


##  Enumeration members

###  Earliest

• **Earliest**: = "earliest"

*Defined in [ethereum-types/src/index.ts:479](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/ethereum-types/src/index.ts#L479)*

___

###  Latest

• **Latest**: = "latest"

*Defined in [ethereum-types/src/index.ts:480](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/ethereum-types/src/index.ts#L480)*

___

###  Pending

• **Pending**: = "pending"

*Defined in [ethereum-types/src/index.ts:481](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/ethereum-types/src/index.ts#L481)*

<hr />











# Enumeration: AssetProxyId


##  Enumeration members

###  ERC1155

• **ERC1155**: = "0xa7cb5fb7"

*Defined in [types/src/index.ts:166](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/types/src/index.ts#L166)*

___

###  ERC20

• **ERC20**: = "0xf47261b0"

*Defined in [types/src/index.ts:163](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/types/src/index.ts#L163)*

___

###  ERC20Bridge

• **ERC20Bridge**: = "0xdc1600f3"

*Defined in [types/src/index.ts:168](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/types/src/index.ts#L168)*

___

###  ERC721

• **ERC721**: = "0x02571792"

*Defined in [types/src/index.ts:164](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/types/src/index.ts#L164)*

___

###  MultiAsset

• **MultiAsset**: = "0x94cfcdd7"

*Defined in [types/src/index.ts:165](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/types/src/index.ts#L165)*

___

###  StaticCall

• **StaticCall**: = "0xc339d10a"

*Defined in [types/src/index.ts:167](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/types/src/index.ts#L167)*

<hr />













# Enumeration: SignatureType


##  Enumeration members

###  EIP1271Wallet

• **EIP1271Wallet**:

*Defined in [types/src/index.ts:158](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/types/src/index.ts#L158)*

___

###  EIP712

• **EIP712**:

*Defined in [types/src/index.ts:153](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/types/src/index.ts#L153)*

___

###  EthSign

• **EthSign**:

*Defined in [types/src/index.ts:154](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/types/src/index.ts#L154)*

___

###  Illegal

• **Illegal**:

*Defined in [types/src/index.ts:151](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/types/src/index.ts#L151)*

___

###  Invalid

• **Invalid**:

*Defined in [types/src/index.ts:152](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/types/src/index.ts#L152)*

___

###  NSignatureTypes

• **NSignatureTypes**:

*Defined in [types/src/index.ts:159](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/types/src/index.ts#L159)*

___

###  PreSigned

• **PreSigned**:

*Defined in [types/src/index.ts:157](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/types/src/index.ts#L157)*

___

###  Validator

• **Validator**:

*Defined in [types/src/index.ts:156](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/types/src/index.ts#L156)*

___

###  Wallet

• **Wallet**:

*Defined in [types/src/index.ts:155](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/types/src/index.ts#L155)*

<hr />









# Interface: ERC20TokenApprovalEventArgs


##   Index

### Properties

* [_owner](#_owner)
* [_spender](#_spender)
* [_value](#_value)

## Properties

###  _owner

• **_owner**: *string*

*Defined in [abi-gen-wrappers/src/generated-wrappers/erc20_token.ts:51](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/erc20_token.ts#L51)*

___

###  _spender

• **_spender**: *string*

*Defined in [abi-gen-wrappers/src/generated-wrappers/erc20_token.ts:52](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/erc20_token.ts#L52)*

___

###  _value

• **_value**: *`BigNumber`*

*Defined in [abi-gen-wrappers/src/generated-wrappers/erc20_token.ts:53](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/erc20_token.ts#L53)*

<hr />

# Interface: ERC20TokenTransferEventArgs


##   Index

### Properties

* [_from](#_from)
* [_to](#_to)
* [_value](#_value)

## Properties

###  _from

• **_from**: *string*

*Defined in [abi-gen-wrappers/src/generated-wrappers/erc20_token.ts:45](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/erc20_token.ts#L45)*

___

###  _to

• **_to**: *string*

*Defined in [abi-gen-wrappers/src/generated-wrappers/erc20_token.ts:46](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/erc20_token.ts#L46)*

___

###  _value

• **_value**: *`BigNumber`*

*Defined in [abi-gen-wrappers/src/generated-wrappers/erc20_token.ts:47](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/erc20_token.ts#L47)*

<hr />

# Interface: ERC721TokenApprovalEventArgs


##   Index

### Properties

* [_approved](#_approved)
* [_owner](#_owner)
* [_tokenId](#_tokenid)

## Properties

###  _approved

• **_approved**: *string*

*Defined in [abi-gen-wrappers/src/generated-wrappers/erc721_token.ts:50](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/erc721_token.ts#L50)*

___

###  _owner

• **_owner**: *string*

*Defined in [abi-gen-wrappers/src/generated-wrappers/erc721_token.ts:49](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/erc721_token.ts#L49)*

___

###  _tokenId

• **_tokenId**: *`BigNumber`*

*Defined in [abi-gen-wrappers/src/generated-wrappers/erc721_token.ts:51](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/erc721_token.ts#L51)*

<hr />

# Interface: ERC721TokenApprovalForAllEventArgs


##   Index

### Properties

* [_approved](#_approved)
* [_operator](#_operator)
* [_owner](#_owner)

## Properties

###  _approved

• **_approved**: *boolean*

*Defined in [abi-gen-wrappers/src/generated-wrappers/erc721_token.ts:57](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/erc721_token.ts#L57)*

___

###  _operator

• **_operator**: *string*

*Defined in [abi-gen-wrappers/src/generated-wrappers/erc721_token.ts:56](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/erc721_token.ts#L56)*

___

###  _owner

• **_owner**: *string*

*Defined in [abi-gen-wrappers/src/generated-wrappers/erc721_token.ts:55](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/erc721_token.ts#L55)*

<hr />

# Interface: ERC721TokenTransferEventArgs


##   Index

### Properties

* [_from](#_from)
* [_to](#_to)
* [_tokenId](#_tokenid)

## Properties

###  _from

• **_from**: *string*

*Defined in [abi-gen-wrappers/src/generated-wrappers/erc721_token.ts:61](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/erc721_token.ts#L61)*

___

###  _to

• **_to**: *string*

*Defined in [abi-gen-wrappers/src/generated-wrappers/erc721_token.ts:62](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/erc721_token.ts#L62)*

___

###  _tokenId

• **_tokenId**: *`BigNumber`*

*Defined in [abi-gen-wrappers/src/generated-wrappers/erc721_token.ts:63](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/erc721_token.ts#L63)*

<hr />

# Interface: ExchangeAssetProxyRegisteredEventArgs


##   Index

### Properties

* [assetProxy](#assetproxy)
* [id](#id)

## Properties

###  assetProxy

• **assetProxy**: *string*

*Defined in [abi-gen-wrappers/src/generated-wrappers/exchange.ts:60](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/exchange.ts#L60)*

___

###  id

• **id**: *string*

*Defined in [abi-gen-wrappers/src/generated-wrappers/exchange.ts:59](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/exchange.ts#L59)*

<hr />

# Interface: ExchangeCancelEventArgs


##   Index

### Properties

* [feeRecipientAddress](#feerecipientaddress)
* [makerAddress](#makeraddress)
* [makerAssetData](#makerassetdata)
* [orderHash](#orderhash)
* [senderAddress](#senderaddress)
* [takerAssetData](#takerassetdata)

## Properties

###  feeRecipientAddress

• **feeRecipientAddress**: *string*

*Defined in [abi-gen-wrappers/src/generated-wrappers/exchange.ts:65](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/exchange.ts#L65)*

___

###  makerAddress

• **makerAddress**: *string*

*Defined in [abi-gen-wrappers/src/generated-wrappers/exchange.ts:64](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/exchange.ts#L64)*

___

###  makerAssetData

• **makerAssetData**: *string*

*Defined in [abi-gen-wrappers/src/generated-wrappers/exchange.ts:66](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/exchange.ts#L66)*

___

###  orderHash

• **orderHash**: *string*

*Defined in [abi-gen-wrappers/src/generated-wrappers/exchange.ts:69](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/exchange.ts#L69)*

___

###  senderAddress

• **senderAddress**: *string*

*Defined in [abi-gen-wrappers/src/generated-wrappers/exchange.ts:68](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/exchange.ts#L68)*

___

###  takerAssetData

• **takerAssetData**: *string*

*Defined in [abi-gen-wrappers/src/generated-wrappers/exchange.ts:67](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/exchange.ts#L67)*

<hr />

# Interface: ExchangeCancelUpToEventArgs


##   Index

### Properties

* [makerAddress](#makeraddress)
* [orderEpoch](#orderepoch)
* [orderSenderAddress](#ordersenderaddress)

## Properties

###  makerAddress

• **makerAddress**: *string*

*Defined in [abi-gen-wrappers/src/generated-wrappers/exchange.ts:73](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/exchange.ts#L73)*

___

###  orderEpoch

• **orderEpoch**: *`BigNumber`*

*Defined in [abi-gen-wrappers/src/generated-wrappers/exchange.ts:75](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/exchange.ts#L75)*

___

###  orderSenderAddress

• **orderSenderAddress**: *string*

*Defined in [abi-gen-wrappers/src/generated-wrappers/exchange.ts:74](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/exchange.ts#L74)*

<hr />

# Interface: ExchangeFillEventArgs


##   Index

### Properties

* [feeRecipientAddress](#feerecipientaddress)
* [makerAddress](#makeraddress)
* [makerAssetData](#makerassetdata)
* [makerAssetFilledAmount](#makerassetfilledamount)
* [makerFeeAssetData](#makerfeeassetdata)
* [makerFeePaid](#makerfeepaid)
* [orderHash](#orderhash)
* [protocolFeePaid](#protocolfeepaid)
* [senderAddress](#senderaddress)
* [takerAddress](#takeraddress)
* [takerAssetData](#takerassetdata)
* [takerAssetFilledAmount](#takerassetfilledamount)
* [takerFeeAssetData](#takerfeeassetdata)
* [takerFeePaid](#takerfeepaid)

## Properties

###  feeRecipientAddress

• **feeRecipientAddress**: *string*

*Defined in [abi-gen-wrappers/src/generated-wrappers/exchange.ts:80](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/exchange.ts#L80)*

___

###  makerAddress

• **makerAddress**: *string*

*Defined in [abi-gen-wrappers/src/generated-wrappers/exchange.ts:79](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/exchange.ts#L79)*

___

###  makerAssetData

• **makerAssetData**: *string*

*Defined in [abi-gen-wrappers/src/generated-wrappers/exchange.ts:81](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/exchange.ts#L81)*

___

###  makerAssetFilledAmount

• **makerAssetFilledAmount**: *`BigNumber`*

*Defined in [abi-gen-wrappers/src/generated-wrappers/exchange.ts:88](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/exchange.ts#L88)*

___

###  makerFeeAssetData

• **makerFeeAssetData**: *string*

*Defined in [abi-gen-wrappers/src/generated-wrappers/exchange.ts:83](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/exchange.ts#L83)*

___

###  makerFeePaid

• **makerFeePaid**: *`BigNumber`*

*Defined in [abi-gen-wrappers/src/generated-wrappers/exchange.ts:90](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/exchange.ts#L90)*

___

###  orderHash

• **orderHash**: *string*

*Defined in [abi-gen-wrappers/src/generated-wrappers/exchange.ts:85](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/exchange.ts#L85)*

___

###  protocolFeePaid

• **protocolFeePaid**: *`BigNumber`*

*Defined in [abi-gen-wrappers/src/generated-wrappers/exchange.ts:92](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/exchange.ts#L92)*

___

###  senderAddress

• **senderAddress**: *string*

*Defined in [abi-gen-wrappers/src/generated-wrappers/exchange.ts:87](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/exchange.ts#L87)*

___

###  takerAddress

• **takerAddress**: *string*

*Defined in [abi-gen-wrappers/src/generated-wrappers/exchange.ts:86](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/exchange.ts#L86)*

___

###  takerAssetData

• **takerAssetData**: *string*

*Defined in [abi-gen-wrappers/src/generated-wrappers/exchange.ts:82](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/exchange.ts#L82)*

___

###  takerAssetFilledAmount

• **takerAssetFilledAmount**: *`BigNumber`*

*Defined in [abi-gen-wrappers/src/generated-wrappers/exchange.ts:89](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/exchange.ts#L89)*

___

###  takerFeeAssetData

• **takerFeeAssetData**: *string*

*Defined in [abi-gen-wrappers/src/generated-wrappers/exchange.ts:84](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/exchange.ts#L84)*

___

###  takerFeePaid

• **takerFeePaid**: *`BigNumber`*

*Defined in [abi-gen-wrappers/src/generated-wrappers/exchange.ts:91](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/exchange.ts#L91)*

<hr />

# Interface: ExchangeProtocolFeeCollectorAddressEventArgs


##   Index

### Properties

* [oldProtocolFeeCollector](#oldprotocolfeecollector)
* [updatedProtocolFeeCollector](#updatedprotocolfeecollector)

## Properties

###  oldProtocolFeeCollector

• **oldProtocolFeeCollector**: *string*

*Defined in [abi-gen-wrappers/src/generated-wrappers/exchange.ts:96](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/exchange.ts#L96)*

___

###  updatedProtocolFeeCollector

• **updatedProtocolFeeCollector**: *string*

*Defined in [abi-gen-wrappers/src/generated-wrappers/exchange.ts:97](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/exchange.ts#L97)*

<hr />

# Interface: ExchangeProtocolFeeMultiplierEventArgs


##   Index

### Properties

* [oldProtocolFeeMultiplier](#oldprotocolfeemultiplier)
* [updatedProtocolFeeMultiplier](#updatedprotocolfeemultiplier)

## Properties

###  oldProtocolFeeMultiplier

• **oldProtocolFeeMultiplier**: *`BigNumber`*

*Defined in [abi-gen-wrappers/src/generated-wrappers/exchange.ts:101](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/exchange.ts#L101)*

___

###  updatedProtocolFeeMultiplier

• **updatedProtocolFeeMultiplier**: *`BigNumber`*

*Defined in [abi-gen-wrappers/src/generated-wrappers/exchange.ts:102](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/exchange.ts#L102)*

<hr />

# Interface: ExchangeSignatureValidatorApprovalEventArgs


##   Index

### Properties

* [isApproved](#isapproved)
* [signerAddress](#signeraddress)
* [validatorAddress](#validatoraddress)

## Properties

###  isApproved

• **isApproved**: *boolean*

*Defined in [abi-gen-wrappers/src/generated-wrappers/exchange.ts:108](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/exchange.ts#L108)*

___

###  signerAddress

• **signerAddress**: *string*

*Defined in [abi-gen-wrappers/src/generated-wrappers/exchange.ts:106](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/exchange.ts#L106)*

___

###  validatorAddress

• **validatorAddress**: *string*

*Defined in [abi-gen-wrappers/src/generated-wrappers/exchange.ts:107](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/exchange.ts#L107)*

<hr />

# Interface: ExchangeTransactionExecutionEventArgs


##   Index

### Properties

* [transactionHash](#transactionhash)

## Properties

###  transactionHash

• **transactionHash**: *string*

*Defined in [abi-gen-wrappers/src/generated-wrappers/exchange.ts:112](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/exchange.ts#L112)*

<hr />

# Interface: WETH9ApprovalEventArgs


##   Index

### Properties

* [_owner](#_owner)
* [_spender](#_spender)
* [_value](#_value)

## Properties

###  _owner

• **_owner**: *string*

*Defined in [abi-gen-wrappers/src/generated-wrappers/weth9.ts:51](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/weth9.ts#L51)*

___

###  _spender

• **_spender**: *string*

*Defined in [abi-gen-wrappers/src/generated-wrappers/weth9.ts:52](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/weth9.ts#L52)*

___

###  _value

• **_value**: *`BigNumber`*

*Defined in [abi-gen-wrappers/src/generated-wrappers/weth9.ts:53](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/weth9.ts#L53)*

<hr />

# Interface: WETH9DepositEventArgs


##   Index

### Properties

* [_owner](#_owner)
* [_value](#_value)

## Properties

###  _owner

• **_owner**: *string*

*Defined in [abi-gen-wrappers/src/generated-wrappers/weth9.ts:63](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/weth9.ts#L63)*

___

###  _value

• **_value**: *`BigNumber`*

*Defined in [abi-gen-wrappers/src/generated-wrappers/weth9.ts:64](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/weth9.ts#L64)*

<hr />

# Interface: WETH9TransferEventArgs


##   Index

### Properties

* [_from](#_from)
* [_to](#_to)
* [_value](#_value)

## Properties

###  _from

• **_from**: *string*

*Defined in [abi-gen-wrappers/src/generated-wrappers/weth9.ts:57](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/weth9.ts#L57)*

___

###  _to

• **_to**: *string*

*Defined in [abi-gen-wrappers/src/generated-wrappers/weth9.ts:58](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/weth9.ts#L58)*

___

###  _value

• **_value**: *`BigNumber`*

*Defined in [abi-gen-wrappers/src/generated-wrappers/weth9.ts:59](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/weth9.ts#L59)*

<hr />

# Interface: WETH9WithdrawalEventArgs


##   Index

### Properties

* [_owner](#_owner)
* [_value](#_value)

## Properties

###  _owner

• **_owner**: *string*

*Defined in [abi-gen-wrappers/src/generated-wrappers/weth9.ts:68](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/weth9.ts#L68)*

___

###  _value

• **_value**: *`BigNumber`*

*Defined in [abi-gen-wrappers/src/generated-wrappers/weth9.ts:69](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/weth9.ts#L69)*

<hr />

# Interface: AwaitTransactionSuccessOpts

Used with `awaitTransactionSuccessAsync`
* pollingIntervalMs: Determine polling intervals in milliseconds
* timeoutMs: Determines timeout in milliseconds


##   Properties

### `Optional` pollingIntervalMs

• **pollingIntervalMs**? : *undefined | number*

*Defined in [base-contract/src/types.ts:39](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/base-contract/src/types.ts#L39)*

___

### `Optional` shouldValidate

• **shouldValidate**? : *undefined | false | true*

*Inherited from [SendTransactionOpts](#interface-sendtransactionopts).[shouldValidate](#optional-shouldvalidate)*

*Defined in [base-contract/src/types.ts:30](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/base-contract/src/types.ts#L30)*

___

### `Optional` timeoutMs

• **timeoutMs**? : *undefined | number*

*Defined in [base-contract/src/types.ts:40](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/base-contract/src/types.ts#L40)*

<hr />

# Interface: ContractEvent <**ContractEventArgs**>

## Type parameters

▪ **ContractEventArgs**


##   Properties

###  address

• **address**: *string*

*Defined in [base-contract/src/types.ts:13](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/base-contract/src/types.ts#L13)*

___

###  args

• **args**: *`ContractEventArgs`*

*Defined in [base-contract/src/types.ts:16](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/base-contract/src/types.ts#L16)*

___

###  blockHash

• **blockHash**: *string*

*Defined in [base-contract/src/types.ts:11](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/base-contract/src/types.ts#L11)*

___

###  blockNumber

• **blockNumber**: *number*

*Defined in [base-contract/src/types.ts:12](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/base-contract/src/types.ts#L12)*

___

###  event

• **event**: *string*

*Defined in [base-contract/src/types.ts:15](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/base-contract/src/types.ts#L15)*

___

###  logIndex

• **logIndex**: *number*

*Defined in [base-contract/src/types.ts:8](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/base-contract/src/types.ts#L8)*

___

###  transactionHash

• **transactionHash**: *string*

*Defined in [base-contract/src/types.ts:10](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/base-contract/src/types.ts#L10)*

___

###  transactionIndex

• **transactionIndex**: *number*

*Defined in [base-contract/src/types.ts:9](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/base-contract/src/types.ts#L9)*

___

###  type

• **type**: *string*

*Defined in [base-contract/src/types.ts:14](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/base-contract/src/types.ts#L14)*

<hr />

# Interface: ContractFunctionObj <**T**>

## Type parameters

▪ **T**


##   Methods

###  callAsync

▸ **callAsync**(`callData?`: `Partial<CallData>`, `defaultBlock?`: [BlockParam](#blockparam)): *`Promise<T>`*

*Defined in [base-contract/src/types.ts:44](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/base-contract/src/types.ts#L44)*

**Parameters:**

Name | Type |
------ | ------ |
`callData?` | `Partial<CallData>` |
`defaultBlock?` | [BlockParam](#blockparam) |

**Returns:** *`Promise<T>`*

___

###  getABIEncodedTransactionData

▸ **getABIEncodedTransactionData**(): *string*

*Defined in [base-contract/src/types.ts:45](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/base-contract/src/types.ts#L45)*

**Returns:** *string*

<hr />

# Interface: ContractTxFunctionObj <**T**>

## Type parameters

▪ **T**


##   Methods

###  awaitTransactionSuccessAsync

▸ **awaitTransactionSuccessAsync**(`txData?`: `Partial<TxData>`, `opts?`: [AwaitTransactionSuccessOpts](#class-awaittransactionsuccessopts)): *`PromiseWithTransactionHash<TransactionReceiptWithDecodedLogs>`*

*Defined in [base-contract/src/types.ts:50](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/base-contract/src/types.ts#L50)*

**Parameters:**

Name | Type |
------ | ------ |
`txData?` | `Partial<TxData>` |
`opts?` | [AwaitTransactionSuccessOpts](#class-awaittransactionsuccessopts) |

**Returns:** *`PromiseWithTransactionHash<TransactionReceiptWithDecodedLogs>`*

___

###  callAsync

▸ **callAsync**(`callData?`: `Partial<CallData>`, `defaultBlock?`: [BlockParam](#blockparam)): *`Promise<T>`*

*Inherited from [ContractFunctionObj](#interface-contractfunctionobj).[callAsync](#callasync)*

*Defined in [base-contract/src/types.ts:44](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/base-contract/src/types.ts#L44)*

**Parameters:**

Name | Type |
------ | ------ |
`callData?` | `Partial<CallData>` |
`defaultBlock?` | [BlockParam](#blockparam) |

**Returns:** *`Promise<T>`*

___

###  estimateGasAsync

▸ **estimateGasAsync**(`txData?`: `Partial<TxData>`): *`Promise<number>`*

*Defined in [base-contract/src/types.ts:54](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/base-contract/src/types.ts#L54)*

**Parameters:**

Name | Type |
------ | ------ |
`txData?` | `Partial<TxData>` |

**Returns:** *`Promise<number>`*

___

###  getABIEncodedTransactionData

▸ **getABIEncodedTransactionData**(): *string*

*Inherited from [ContractFunctionObj](#interface-contractfunctionobj).[getABIEncodedTransactionData](#getabiencodedtransactiondata)*

*Defined in [base-contract/src/types.ts:45](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/base-contract/src/types.ts#L45)*

**Returns:** *string*

___

###  sendTransactionAsync

▸ **sendTransactionAsync**(`txData?`: `Partial<TxData>`, `opts?`: [SendTransactionOpts](#class-sendtransactionopts)): *`Promise<string>`*

*Defined in [base-contract/src/types.ts:49](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/base-contract/src/types.ts#L49)*

**Parameters:**

Name | Type |
------ | ------ |
`txData?` | `Partial<TxData>` |
`opts?` | [SendTransactionOpts](#class-sendtransactionopts) |

**Returns:** *`Promise<string>`*

<hr />



# Interface: ContractAddresses


##   Properties

###  assetProxyOwner

• **assetProxyOwner**: *string*

*Defined in [contract-addresses/src/index.ts:12](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/contract-addresses/src/index.ts#L12)*

___

###  coordinator

• **coordinator**: *string*

*Defined in [contract-addresses/src/index.ts:18](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/contract-addresses/src/index.ts#L18)*

___

###  coordinatorRegistry

• **coordinatorRegistry**: *string*

*Defined in [contract-addresses/src/index.ts:17](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/contract-addresses/src/index.ts#L17)*

___

###  devUtils

• **devUtils**: *string*

*Defined in [contract-addresses/src/index.ts:22](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/contract-addresses/src/index.ts#L22)*

___

###  dutchAuction

• **dutchAuction**: *string*

*Defined in [contract-addresses/src/index.ts:16](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/contract-addresses/src/index.ts#L16)*

___

###  erc1155Proxy

• **erc1155Proxy**: *string*

*Defined in [contract-addresses/src/index.ts:21](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/contract-addresses/src/index.ts#L21)*

___

###  erc20BridgeProxy

• **erc20BridgeProxy**: *string*

*Defined in [contract-addresses/src/index.ts:26](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/contract-addresses/src/index.ts#L26)*

___

###  erc20Proxy

• **erc20Proxy**: *string*

*Defined in [contract-addresses/src/index.ts:6](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/contract-addresses/src/index.ts#L6)*

___

###  erc721Proxy

• **erc721Proxy**: *string*

*Defined in [contract-addresses/src/index.ts:7](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/contract-addresses/src/index.ts#L7)*

___

###  eth2DaiBridge

• **eth2DaiBridge**: *string*

*Defined in [contract-addresses/src/index.ts:28](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/contract-addresses/src/index.ts#L28)*

___

###  etherToken

• **etherToken**: *string*

*Defined in [contract-addresses/src/index.ts:9](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/contract-addresses/src/index.ts#L9)*

___

###  exchange

• **exchange**: *string*

*Defined in [contract-addresses/src/index.ts:11](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/contract-addresses/src/index.ts#L11)*

___

###  exchangeV2

• **exchangeV2**: *string*

*Defined in [contract-addresses/src/index.ts:10](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/contract-addresses/src/index.ts#L10)*

___

###  forwarder

• **forwarder**: *string*

*Defined in [contract-addresses/src/index.ts:14](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/contract-addresses/src/index.ts#L14)*

___

###  multiAssetProxy

• **multiAssetProxy**: *string*

*Defined in [contract-addresses/src/index.ts:19](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/contract-addresses/src/index.ts#L19)*

___

###  orderValidator

• **orderValidator**: *string*

*Defined in [contract-addresses/src/index.ts:15](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/contract-addresses/src/index.ts#L15)*

___

###  staking

• **staking**: *string*

*Defined in [contract-addresses/src/index.ts:24](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/contract-addresses/src/index.ts#L24)*

___

###  stakingProxy

• **stakingProxy**: *string*

*Defined in [contract-addresses/src/index.ts:25](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/contract-addresses/src/index.ts#L25)*

___

###  staticCallProxy

• **staticCallProxy**: *string*

*Defined in [contract-addresses/src/index.ts:20](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/contract-addresses/src/index.ts#L20)*

___

###  uniswapBridge

• **uniswapBridge**: *string*

*Defined in [contract-addresses/src/index.ts:27](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/contract-addresses/src/index.ts#L27)*

___

###  zeroExGovernor

• **zeroExGovernor**: *string*

*Defined in [contract-addresses/src/index.ts:13](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/contract-addresses/src/index.ts#L13)*

___

###  zrxToken

• **zrxToken**: *string*

*Defined in [contract-addresses/src/index.ts:8](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/contract-addresses/src/index.ts#L8)*

___

###  zrxVault

• **zrxVault**: *string*

*Defined in [contract-addresses/src/index.ts:23](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/contract-addresses/src/index.ts#L23)*

<hr />



# Interface: BlockRange


##   Properties

###  fromBlock

• **fromBlock**: *[BlockParam](#blockparam)*

*Defined in [ethereum-types/src/index.ts:743](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/ethereum-types/src/index.ts#L743)*

___

###  toBlock

• **toBlock**: *[BlockParam](#blockparam)*

*Defined in [ethereum-types/src/index.ts:744](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/ethereum-types/src/index.ts#L744)*

<hr />





# Interface: CallData


##   Properties

### `Optional` data

• **data**? : *undefined | string*

*Inherited from [CallTxDataBase](#interface-calltxdatabase).[data](#optional-data)*

*Defined in [ethereum-types/src/index.ts:394](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/ethereum-types/src/index.ts#L394)*

___

### `Optional` from

• **from**? : *undefined | string*

*Defined in [ethereum-types/src/index.ts:403](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/ethereum-types/src/index.ts#L403)*

___

### `Optional` gas

• **gas**? : *number | string | `BigNumber`*

*Inherited from [CallTxDataBase](#interface-calltxdatabase).[gas](#optional-gas)*

*Defined in [ethereum-types/src/index.ts:392](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/ethereum-types/src/index.ts#L392)*

___

### `Optional` gasPrice

• **gasPrice**? : *number | string | `BigNumber`*

*Inherited from [CallTxDataBase](#interface-calltxdatabase).[gasPrice](#optional-gasprice)*

*Defined in [ethereum-types/src/index.ts:393](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/ethereum-types/src/index.ts#L393)*

___

### `Optional` nonce

• **nonce**? : *undefined | number*

*Inherited from [CallTxDataBase](#interface-calltxdatabase).[nonce](#optional-nonce)*

*Defined in [ethereum-types/src/index.ts:395](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/ethereum-types/src/index.ts#L395)*

___

### `Optional` to

• **to**? : *undefined | string*

*Inherited from [CallTxDataBase](#interface-calltxdatabase).[to](#optional-to)*

*Defined in [ethereum-types/src/index.ts:390](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/ethereum-types/src/index.ts#L390)*

___

### `Optional` value

• **value**? : *number | string | `BigNumber`*

*Inherited from [CallTxDataBase](#interface-calltxdatabase).[value](#optional-value)*

*Defined in [ethereum-types/src/index.ts:391](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/ethereum-types/src/index.ts#L391)*

<hr />





# Interface: CompilerOpts


##   Properties

###  name

• **name**: *"solc"*

*Defined in [ethereum-types/src/index.ts:656](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/ethereum-types/src/index.ts#L656)*

___

###  settings

• **settings**: *[CompilerSettings](#class-compilersettings)*

*Defined in [ethereum-types/src/index.ts:658](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/ethereum-types/src/index.ts#L658)*

___

###  version

• **version**: *string*

*Defined in [ethereum-types/src/index.ts:657](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/ethereum-types/src/index.ts#L657)*

<hr />

# Interface: CompilerSettings


##   Properties

### `Optional` evmVersion

• **evmVersion**? : *"homestead" | "tangerineWhistle" | "spuriousDragon" | "byzantium" | "constantinople"*

*Defined in [ethereum-types/src/index.ts:690](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/ethereum-types/src/index.ts#L690)*

___

### `Optional` libraries

• **libraries**? : *undefined | object*

*Defined in [ethereum-types/src/index.ts:692](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/ethereum-types/src/index.ts#L692)*

___

### `Optional` metadata

• **metadata**? : *[CompilerSettingsMetadata](#class-compilersettingsmetadata)*

*Defined in [ethereum-types/src/index.ts:691](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/ethereum-types/src/index.ts#L691)*

___

### `Optional` optimizer

• **optimizer**? : *[OptimizerSettings](#class-optimizersettings)*

*Defined in [ethereum-types/src/index.ts:689](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/ethereum-types/src/index.ts#L689)*

___

###  outputSelection

• **outputSelection**: *object*

*Defined in [ethereum-types/src/index.ts:697](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/ethereum-types/src/index.ts#L697)*

#### Type declaration:

● \[▪ **fileName**: *string*\]: object

● \[▪ **contractName**: *string*\]: [OutputField](#outputfield)[]

___

### `Optional` remappings

• **remappings**? : *string[]*

*Defined in [ethereum-types/src/index.ts:688](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/ethereum-types/src/index.ts#L688)*

<hr />

# Interface: CompilerSettingsMetadata


##   Properties

###  useLiteralContent

• **useLiteralContent**: *true*

*Defined in [ethereum-types/src/index.ts:705](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/ethereum-types/src/index.ts#L705)*

<hr />

# Interface: ConstructorAbi


##   Properties

###  inputs

• **inputs**: *[DataItem](#class-dataitem)[]*

*Defined in [ethereum-types/src/index.ts:103](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/ethereum-types/src/index.ts#L103)*

___

###  payable

• **payable**: *boolean*

*Defined in [ethereum-types/src/index.ts:104](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/ethereum-types/src/index.ts#L104)*

___

###  stateMutability

• **stateMutability**: *[ConstructorStateMutability](#constructorstatemutability)*

*Defined in [ethereum-types/src/index.ts:105](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/ethereum-types/src/index.ts#L105)*

___

###  type

• **type**: *string*

*Defined in [ethereum-types/src/index.ts:102](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/ethereum-types/src/index.ts#L102)*

<hr />

# Interface: ContractArtifact

This type defines the schema of the artifact.json file generated by Sol-compiler
schemaVersion: The version of the artifact schema
contractName: The contract name it represents
chains: Chain specific information by chain (address, id, constructor args, etc...)
compilerOutput: The Solidity compiler output generated from the specified compiler input
description (http://solidity.readthedocs.io/en/v0.4.24/using-the-compiler.html#compiler-input-and-output-json-description)
compiler: The compiler settings used
sourceCodes: The source code of the contract and all it's dependencies
sources: A mapping from source filePath to sourceMap id
sourceTreeHashHex: A unique hash generated from the contract source and that of it's dependencies.
If any of the sources change, the hash would change notifying us that a re-compilation is necessary


##   Properties

###  chains

• **chains**: *[ContractChains](#class-contractchains)*

*Defined in [ethereum-types/src/index.ts:677](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/ethereum-types/src/index.ts#L677)*

___

###  compiler

• **compiler**: *[CompilerOpts](#class-compileropts)*

*Inherited from [ContractVersionData](#interface-contractversiondata).[compiler](#compiler)*

*Defined in [ethereum-types/src/index.ts:642](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/ethereum-types/src/index.ts#L642)*

___

###  compilerOutput

• **compilerOutput**: *[StandardContractOutput](#class-standardcontractoutput)*

*Inherited from [ContractVersionData](#interface-contractversiondata).[compilerOutput](#compileroutput)*

*Defined in [ethereum-types/src/index.ts:652](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/ethereum-types/src/index.ts#L652)*

___

###  contractName

• **contractName**: *string*

*Defined in [ethereum-types/src/index.ts:676](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/ethereum-types/src/index.ts#L676)*

___

###  schemaVersion

• **schemaVersion**: *string*

*Defined in [ethereum-types/src/index.ts:675](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/ethereum-types/src/index.ts#L675)*

___

###  sourceCodes

• **sourceCodes**: *object*

*Inherited from [ContractVersionData](#interface-contractversiondata).[sourceCodes](#sourcecodes)*

*Defined in [ethereum-types/src/index.ts:648](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/ethereum-types/src/index.ts#L648)*

#### Type declaration:

● \[▪ **sourceName**: *string*\]: string

___

###  sourceTreeHashHex

• **sourceTreeHashHex**: *string*

*Inherited from [ContractVersionData](#interface-contractversiondata).[sourceTreeHashHex](#sourcetreehashhex)*

*Defined in [ethereum-types/src/index.ts:651](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/ethereum-types/src/index.ts#L651)*

___

###  sources

• **sources**: *object*

*Inherited from [ContractVersionData](#interface-contractversiondata).[sources](#sources)*

*Defined in [ethereum-types/src/index.ts:643](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/ethereum-types/src/index.ts#L643)*

#### Type declaration:

● \[▪ **sourceName**: *string*\]: object

<hr />

# Interface: ContractChainData


##   Properties

###  address

• **address**: *string*

*Defined in [ethereum-types/src/index.ts:555](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/ethereum-types/src/index.ts#L555)*

___

Args

• **constructorArgs**: *string*

*Defined in [ethereum-types/src/index.ts:559](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/ethereum-types/src/index.ts#L559)*

___

###  links

• **links**: *object*

*Defined in [ethereum-types/src/index.ts:556](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/ethereum-types/src/index.ts#L556)*

#### Type declaration:

● \[▪ **linkName**: *string*\]: string

<hr />

# Interface: ContractChains


##  Hierarchy

* **ContractVersionData**

  * [ContractArtifact](#class-contractartifact)


##  Properties

###  compiler

• **compiler**: *[CompilerOpts](#class-compileropts)*

*Defined in [ethereum-types/src/index.ts:642](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/ethereum-types/src/index.ts#L642)*

___

###  compilerOutput

• **compilerOutput**: *[StandardContractOutput](#class-standardcontractoutput)*

*Defined in [ethereum-types/src/index.ts:652](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/ethereum-types/src/index.ts#L652)*

___

###  sourceCodes

• **sourceCodes**: *object*

*Defined in [ethereum-types/src/index.ts:648](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/ethereum-types/src/index.ts#L648)*

#### Type declaration:

● \[▪ **sourceName**: *string*\]: string

___

###  sourceTreeHashHex

• **sourceTreeHashHex**: *string*

*Defined in [ethereum-types/src/index.ts:651](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/ethereum-types/src/index.ts#L651)*

___

###  sources

• **sources**: *object*

*Defined in [ethereum-types/src/index.ts:643](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/ethereum-types/src/index.ts#L643)*

#### Type declaration:

● \[▪ **sourceName**: *string*\]: object

<hr />

# Interface: DataItem


##   Properties

### `Optional` components

• **components**? : *[DataItem](#class-dataitem)[]*

*Defined in [ethereum-types/src/index.ts:138](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/ethereum-types/src/index.ts#L138)*

___

### `Optional` internalType

• **internalType**? : *undefined | string*

*Defined in [ethereum-types/src/index.ts:137](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/ethereum-types/src/index.ts#L137)*

___

###  name

• **name**: *string*

*Defined in [ethereum-types/src/index.ts:135](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/ethereum-types/src/index.ts#L135)*

___

###  type

• **type**: *string*

*Defined in [ethereum-types/src/index.ts:136](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/ethereum-types/src/index.ts#L136)*

<hr />

# Interface: DecodedLogArgs


##  Type parameters

▪ **A**


##   Properties

###  address

• **address**: *string*

*Inherited from [LogEntry](#interface-logentry).[address](#address)*

*Defined in [ethereum-types/src/index.ts:435](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/ethereum-types/src/index.ts#L435)*

___

###  args

• **args**: *`A`*

*Defined in [ethereum-types/src/index.ts:418](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/ethereum-types/src/index.ts#L418)*

___

###  blockHash

• **blockHash**: *string | null*

*Inherited from [LogEntry](#interface-logentry).[blockHash](#blockhash)*

*Defined in [ethereum-types/src/index.ts:433](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/ethereum-types/src/index.ts#L433)*

___

###  blockNumber

• **blockNumber**: *number | null*

*Inherited from [LogEntry](#interface-logentry).[blockNumber](#blocknumber)*

*Defined in [ethereum-types/src/index.ts:434](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/ethereum-types/src/index.ts#L434)*

___

###  data

• **data**: *string*

*Inherited from [LogEntry](#interface-logentry).[data](#data)*

*Defined in [ethereum-types/src/index.ts:436](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/ethereum-types/src/index.ts#L436)*

___

###  event

• **event**: *string*

*Defined in [ethereum-types/src/index.ts:417](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/ethereum-types/src/index.ts#L417)*

___

###  logIndex

• **logIndex**: *number | null*

*Inherited from [LogEntry](#interface-logentry).[logIndex](#logindex)*

*Defined in [ethereum-types/src/index.ts:430](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/ethereum-types/src/index.ts#L430)*

___

###  topics

• **topics**: *string[]*

*Inherited from [LogEntry](#interface-logentry).[topics](#topics)*

*Defined in [ethereum-types/src/index.ts:437](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/ethereum-types/src/index.ts#L437)*

___

###  transactionHash

• **transactionHash**: *string*

*Inherited from [LogEntry](#interface-logentry).[transactionHash](#transactionhash)*

*Defined in [ethereum-types/src/index.ts:432](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/ethereum-types/src/index.ts#L432)*

___

###  transactionIndex

• **transactionIndex**: *number | null*

*Inherited from [LogEntry](#interface-logentry).[transactionIndex](#transactionindex)*

*Defined in [ethereum-types/src/index.ts:431](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/ethereum-types/src/index.ts#L431)*

<hr />



# Interface: DevdocOutput


##   Properties

### `Optional` author

• **author**? : *undefined | string*

*Defined in [ethereum-types/src/index.ts:629](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/ethereum-types/src/index.ts#L629)*

___

###  methods

• **methods**: *object*

*Defined in [ethereum-types/src/index.ts:630](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/ethereum-types/src/index.ts#L630)*

#### Type declaration:

● \[▪ **signature**: *string*\]: object

___

### `Optional` title

• **title**? : *undefined | string*

*Defined in [ethereum-types/src/index.ts:628](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/ethereum-types/src/index.ts#L628)*

<hr />

# Interface: EIP1193Provider


##   Properties

###  isEIP1193

• **isEIP1193**: *boolean*

*Defined in [ethereum-types/src/index.ts:73](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/ethereum-types/src/index.ts#L73)*

## Methods

###  on

▸ **on**(`event`: [EIP1193Event](#eip1193event), `listener`: function): *this*

*Defined in [ethereum-types/src/index.ts:75](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/ethereum-types/src/index.ts#L75)*

**Parameters:**

▪ **event**: *[EIP1193Event](#eip1193event)*

▪ **listener**: *function*

▸ (`result`: any): *void*

**Parameters:**

Name | Type |
------ | ------ |
`result` | any |

**Returns:** *this*

___

###  send

▸ **send**(`method`: string, `params?`: any[]): *`Promise<any>`*

*Defined in [ethereum-types/src/index.ts:74](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/ethereum-types/src/index.ts#L74)*

**Parameters:**

Name | Type |
------ | ------ |
`method` | string |
`params?` | any[] |

**Returns:** *`Promise<any>`*

<hr />





# Interface: EvmBytecodeOutput


##   Properties

###  object

• **object**: *string*

*Defined in [ethereum-types/src/index.ts:623](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/ethereum-types/src/index.ts#L623)*

___

###  sourceMap

• **sourceMap**: *string*

*Defined in [ethereum-types/src/index.ts:624](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/ethereum-types/src/index.ts#L624)*

<hr />

# Interface: EvmOutput


##   Properties

###  bytecode

• **bytecode**: *[EvmBytecodeOutput](#class-evmbytecodeoutput)*

*Defined in [ethereum-types/src/index.ts:618](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/ethereum-types/src/index.ts#L618)*

___

###  deployedBytecode

• **deployedBytecode**: *[EvmBytecodeOutput](#class-evmbytecodeoutput)*

*Defined in [ethereum-types/src/index.ts:619](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/ethereum-types/src/index.ts#L619)*

<hr />

# Interface: FallbackAbi


##   Properties

###  payable

• **payable**: *boolean*

*Defined in [ethereum-types/src/index.ts:112](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/ethereum-types/src/index.ts#L112)*

___

###  type

• **type**: *string*

*Defined in [ethereum-types/src/index.ts:111](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/ethereum-types/src/index.ts#L111)*

<hr />



# Interface: GanacheProvider


##   Methods

###  sendAsync

▸ **sendAsync**(`payload`: [JSONRPCRequestPayload](_ethereum_types_src_index_.jsonrpcrequestpayload.md), `callback`: [JSONRPCErrorCallback](#jsonrpcerrorcallback)): *void*

*Defined in [ethereum-types/src/index.ts:14](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/ethereum-types/src/index.ts#L14)*

**Parameters:**

Name | Type |
------ | ------ |
`payload` | [JSONRPCRequestPayload](#class-jsonrpcrequestpayload) |
`callback` | [JSONRPCErrorCallback](#jsonrpcerrorcallback) |

**Returns:** *void*

<hr />



# Interface: JSONRPCRequestPayload


##   Properties

###  id

• **id**: *number*

*Defined in [ethereum-types/src/index.ts:331](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/ethereum-types/src/index.ts#L331)*

___

###  jsonrpc

• **jsonrpc**: *string*

*Defined in [ethereum-types/src/index.ts:332](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/ethereum-types/src/index.ts#L332)*

___

###  method

• **method**: *string*

*Defined in [ethereum-types/src/index.ts:330](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/ethereum-types/src/index.ts#L330)*

___

###  params

• **params**: *any[]*

*Defined in [ethereum-types/src/index.ts:329](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/ethereum-types/src/index.ts#L329)*

<hr />

# Interface: JSONRPCResponseError


##   Properties

###  code

• **code**: *number*

*Defined in [ethereum-types/src/index.ts:337](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/ethereum-types/src/index.ts#L337)*

___

###  message

• **message**: *string*

*Defined in [ethereum-types/src/index.ts:336](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/ethereum-types/src/index.ts#L336)*

<hr />

# Interface: JSONRPCResponsePayload


##   Properties

### `Optional` error

• **error**? : *[JSONRPCResponseError](#class-jsonrpcresponseerror)*

*Defined in [ethereum-types/src/index.ts:344](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/ethereum-types/src/index.ts#L344)*

___

###  id

• **id**: *number*

*Defined in [ethereum-types/src/index.ts:342](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/ethereum-types/src/index.ts#L342)*

___

###  jsonrpc

• **jsonrpc**: *string*

*Defined in [ethereum-types/src/index.ts:343](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/ethereum-types/src/index.ts#L343)*

___

###  result

• **result**: *any*

*Defined in [ethereum-types/src/index.ts:341](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/ethereum-types/src/index.ts#L341)*

<hr />





# Interface: LogWithDecodedArgs <**ArgsType**>

## Type parameters

▪ **ArgsType**: *[DecodedLogArgs](#class-decodedlogargs)*


##   Properties

###  address

• **address**: *string*

*Inherited from [LogEntry](#interface-logentry).[address](#address)*

*Defined in [ethereum-types/src/index.ts:435](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/ethereum-types/src/index.ts#L435)*

___

###  args

• **args**: *`ArgsType`*

*Inherited from [DecodedLogEntry](#interface-decodedlogentry).[args](#args)*

*Defined in [ethereum-types/src/index.ts:418](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/ethereum-types/src/index.ts#L418)*

___

###  blockHash

• **blockHash**: *string | null*

*Inherited from [LogEntry](#interface-logentry).[blockHash](#blockhash)*

*Defined in [ethereum-types/src/index.ts:433](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/ethereum-types/src/index.ts#L433)*

___

###  blockNumber

• **blockNumber**: *number | null*

*Inherited from [LogEntry](#interface-logentry).[blockNumber](#blocknumber)*

*Defined in [ethereum-types/src/index.ts:434](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/ethereum-types/src/index.ts#L434)*

___

###  data

• **data**: *string*

*Inherited from [LogEntry](#interface-logentry).[data](#data)*

*Defined in [ethereum-types/src/index.ts:436](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/ethereum-types/src/index.ts#L436)*

___

###  event

• **event**: *string*

*Inherited from [DecodedLogEntry](#interface-decodedlogentry).[event](#event)*

*Defined in [ethereum-types/src/index.ts:417](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/ethereum-types/src/index.ts#L417)*

___

###  logIndex

• **logIndex**: *number | null*

*Inherited from [LogEntry](#interface-logentry).[logIndex](#logindex)*

*Defined in [ethereum-types/src/index.ts:430](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/ethereum-types/src/index.ts#L430)*

___

###  topics

• **topics**: *string[]*

*Inherited from [LogEntry](#interface-logentry).[topics](#topics)*

*Defined in [ethereum-types/src/index.ts:437](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/ethereum-types/src/index.ts#L437)*

___

###  transactionHash

• **transactionHash**: *string*

*Inherited from [LogEntry](#interface-logentry).[transactionHash](#transactionhash)*

*Defined in [ethereum-types/src/index.ts:432](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/ethereum-types/src/index.ts#L432)*

___

###  transactionIndex

• **transactionIndex**: *number | null*

*Inherited from [LogEntry](#interface-logentry).[transactionIndex](#transactionindex)*

*Defined in [ethereum-types/src/index.ts:431](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/ethereum-types/src/index.ts#L431)*

<hr />

# Interface: MethodAbi


##   Properties

###  constant

• **constant**: *boolean*

*Defined in [ethereum-types/src/index.ts:94](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/ethereum-types/src/index.ts#L94)*

___

###  inputs

• **inputs**: *[DataItem](#class-dataitem)[]*

*Defined in [ethereum-types/src/index.ts:92](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/ethereum-types/src/index.ts#L92)*

___

###  name

• **name**: *string*

*Defined in [ethereum-types/src/index.ts:91](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/ethereum-types/src/index.ts#L91)*

___

###  outputs

• **outputs**: *[DataItem](#class-dataitem)[]*

*Defined in [ethereum-types/src/index.ts:93](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/ethereum-types/src/index.ts#L93)*

___

###  payable

• **payable**: *boolean*

*Defined in [ethereum-types/src/index.ts:96](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/ethereum-types/src/index.ts#L96)*

___

###  stateMutability

• **stateMutability**: *[StateMutability](#statemutability)*

*Defined in [ethereum-types/src/index.ts:95](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/ethereum-types/src/index.ts#L95)*

___

###  type

• **type**: *string*

*Defined in [ethereum-types/src/index.ts:90](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/ethereum-types/src/index.ts#L90)*

<hr />

# Interface: OptimizerSettings


##   Properties

###  enabled

• **enabled**: *boolean*

*Defined in [ethereum-types/src/index.ts:709](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/ethereum-types/src/index.ts#L709)*

___

### `Optional` runs

• **runs**? : *undefined | number*

*Defined in [ethereum-types/src/index.ts:710](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/ethereum-types/src/index.ts#L710)*

<hr />





# Interface: RevertErrorAbi


##   Properties

### `Optional` arguments

• **arguments**? : *[DataItem](#class-dataitem)[]*

*Defined in [ethereum-types/src/index.ts:122](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/ethereum-types/src/index.ts#L122)*

___

###  name

• **name**: *string*

*Defined in [ethereum-types/src/index.ts:121](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/ethereum-types/src/index.ts#L121)*

___

###  type

• **type**: *"error"*

*Defined in [ethereum-types/src/index.ts:120](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/ethereum-types/src/index.ts#L120)*

<hr />







# Interface: StandardContractOutput


##   Properties

###  abi

• **abi**: *[ContractAbi](#contractabi)*

*Defined in [ethereum-types/src/index.ts:565](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/ethereum-types/src/index.ts#L565)*

___

### `Optional` devdoc

• **devdoc**? : *[DevdocOutput](#class-devdocoutput)*

*Defined in [ethereum-types/src/index.ts:567](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/ethereum-types/src/index.ts#L567)*

___

###  evm

• **evm**: *[EvmOutput](#class-evmoutput)*

*Defined in [ethereum-types/src/index.ts:566](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/ethereum-types/src/index.ts#L566)*

<hr />















# Interface: TupleDataItem


##   Properties

###  components

• **components**: *[DataItem](#class-dataitem)[]*

*Overrides [DataItem](_ethereum_types_src_index_.dataitem.md).[components](#optional-components)*

*Defined in [ethereum-types/src/index.ts:142](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/ethereum-types/src/index.ts#L142)*

___

### `Optional` internalType

• **internalType**? : *undefined | string*

*Inherited from [DataItem](#interface-dataitem).[internalType](#optional-internaltype)*

*Defined in [ethereum-types/src/index.ts:137](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/ethereum-types/src/index.ts#L137)*

___

###  name

• **name**: *string*

*Inherited from [DataItem](#interface-dataitem).[name](#name)*

*Defined in [ethereum-types/src/index.ts:135](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/ethereum-types/src/index.ts#L135)*

___

###  type

• **type**: *string*

*Inherited from [DataItem](#interface-dataitem).[type](#type)*

*Defined in [ethereum-types/src/index.ts:136](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/ethereum-types/src/index.ts#L136)*

<hr />

# Interface: TxData


##   Properties

### `Optional` data

• **data**? : *undefined | string*

*Inherited from [CallTxDataBase](#interface-calltxdatabase).[data](#optional-data)*

*Defined in [ethereum-types/src/index.ts:394](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/ethereum-types/src/index.ts#L394)*

___

###  from

• **from**: *string*

*Defined in [ethereum-types/src/index.ts:399](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/ethereum-types/src/index.ts#L399)*

___

### `Optional` gas

• **gas**? : *number | string | `BigNumber`*

*Inherited from [CallTxDataBase](#interface-calltxdatabase).[gas](#optional-gas)*

*Defined in [ethereum-types/src/index.ts:392](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/ethereum-types/src/index.ts#L392)*

___

### `Optional` gasPrice

• **gasPrice**? : *number | string | `BigNumber`*

*Inherited from [CallTxDataBase](#interface-calltxdatabase).[gasPrice](#optional-gasprice)*

*Defined in [ethereum-types/src/index.ts:393](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/ethereum-types/src/index.ts#L393)*

___

### `Optional` nonce

• **nonce**? : *undefined | number*

*Inherited from [CallTxDataBase](#interface-calltxdatabase).[nonce](#optional-nonce)*

*Defined in [ethereum-types/src/index.ts:395](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/ethereum-types/src/index.ts#L395)*

___

### `Optional` to

• **to**? : *undefined | string*

*Inherited from [CallTxDataBase](#interface-calltxdatabase).[to](#optional-to)*

*Defined in [ethereum-types/src/index.ts:390](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/ethereum-types/src/index.ts#L390)*

___

### `Optional` value

• **value**? : *number | string | `BigNumber`*

*Inherited from [CallTxDataBase](#interface-calltxdatabase).[value](#optional-value)*

*Defined in [ethereum-types/src/index.ts:391](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/ethereum-types/src/index.ts#L391)*

<hr />

# Interface: TxDataPayable


##   Properties

### `Optional` data

• **data**? : *undefined | string*

*Inherited from [CallTxDataBase](#interface-calltxdatabase).[data](#optional-data)*

*Defined in [ethereum-types/src/index.ts:394](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/ethereum-types/src/index.ts#L394)*

___

###  from

• **from**: *string*

*Inherited from [TxData](#interface-txdata).[from](#from)*

*Defined in [ethereum-types/src/index.ts:399](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/ethereum-types/src/index.ts#L399)*

___

### `Optional` gas

• **gas**? : *number | string | `BigNumber`*

*Inherited from [CallTxDataBase](#interface-calltxdatabase).[gas](#optional-gas)*

*Defined in [ethereum-types/src/index.ts:392](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/ethereum-types/src/index.ts#L392)*

___

### `Optional` gasPrice

• **gasPrice**? : *number | string | `BigNumber`*

*Inherited from [CallTxDataBase](#interface-calltxdatabase).[gasPrice](#optional-gasprice)*

*Defined in [ethereum-types/src/index.ts:393](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/ethereum-types/src/index.ts#L393)*

___

### `Optional` nonce

• **nonce**? : *undefined | number*

*Inherited from [CallTxDataBase](#interface-calltxdatabase).[nonce](#optional-nonce)*

*Defined in [ethereum-types/src/index.ts:395](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/ethereum-types/src/index.ts#L395)*

___

### `Optional` to

• **to**? : *undefined | string*

*Inherited from [CallTxDataBase](#interface-calltxdatabase).[to](#optional-to)*

*Defined in [ethereum-types/src/index.ts:390](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/ethereum-types/src/index.ts#L390)*

___

### `Optional` value

• **value**? : *`BigNumber`*

*Overrides [CallTxDataBase](_ethereum_types_src_index_.calltxdatabase.md).[value](#optional-value)*

*Defined in [ethereum-types/src/index.ts:443](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/ethereum-types/src/index.ts#L443)*

<hr />

# Interface: Web3JsV1Provider

Web3.js version 1 provider interface
This provider interface was implemented in the pre-1.0Beta releases for Web3.js.
This interface allowed sending synchonous requests, support for which was later dropped.


##   Methods

###  send

▸ **send**(`payload`: [JSONRPCRequestPayload](_ethereum_types_src_index_.jsonrpcrequestpayload.md)): *[JSONRPCResponsePayload](#class-jsonrpcresponsepayload)*

*Defined in [ethereum-types/src/index.ts:45](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/ethereum-types/src/index.ts#L45)*

**Parameters:**

Name | Type |
------ | ------ |
`payload` | [JSONRPCRequestPayload](#class-jsonrpcrequestpayload) |

**Returns:** *[JSONRPCResponsePayload](#class-jsonrpcresponsepayload)*

___

###  sendAsync

▸ **sendAsync**(`payload`: [JSONRPCRequestPayload](_ethereum_types_src_index_.jsonrpcrequestpayload.md), `callback`: [JSONRPCErrorCallback](#jsonrpcerrorcallback)): *void*

*Defined in [ethereum-types/src/index.ts:44](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/ethereum-types/src/index.ts#L44)*

**Parameters:**

Name | Type |
------ | ------ |
`payload` | [JSONRPCRequestPayload](#class-jsonrpcrequestpayload) |
`callback` | [JSONRPCErrorCallback](#jsonrpcerrorcallback) |

**Returns:** *void*

<hr />

# Interface: Web3JsV2Provider

Web3.js version 2 provider interface
This provider interface was used in a couple of Web3.js 1.0 beta releases
before the first attempts to conform to EIP1193


##   Methods

###  send

▸ **send**(`payload`: [JSONRPCRequestPayload](_ethereum_types_src_index_.jsonrpcrequestpayload.md), `callback`: [JSONRPCErrorCallback](#jsonrpcerrorcallback)): *void*

*Defined in [ethereum-types/src/index.ts:54](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/ethereum-types/src/index.ts#L54)*

**Parameters:**

Name | Type |
------ | ------ |
`payload` | [JSONRPCRequestPayload](#class-jsonrpcrequestpayload) |
`callback` | [JSONRPCErrorCallback](#jsonrpcerrorcallback) |

**Returns:** *void*

<hr />

# Interface: Web3JsV3Provider

Web3.js version 3 provider interface
This provider interface was implemented with the hopes for conforming to the EIP1193 spec,
however it does not conform entirely.


##   Methods

###  send

▸ **send**(`method`: string, `params?`: any[]): *`Promise<any>`*

*Defined in [ethereum-types/src/index.ts:63](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/ethereum-types/src/index.ts#L63)*

**Parameters:**

Name | Type |
------ | ------ |
`method` | string |
`params?` | any[] |

**Returns:** *`Promise<any>`*

<hr />

# Interface: ZeroExProvider

The interface for the provider used internally by 0x libraries
Any property we use from any SupportedProvider should we explicitly
add here


##   Properties

### `Optional` isMetaMask

• **isMetaMask**? : *undefined | false | true*

*Defined in [ethereum-types/src/index.ts:31](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/ethereum-types/src/index.ts#L31)*

___

### `Optional` isParity

• **isParity**? : *undefined | false | true*

*Defined in [ethereum-types/src/index.ts:32](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/ethereum-types/src/index.ts#L32)*

___

### `Optional` isZeroExProvider

• **isZeroExProvider**? : *undefined | false | true*

*Defined in [ethereum-types/src/index.ts:30](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/ethereum-types/src/index.ts#L30)*

## Methods

### `Optional` enable

▸ **enable**(): *`Promise<void>`*

*Defined in [ethereum-types/src/index.ts:34](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/ethereum-types/src/index.ts#L34)*

**Returns:** *`Promise<void>`*

___

###  sendAsync

▸ **sendAsync**(`payload`: [JSONRPCRequestPayload](_ethereum_types_src_index_.jsonrpcrequestpayload.md), `callback`: [JSONRPCErrorCallback](#jsonrpcerrorcallback)): *void*

*Defined in [ethereum-types/src/index.ts:35](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/ethereum-types/src/index.ts#L35)*

**Parameters:**

Name | Type |
------ | ------ |
`payload` | [JSONRPCRequestPayload](#class-jsonrpcrequestpayload) |
`callback` | [JSONRPCErrorCallback](#jsonrpcerrorcallback) |

**Returns:** *void*

___

### `Optional` stop

▸ **stop**(): *void*

*Defined in [ethereum-types/src/index.ts:33](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/ethereum-types/src/index.ts#L33)*

**Returns:** *void*

<hr />







# Interface: JSONRPCRequestPayloadWithMethod


##   Properties

###  id

• **id**: *number*



Defined in ethereum-types/lib/index.d.ts:268

___

###  jsonrpc

• **jsonrpc**: *string*



Defined in ethereum-types/lib/index.d.ts:269

___

###  method

• **method**: *string*

*Overrides void*

*Defined in [subproviders/src/types.ts:136](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/subproviders/src/types.ts#L136)*

___

###  params

• **params**: *any[]*



Defined in ethereum-types/lib/index.d.ts:266

<hr />



















































# Interface: DecodedLogEvent <**ArgsType**>

## Type parameters

▪ **ArgsType**: *`DecodedLogArgs`*


##   Properties

###  isRemoved

• **isRemoved**: *boolean*

*Defined in [types/src/index.ts:844](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/types/src/index.ts#L844)*

___

###  log

• **log**: *`LogWithDecodedArgs<ArgsType>`*

*Defined in [types/src/index.ts:845](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/types/src/index.ts#L845)*

<hr />



# Interface: DutchAuctionData


##   Properties

###  assetData

• **assetData**: *[AssetData](#assetdata)*

*Defined in [types/src/index.ts:219](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/types/src/index.ts#L219)*

___

###  beginAmount

• **beginAmount**: *`BigNumber`*

*Defined in [types/src/index.ts:221](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/types/src/index.ts#L221)*

___

###  beginTimeSeconds

• **beginTimeSeconds**: *`BigNumber`*

*Defined in [types/src/index.ts:220](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/types/src/index.ts#L220)*

<hr />



# Interface: ECSignature

Elliptic Curve signature


##   Properties

###  r

• **r**: *string*

*Defined in [types/src/index.ts:62](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/types/src/index.ts#L62)*

___

###  s

• **s**: *string*

*Defined in [types/src/index.ts:63](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/types/src/index.ts#L63)*

___

###  v

• **v**: *number*

*Defined in [types/src/index.ts:61](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/types/src/index.ts#L61)*

<hr />

# Interface: EIP712DomainWithDefaultSchema


##   Properties

###  chainId

• **chainId**: *number*

*Defined in [types/src/index.ts:793](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/types/src/index.ts#L793)*

___

### `Optional` name

• **name**? : *undefined | string*

*Defined in [types/src/index.ts:791](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/types/src/index.ts#L791)*

___

###  verifyingContract

• **verifyingContract**: *string*

*Defined in [types/src/index.ts:794](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/types/src/index.ts#L794)*

___

### `Optional` version

• **version**? : *undefined | string*

*Defined in [types/src/index.ts:792](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/types/src/index.ts#L792)*

<hr />







# Interface: ERC1155AssetData


##   Properties

###  assetProxyId

• **assetProxyId**: *string*

*Defined in [types/src/index.ts:183](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/types/src/index.ts#L183)*

___

###  callbackData

• **callbackData**: *string*

*Defined in [types/src/index.ts:187](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/types/src/index.ts#L187)*

___

###  tokenAddress

• **tokenAddress**: *string*

*Defined in [types/src/index.ts:184](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/types/src/index.ts#L184)*

___

###  tokenIds

• **tokenIds**: *`BigNumber`[]*

*Defined in [types/src/index.ts:185](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/types/src/index.ts#L185)*

___

###  tokenValues

• **tokenValues**: *`BigNumber`[]*

*Defined in [types/src/index.ts:186](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/types/src/index.ts#L186)*

<hr />



# Interface: ERC20AssetData


##   Properties

###  assetProxyId

• **assetProxyId**: *string*

*Defined in [types/src/index.ts:172](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/types/src/index.ts#L172)*

___

###  tokenAddress

• **tokenAddress**: *string*

*Defined in [types/src/index.ts:173](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/types/src/index.ts#L173)*

<hr />

# Interface: ERC721AssetData


##   Properties

###  assetProxyId

• **assetProxyId**: *string*

*Defined in [types/src/index.ts:177](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/types/src/index.ts#L177)*

___

###  tokenAddress

• **tokenAddress**: *string*

*Defined in [types/src/index.ts:178](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/types/src/index.ts#L178)*

___

###  tokenId

• **tokenId**: *`BigNumber`*

*Defined in [types/src/index.ts:179](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/types/src/index.ts#L179)*

<hr />





 





# Interface: IndexedFilterValues


##  Hierarchy

* **IndexSignature**


##  Properties

###  keyName

• **keyName**: *string*

*Defined in [types/src/index.ts:691](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/types/src/index.ts#L691)*

___

###  keyType

• **keyType**: *[Type](#class-type)*

*Defined in [types/src/index.ts:692](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/types/src/index.ts#L692)*

___

###  valueName

• **valueName**: *string*

*Defined in [types/src/index.ts:693](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/types/src/index.ts#L693)*

<hr />





# Interface: MultiAssetData


##   Properties

###  amounts

• **amounts**: *`BigNumber`[]*

*Defined in [types/src/index.ts:208](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/types/src/index.ts#L208)*

___

###  assetProxyId

• **assetProxyId**: *string*

*Defined in [types/src/index.ts:207](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/types/src/index.ts#L207)*

___

###  nestedAssetData

• **nestedAssetData**: *string[]*

*Defined in [types/src/index.ts:209](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/types/src/index.ts#L209)*

<hr />

# Interface: MultiAssetDataWithRecursiveDecoding


##   Properties

###  amounts

• **amounts**: *`BigNumber`[]*

*Defined in [types/src/index.ts:214](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/types/src/index.ts#L214)*

___

###  assetProxyId

• **assetProxyId**: *string*

*Defined in [types/src/index.ts:213](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/types/src/index.ts#L213)*

___

###  nestedAssetData

• **nestedAssetData**: *[SingleAssetData](#singleassetdata)[]*

*Defined in [types/src/index.ts:215](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/types/src/index.ts#L215)*

<hr />







































# Interface: SignedOrder


##   Properties

###  chainId

• **chainId**: *number*

*Inherited from [Order](#interface-order).[chainId](#chainid)*

*Defined in [types/src/index.ts:14](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/types/src/index.ts#L14)*

___

###  exchangeAddress

• **exchangeAddress**: *string*

*Inherited from [Order](#interface-order).[exchangeAddress](#exchangeaddress)*

*Defined in [types/src/index.ts:15](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/types/src/index.ts#L15)*

___

###  expirationTimeSeconds

• **expirationTimeSeconds**: *`BigNumber`*

*Inherited from [Order](#interface-order).[expirationTimeSeconds](#expirationtimeseconds)*

*Defined in [types/src/index.ts:24](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/types/src/index.ts#L24)*

___

###  feeRecipientAddress

• **feeRecipientAddress**: *string*

*Inherited from [Order](#interface-order).[feeRecipientAddress](#feerecipientaddress)*

*Defined in [types/src/index.ts:18](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/types/src/index.ts#L18)*

___

###  makerAddress

• **makerAddress**: *string*

*Inherited from [Order](#interface-order).[makerAddress](#makeraddress)*

*Defined in [types/src/index.ts:16](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/types/src/index.ts#L16)*

___

###  makerAssetAmount

• **makerAssetAmount**: *`BigNumber`*

*Inherited from [Order](#interface-order).[makerAssetAmount](#makerassetamount)*

*Defined in [types/src/index.ts:20](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/types/src/index.ts#L20)*

___

###  makerAssetData

• **makerAssetData**: *string*

*Inherited from [Order](#interface-order).[makerAssetData](#makerassetdata)*

*Defined in [types/src/index.ts:26](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/types/src/index.ts#L26)*

___

###  makerFee

• **makerFee**: *`BigNumber`*

*Inherited from [Order](#interface-order).[makerFee](#makerfee)*

*Defined in [types/src/index.ts:22](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/types/src/index.ts#L22)*

___

###  makerFeeAssetData

• **makerFeeAssetData**: *string*

*Inherited from [Order](#interface-order).[makerFeeAssetData](#makerfeeassetdata)*

*Defined in [types/src/index.ts:28](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/types/src/index.ts#L28)*

___

###  salt

• **salt**: *`BigNumber`*

*Inherited from [Order](#interface-order).[salt](#salt)*

*Defined in [types/src/index.ts:25](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/types/src/index.ts#L25)*

___

###  senderAddress

• **senderAddress**: *string*

*Inherited from [Order](#interface-order).[senderAddress](#senderaddress)*

*Defined in [types/src/index.ts:19](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/types/src/index.ts#L19)*

___

###  signature

• **signature**: *string*

*Defined in [types/src/index.ts:33](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/types/src/index.ts#L33)*

___

###  takerAddress

• **takerAddress**: *string*

*Inherited from [Order](#interface-order).[takerAddress](#takeraddress)*

*Defined in [types/src/index.ts:17](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/types/src/index.ts#L17)*

___

###  takerAssetAmount

• **takerAssetAmount**: *`BigNumber`*

*Inherited from [Order](#interface-order).[takerAssetAmount](#takerassetamount)*

*Defined in [types/src/index.ts:21](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/types/src/index.ts#L21)*

___

###  takerAssetData

• **takerAssetData**: *string*

*Inherited from [Order](#interface-order).[takerAssetData](#takerassetdata)*

*Defined in [types/src/index.ts:27](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/types/src/index.ts#L27)*

___

###  takerFee

• **takerFee**: *`BigNumber`*

*Inherited from [Order](#interface-order).[takerFee](#takerfee)*

*Defined in [types/src/index.ts:23](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/types/src/index.ts#L23)*

___

###  takerFeeAssetData

• **takerFeeAssetData**: *string*

*Inherited from [Order](#interface-order).[takerFeeAssetData](#takerfeeassetdata)*

*Defined in [types/src/index.ts:29](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/types/src/index.ts#L29)*

<hr />

# Interface: SignedZeroExTransaction


##   Properties

###  data

• **data**: *string*

*Inherited from [ZeroExTransaction](#interface-zeroextransaction).[data](#data)*

*Defined in [types/src/index.ts:49](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/types/src/index.ts#L49)*

___

###  domain

• **domain**: *[EIP712DomainWithDefaultSchema](#class-eip712domainwithdefaultschema)*

*Inherited from [ZeroExTransaction](#interface-zeroextransaction).[domain](#domain)*

*Defined in [types/src/index.ts:50](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/types/src/index.ts#L50)*

___

###  expirationTimeSeconds

• **expirationTimeSeconds**: *`BigNumber`*

*Inherited from [ZeroExTransaction](#interface-zeroextransaction).[expirationTimeSeconds](#expirationtimeseconds)*

*Defined in [types/src/index.ts:46](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/types/src/index.ts#L46)*

___

###  gasPrice

• **gasPrice**: *`BigNumber`*

*Inherited from [ZeroExTransaction](#interface-zeroextransaction).[gasPrice](#gasprice)*

*Defined in [types/src/index.ts:47](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/types/src/index.ts#L47)*

___

###  salt

• **salt**: *`BigNumber`*

*Inherited from [ZeroExTransaction](#interface-zeroextransaction).[salt](#salt)*

*Defined in [types/src/index.ts:45](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/types/src/index.ts#L45)*

___

###  signature

• **signature**: *string*

*Defined in [types/src/index.ts:54](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/types/src/index.ts#L54)*

___

###  signerAddress

• **signerAddress**: *string*

*Inherited from [ZeroExTransaction](#interface-zeroextransaction).[signerAddress](#signeraddress)*

*Defined in [types/src/index.ts:48](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/types/src/index.ts#L48)*

<hr />

# Interface: SimpleContractArtifact


##   Properties

###  chains

• **chains**: *`ContractChains`*

*Defined in [types/src/index.ts:861](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/types/src/index.ts#L861)*

___

###  compilerOutput

• **compilerOutput**: *[SimpleStandardContractOutput](#class-simplestandardcontractoutput)*

*Defined in [types/src/index.ts:860](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/types/src/index.ts#L860)*

___

###  contractName

• **contractName**: *string*

*Defined in [types/src/index.ts:859](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/types/src/index.ts#L859)*

___

###  schemaVersion

• **schemaVersion**: *string*

*Defined in [types/src/index.ts:858](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/types/src/index.ts#L858)*

<hr />

# Interface: SimpleEvmBytecodeOutput


##   Properties

###  object

• **object**: *string*

*Defined in [types/src/index.ts:875](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/types/src/index.ts#L875)*

<hr />

# Interface: SimpleEvmOutput


##   Properties

###  bytecode

• **bytecode**: *[SimpleEvmBytecodeOutput](#class-simpleevmbytecodeoutput)*

*Defined in [types/src/index.ts:871](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/types/src/index.ts#L871)*

<hr />

# Interface: SimpleStandardContractOutput


##   Properties

###  abi

• **abi**: *[ContractAbi](#contractabi)*

*Defined in [types/src/index.ts:865](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/types/src/index.ts#L865)*

___

### `Optional` devdoc

• **devdoc**? : *[DevdocOutput](#class-devdocoutput)*

*Defined in [types/src/index.ts:867](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/types/src/index.ts#L867)*

___

###  evm

• **evm**: *[SimpleEvmOutput](#class-simpleevmoutput)*

*Defined in [types/src/index.ts:866](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/types/src/index.ts#L866)*

<hr />





# Interface: StaticCallAssetData


##   Properties

###  assetProxyId

• **assetProxyId**: *string*

*Defined in [types/src/index.ts:191](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/types/src/index.ts#L191)*

___

###  callResultHash

• **callResultHash**: *string*

*Defined in [types/src/index.ts:194](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/types/src/index.ts#L194)*

___

###  callTarget

• **callTarget**: *string*

*Defined in [types/src/index.ts:192](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/types/src/index.ts#L192)*

___

###  staticCallData

• **staticCallData**: *string*

*Defined in [types/src/index.ts:193](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/types/src/index.ts#L193)*

<hr />



























# Interface: ValidatorSignature

Validator signature components


##   Properties

###  signature

• **signature**: *string*

*Defined in [types/src/index.ts:71](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/types/src/index.ts#L71)*

___

###  validatorAddress

• **validatorAddress**: *string*

*Defined in [types/src/index.ts:70](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/types/src/index.ts#L70)*

<hr />

# Interface: ZeroExTransaction

ZeroExTransaction for use with 0x Exchange executeTransaction


##   Properties

###  data

• **data**: *string*

*Defined in [types/src/index.ts:49](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/types/src/index.ts#L49)*

___

###  domain

• **domain**: *[EIP712DomainWithDefaultSchema](#class-eip712domainwithdefaultschema)*

*Defined in [types/src/index.ts:50](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/types/src/index.ts#L50)*

___

###  expirationTimeSeconds

• **expirationTimeSeconds**: *`BigNumber`*

*Defined in [types/src/index.ts:46](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/types/src/index.ts#L46)*

___

###  gasPrice

• **gasPrice**: *`BigNumber`*

*Defined in [types/src/index.ts:47](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/types/src/index.ts#L47)*

___

###  salt

• **salt**: *`BigNumber`*

*Defined in [types/src/index.ts:45](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/types/src/index.ts#L45)*

___

###  signerAddress

• **signerAddress**: *string*

*Defined in [types/src/index.ts:48](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/types/src/index.ts#L48)*

<hr />



<hr /> 




##  Type aliases

###  ERC20TokenEventArgs

Ƭ **ERC20TokenEventArgs**: *[ERC20TokenTransferEventArgs](#interface-erc20tokentransfereventargs) | [ERC20TokenApprovalEventArgs](#interface-erc20tokenapprovaleventargs)*

*Defined in [abi-gen-wrappers/src/generated-wrappers/erc20_token.ts:37](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/erc20_token.ts#L37)*

<hr />




##  Type aliases

###  ERC721TokenEventArgs

Ƭ **ERC721TokenEventArgs**: *[ERC721TokenApprovalEventArgs](#interface-erc721tokenapprovaleventargs) | [ERC721TokenApprovalForAllEventArgs](#interface-erc721tokenapprovalforalleventargs) | [ERC721TokenTransferEventArgs](#interface-erc721tokentransfereventargs)*

*Defined in [abi-gen-wrappers/src/generated-wrappers/erc721_token.ts:37](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/erc721_token.ts#L37)*

<hr />




##  Type aliases

###  ExchangeEventArgs

Ƭ **ExchangeEventArgs**: *[ExchangeAssetProxyRegisteredEventArgs](#interface-exchangeassetproxyregisteredeventargs) | [ExchangeCancelEventArgs](#interface-exchangecanceleventargs) | [ExchangeCancelUpToEventArgs](#interface-exchangecanceluptoeventargs) | [ExchangeFillEventArgs](#interface-exchangefilleventargs) | [ExchangeProtocolFeeCollectorAddressEventArgs](#interface-exchangeprotocolfeecollectoraddresseventargs) | [ExchangeProtocolFeeMultiplierEventArgs](#interface-exchangeprotocolfeemultipliereventargs) | [ExchangeSignatureValidatorApprovalEventArgs](#interface-exchangesignaturevalidatorapprovaleventargs) | [ExchangeTransactionExecutionEventArgs](#interface-exchangetransactionexecutioneventargs)*

*Defined in [abi-gen-wrappers/src/generated-wrappers/exchange.ts:37](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/exchange.ts#L37)*

<hr />




##  Type aliases

###  WETH9EventArgs

Ƭ **WETH9EventArgs**: *[WETH9ApprovalEventArgs](#interface-weth9approvaleventargs) | [WETH9TransferEventArgs](#interface-weth9transfereventargs) | [WETH9DepositEventArgs](#interface-weth9depositeventargs) | [WETH9WithdrawalEventArgs](#interface-weth9withdrawaleventargs)*

*Defined in [abi-gen-wrappers/src/generated-wrappers/weth9.ts:37](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/abi-gen-wrappers/src/generated-wrappers/weth9.ts#L37)*

<hr />




##  Type aliases






##  Functions

###  getContractAddressesForChainOrThrow

▸ **getContractAddressesForChainOrThrow**(`chainId`: [ChainId](#enumeration-chainid)): *[ContractAddresses](#interface-contractaddresses)*

*Defined in [contract-addresses/src/index.ts:47](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/contract-addresses/src/index.ts#L47)*

Used to get addresses of contracts that have been deployed to either the
Ethereum mainnet or a supported testnet. Throws if there are no known
contracts deployed on the corresponding chain.

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`chainId` | [ChainId](#enumeration-chainid) | The desired chainId. |

**Returns:** *[ContractAddresses](#interface-contractaddresses)*

The set of addresses for contracts which have been deployed on the
given chainId.

<hr />




##  Type aliases

###  AbiDefinition

Ƭ **AbiDefinition**: *[FunctionAbi](_ethereum_types_src_index_.md#functionabi) | [EventAbi](#interface-eventabi) | [RevertErrorAbi](#interface-reverterrorabi)*

*Defined in [ethereum-types/src/index.ts:80](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/ethereum-types/src/index.ts#L80)*

___

###  BlockParam

Ƭ **BlockParam**: *[BlockParamLiteral](#enumeration-blockparamliteral) | number*

*Defined in [ethereum-types/src/index.ts:484](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/ethereum-types/src/index.ts#L484)*

___

###  ConstructorStateMutability

Ƭ **ConstructorStateMutability**: *"nonpayable" | "payable"*

*Defined in [ethereum-types/src/index.ts:84](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/ethereum-types/src/index.ts#L84)*

___

###  ContractAbi

Ƭ **ContractAbi**: *[AbiDefinition](#abidefinition)[]*

*Defined in [ethereum-types/src/index.ts:78](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/ethereum-types/src/index.ts#L78)*

___

###  ContractEventArg

Ƭ **ContractEventArg**: *any*

*Defined in [ethereum-types/src/index.ts:469](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/ethereum-types/src/index.ts#L469)*

___



###  EIP1193Event

Ƭ **EIP1193Event**: *"accountsChanged" | "networkChanged" | "close" | "connect" | "notification"*

*Defined in [ethereum-types/src/index.ts:70](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/ethereum-types/src/index.ts#L70)*

Interface for providers that conform to EIP 1193
Source: https://github.com/ethereum/EIPs/blob/master/EIPS/eip-1193.md

___





###  FunctionAbi

Ƭ **FunctionAbi**: *[MethodAbi](#interface-methodabi) | [ConstructorAbi](#interface-constructorabi) | [FallbackAbi](#interface-fallbackabi)*

*Defined in [ethereum-types/src/index.ts:82](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/ethereum-types/src/index.ts#L82)*

___

###  JSONRPCErrorCallback

Ƭ **JSONRPCErrorCallback**: *function*

*Defined in [ethereum-types/src/index.ts:3](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/ethereum-types/src/index.ts#L3)*

#### Type declaration:

▸ (`err`: `Error` | null, `result?`: [JSONRPCResponsePayload](#interface-jsonrpcresponsepayload)): *void*

**Parameters:**

Name | Type |
------ | ------ |
`err` | `Error` \| null |
`result?` | [JSONRPCResponsePayload](#interface-jsonrpcresponsepayload) |

___



###  OutputField

Ƭ **OutputField**: *"*" | "ast" | "legacyAST" | "abi" | "devdoc" | "userdoc" | "metadata" | "ir" | "evm.assembly" | "evm.legacyAssembly" | "evm.bytecode.object" | "evm.bytecode.opcodes" | "evm.bytecode.sourceMap" | "evm.bytecode.linkReferences" | "evm.deployedBytecode.object" | "evm.deployedBytecode.opcodes" | "evm.deployedBytecode.sourceMap" | "evm.deployedBytecode.linkReferences" | "evm.methodIdentifiers" | "evm.gasEstimates" | "ewasm.wast" | "ewasm.wasm"*

*Defined in [ethereum-types/src/index.ts:526](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/ethereum-types/src/index.ts#L526)*

___

###  ParamDescription

Ƭ **ParamDescription**: *string*

*Defined in [ethereum-types/src/index.ts:562](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/ethereum-types/src/index.ts#L562)*

___



###  StateMutability

Ƭ **StateMutability**: *"pure" | "view" | [ConstructorStateMutability](#constructorstatemutability)*

*Defined in [ethereum-types/src/index.ts:85](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/ethereum-types/src/index.ts#L85)*

___

###  SupportedProvider

Ƭ **SupportedProvider**: *[Web3JsProvider](_ethereum_types_src_index_.md#web3jsprovider) | [GanacheProvider](#interface-ganacheprovider) | [EIP1193Provider](#interface-eip1193provider) | [ZeroExProvider](#interface-zeroexprovider)*

*Defined in [ethereum-types/src/index.ts:9](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/ethereum-types/src/index.ts#L9)*

Do not create your own provider. Use an existing provider from a Web3 or ProviderEngine library
Read more about Providers in the guides section of the 0x docs.

___





###  Web3JsProvider

Ƭ **Web3JsProvider**: *[Web3JsV1Provider](#interface-web3jsv1provider) | [Web3JsV2Provider](#interface-web3jsv2provider) | [Web3JsV3Provider](#interface-web3jsv3provider)*

*Defined in [ethereum-types/src/index.ts:11](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/ethereum-types/src/index.ts#L11)*

<hr />




##  Object literals

### `Const` assetDataUtils

#### ▪ **assetDataUtils**: *object*

*Defined in [order-utils/src/asset_data_utils.ts:23](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/order-utils/src/asset_data_utils.ts#L23)*

####  assertIsERC1155AssetData

▸ **assertIsERC1155AssetData**(`assetData`: string): *void*

*Defined in [order-utils/src/asset_data_utils.ts:397](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/order-utils/src/asset_data_utils.ts#L397)*

Throws if the assetData is not ERC1155.

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`assetData` | string | Hex encoded assetData string  |

**Returns:** *void*

####  assertIsERC20AssetData

▸ **assertIsERC20AssetData**(`assetData`: string): *void*

*Defined in [order-utils/src/asset_data_utils.ts:353](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/order-utils/src/asset_data_utils.ts#L353)*

Throws if the length or assetProxyId are invalid for the ERC20Proxy.

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`assetData` | string | Hex encoded assetData string  |

**Returns:** *void*

####  assertIsERC721AssetData

▸ **assertIsERC721AssetData**(`assetData`: string): *void*

*Defined in [order-utils/src/asset_data_utils.ts:375](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/order-utils/src/asset_data_utils.ts#L375)*

Throws if the length or assetProxyId are invalid for the ERC721Proxy.

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`assetData` | string | Hex encoded assetData string  |

**Returns:** *void*

####  assertIsMultiAssetData

▸ **assertIsMultiAssetData**(`assetData`: string): *void*

*Defined in [order-utils/src/asset_data_utils.ts:419](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/order-utils/src/asset_data_utils.ts#L419)*

Throws if the length or assetProxyId are invalid for the MultiAssetProxy.

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`assetData` | string | Hex encoded assetData string  |

**Returns:** *void*

####  assertIsStaticCallAssetData

▸ **assertIsStaticCallAssetData**(`assetData`: string): *void*

*Defined in [order-utils/src/asset_data_utils.ts:441](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/order-utils/src/asset_data_utils.ts#L441)*

Throws if the assetData is not StaticCallData.

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`assetData` | string | Hex encoded assetData string  |

**Returns:** *void*

####  assertWordAlignedAssetData

▸ **assertWordAlignedAssetData**(`assetData`: string): *void*

*Defined in [order-utils/src/asset_data_utils.ts:463](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/order-utils/src/asset_data_utils.ts#L463)*

Throws if the assetData is not padded to 32 bytes.

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`assetData` | string | Hex encoded assetData string  |

**Returns:** *void*

####  decodeAssetDataOrThrow

▸ **decodeAssetDataOrThrow**(`assetData`: string): *[SingleAssetData](#singleassetdata) | `MultiAssetData`*

*Defined in [order-utils/src/asset_data_utils.ts:502](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/order-utils/src/asset_data_utils.ts#L502)*

Decode any assetData into its corresponding assetData object

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`assetData` | string | Hex encoded assetData string to decode |

**Returns:** *[SingleAssetData](#singleassetdata) | `MultiAssetData`*

Either a ERC20, ERC721, ERC1155, or MultiAsset assetData object

####  decodeAssetProxyId

▸ **decodeAssetProxyId**(`assetData`: string): *`AssetProxyId`*

*Defined in [order-utils/src/asset_data_utils.ts:294](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/order-utils/src/asset_data_utils.ts#L294)*

Decode and return the assetProxyId from the assetData

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`assetData` | string | Hex encoded assetData string to decode |

**Returns:** *`AssetProxyId`*

The assetProxyId

####  decodeDutchAuctionData

▸ **decodeDutchAuctionData**(`dutchAuctionData`: string): *`DutchAuctionData`*

*Defined in [order-utils/src/asset_data_utils.ts:263](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/order-utils/src/asset_data_utils.ts#L263)*

Dutch auction details are encoded with the asset data for a 0x order. This function decodes a hex
encoded assetData string, containing information both about the asset being traded and the
dutch auction.

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`dutchAuctionData` | string | Hex encoded assetData string for the asset being auctioned. |

**Returns:** *`DutchAuctionData`*

An object containing the auction asset, auction begin time and auction begin amount.

####  decodeERC1155AssetData

▸ **decodeERC1155AssetData**(`assetData`: string): *`ERC1155AssetData`*

*Defined in [order-utils/src/asset_data_utils.ts:107](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/order-utils/src/asset_data_utils.ts#L107)*

Decodes an ERC1155 assetData hex string into its corresponding ERC1155 components.

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`assetData` | string | Hex encoded assetData string to decode |

**Returns:** *`ERC1155AssetData`*

An object containing the decoded tokenAddress, tokenIds, tokenValues, callbackData & assetProxyId

####  decodeERC20AssetData

▸ **decodeERC20AssetData**(`assetData`: string): *`ERC20AssetData`*

*Defined in [order-utils/src/asset_data_utils.ts:41](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/order-utils/src/asset_data_utils.ts#L41)*

Decodes an ERC20 assetData hex string into its corresponding ERC20 tokenAddress & assetProxyId

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`assetData` | string | Hex encoded assetData string to decode |

**Returns:** *`ERC20AssetData`*

An object containing the decoded tokenAddress & assetProxyId

####  decodeERC721AssetData

▸ **decodeERC721AssetData**(`assetData`: string): *`ERC721AssetData`*

*Defined in [order-utils/src/asset_data_utils.ts:70](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/order-utils/src/asset_data_utils.ts#L70)*

Decodes an ERC721 assetData hex string into its corresponding ERC721 tokenAddress, tokenId & assetProxyId

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`assetData` | string | Hex encoded assetData string to decode |

**Returns:** *`ERC721AssetData`*

An object containing the decoded tokenAddress, tokenId & assetProxyId

####  decodeMultiAssetData

▸ **decodeMultiAssetData**(`assetData`: string): *`MultiAssetData`*

*Defined in [order-utils/src/asset_data_utils.ts:149](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/order-utils/src/asset_data_utils.ts#L149)*

Decodes a MultiAsset assetData hex string into its corresponding amounts and nestedAssetData

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`assetData` | string | Hex encoded assetData string to decode |

**Returns:** *`MultiAssetData`*

An object containing the decoded amounts and nestedAssetData

####  decodeMultiAssetDataRecursively

▸ **decodeMultiAssetDataRecursively**(`assetData`: string): *`MultiAssetDataWithRecursiveDecoding`*

*Defined in [order-utils/src/asset_data_utils.ts:175](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/order-utils/src/asset_data_utils.ts#L175)*

Decodes a MultiAsset assetData hex string into its corresponding amounts and decoded nestedAssetData elements (all nested elements are flattened)

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`assetData` | string | Hex encoded assetData string to decode |

**Returns:** *`MultiAssetDataWithRecursiveDecoding`*

An object containing the decoded amounts and nestedAssetData

####  decodeStaticCallAssetData

▸ **decodeStaticCallAssetData**(`assetData`: string): *`StaticCallAssetData`*

*Defined in [order-utils/src/asset_data_utils.ts:225](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/order-utils/src/asset_data_utils.ts#L225)*

Decoded StaticCall assetData into its corresponding callTarget, staticCallData, and expected callResultHash

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`assetData` | string | Hex encoded assetData string to decode |

**Returns:** *`StaticCallAssetData`*

An object containing the decoded callTarget, staticCallData, and expected callResultHash

####  encodeDutchAuctionAssetData

▸ **encodeDutchAuctionAssetData**(`assetData`: string, `beginTimeSeconds`: `BigNumber`, `beginAmount`: `BigNumber`): *string*

*Defined in [order-utils/src/asset_data_utils.ts:245](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/order-utils/src/asset_data_utils.ts#L245)*

Dutch auction details are encoded with the asset data for a 0x order. This function produces a hex
encoded assetData string, containing information both about the asset being traded and the
dutch auction; which is usable in the makerAssetData or takerAssetData fields in a 0x order.

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`assetData` | string | Hex encoded assetData string for the asset being auctioned. |
`beginTimeSeconds` | `BigNumber` | Begin time of the dutch auction. |
`beginAmount` | `BigNumber` | Starting amount being sold in the dutch auction. |

**Returns:** *string*

The hex encoded assetData string.

####  encodeERC1155AssetData

▸ **encodeERC1155AssetData**(`tokenAddress`: string, `tokenIds`: `BigNumber`[], `tokenValues`: `BigNumber`[], `callbackData`: string): *string*

*Defined in [order-utils/src/asset_data_utils.ts:91](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/order-utils/src/asset_data_utils.ts#L91)*

Encodes a set of ERC1155 assets into an assetData string, usable in the makerAssetData or
takerAssetData fields of a 0x order.

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`tokenAddress` | string | The token address of the ERC1155 contract |
`tokenIds` | `BigNumber`[] | The Id's of the ERC1155 tokens to transfer |
`tokenValues` | `BigNumber`[] | The values of each respective token Id to transfer |
`callbackData` | string | The data forwarded to a receiver, if receiver is a contract. |

**Returns:** *string*

The hex encoded assetData string

####  encodeERC20AssetData

▸ **encodeERC20AssetData**(`tokenAddress`: string): *string*

*Defined in [order-utils/src/asset_data_utils.ts:30](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/order-utils/src/asset_data_utils.ts#L30)*

Encodes an ERC20 token address into a hex encoded assetData string, usable in the makerAssetData or
takerAssetData fields in a 0x order.

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`tokenAddress` | string | The ERC20 token address to encode |

**Returns:** *string*

The hex encoded assetData string

####  encodeERC721AssetData

▸ **encodeERC721AssetData**(`tokenAddress`: string, `tokenId`: `BigNumber`): *string*

*Defined in [order-utils/src/asset_data_utils.ts:59](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/order-utils/src/asset_data_utils.ts#L59)*

Encodes an ERC721 token address into a hex encoded assetData string, usable in the makerAssetData or
takerAssetData fields in a 0x order.

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`tokenAddress` | string | The ERC721 token address to encode |
`tokenId` | `BigNumber` | The ERC721 tokenId to encode |

**Returns:** *string*

The hex encoded assetData string

####  encodeMultiAssetData

▸ **encodeMultiAssetData**(`amounts`: `BigNumber`[], `nestedAssetData`: string[]): *string*

*Defined in [order-utils/src/asset_data_utils.ts:130](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/order-utils/src/asset_data_utils.ts#L130)*

Encodes assetData for multiple AssetProxies into a single hex encoded assetData string, usable in the makerAssetData or
takerAssetData fields in a 0x order.

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`amounts` | `BigNumber`[] | Amounts of each asset that correspond to a single unit within an order. |
`nestedAssetData` | string[] | assetData strings that correspond to a valid assetProxyId. |

**Returns:** *string*

The hex encoded assetData string

####  encodeStaticCallAssetData

▸ **encodeStaticCallAssetData**(`callTarget`: string, `staticCallData`: string, `callResultHash`: string): *string*

*Defined in [order-utils/src/asset_data_utils.ts:214](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/order-utils/src/asset_data_utils.ts#L214)*

Encodes StaticCallProxy data into an assetData hex string

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`callTarget` | string | Address of contract to call from StaticCallProxy |
`staticCallData` | string | The function data that will be called on the callTarget contract |
`callResultHash` | string | The keccak256 hash of the ABI encoded expected output of the static call |

**Returns:** *string*

The hex encoded assetData string

####  isERC1155AssetData

▸ **isERC1155AssetData**(`decodedAssetData`: [SingleAssetData](#singleassetdata) | `MultiAssetData`): *boolean*

*Defined in [order-utils/src/asset_data_utils.ts:332](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/order-utils/src/asset_data_utils.ts#L332)*

Checks if the decoded asset data is valid ERC1155 data

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`decodedAssetData` | [SingleAssetData](#singleassetdata) \| `MultiAssetData` | The decoded asset data to check  |

**Returns:** *boolean*

####  isERC20AssetData

▸ **isERC20AssetData**(`decodedAssetData`: [SingleAssetData](#singleassetdata) | `MultiAssetData`): *boolean*

*Defined in [order-utils/src/asset_data_utils.ts:318](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/order-utils/src/asset_data_utils.ts#L318)*

Checks if the decoded asset data is valid ERC20 data

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`decodedAssetData` | [SingleAssetData](#singleassetdata) \| `MultiAssetData` | The decoded asset data to check  |

**Returns:** *boolean*

####  isERC721AssetData

▸ **isERC721AssetData**(`decodedAssetData`: [SingleAssetData](#singleassetdata) | `MultiAssetData`): *boolean*

*Defined in [order-utils/src/asset_data_utils.ts:325](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/order-utils/src/asset_data_utils.ts#L325)*

Checks if the decoded asset data is valid ERC721 data

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`decodedAssetData` | [SingleAssetData](#singleassetdata) \| `MultiAssetData` | The decoded asset data to check  |

**Returns:** *boolean*

####  isMultiAssetData

▸ **isMultiAssetData**(`decodedAssetData`: [SingleAssetData](#singleassetdata) | `MultiAssetData`): *boolean*

*Defined in [order-utils/src/asset_data_utils.ts:339](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/order-utils/src/asset_data_utils.ts#L339)*

Checks if the decoded asset data is valid MultiAsset data

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`decodedAssetData` | [SingleAssetData](#singleassetdata) \| `MultiAssetData` | The decoded asset data to check  |

**Returns:** *boolean*

####  isStaticCallAssetData

▸ **isStaticCallAssetData**(`decodedAssetData`: [SingleAssetData](#singleassetdata) | `MultiAssetData`): *boolean*

*Defined in [order-utils/src/asset_data_utils.ts:346](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/order-utils/src/asset_data_utils.ts#L346)*

Checks if the decoded asset data is valid StaticCall data

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`decodedAssetData` | [SingleAssetData](#singleassetdata) \| `MultiAssetData` | The decoded asset data to check  |

**Returns:** *boolean*

####  validateAssetDataOrThrow

▸ **validateAssetDataOrThrow**(`assetData`: string): *void*

*Defined in [order-utils/src/asset_data_utils.ts:475](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/order-utils/src/asset_data_utils.ts#L475)*

Throws if the length or assetProxyId are invalid for the corresponding AssetProxy.

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`assetData` | string | Hex encoded assetData string  |

**Returns:** *void*

<hr />




##  Functions

####  generatePseudoRandomSalt

▸ **generatePseudoRandomSalt**(): *`BigNumber`*

*Defined in [order-utils/src/salt.ts:9](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/order-utils/src/salt.ts#L9)*

Generates a pseudo-random 256-bit salt.
The salt can be included in a 0x order, ensuring that the order generates a unique orderHash
and will not collide with other outstanding orders that are identical in all other parameters.

**Returns:** *`BigNumber`*

A pseudo-random 256-bit number that can be used as a salt.

<hr />




##  Functions

####  isValidECSignature

▸ **isValidECSignature**(`data`: string, `signature`: `ECSignature`, `signerAddress`: string): *boolean*

*Defined in [order-utils/src/signature_utils.ts:353](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/order-utils/src/signature_utils.ts#L353)*

Checks if the supplied elliptic curve signature corresponds to signing `data` with
the private key corresponding to `signerAddress`

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`data` | string | The hex encoded data signed by the supplied signature. |
`signature` | `ECSignature` | An object containing the elliptic curve signature parameters. |
`signerAddress` | string | The hex encoded address that signed the data, producing the supplied signature. |

**Returns:** *boolean*

Whether the ECSignature is valid.

___

###  parseSignatureHexAsVRS

▸ **parseSignatureHexAsVRS**(`signatureHex`: string): *`ECSignature`*

*Defined in [order-utils/src/signature_utils.ts:311](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/order-utils/src/signature_utils.ts#L311)*

Parses a signature hex string, which is assumed to be in the VRS format.

**Parameters:**

Name | Type |
------ | ------ |
`signatureHex` | string |

**Returns:** *`ECSignature`*

## Object literals

### `Const` signatureUtils

#### ▪ **signatureUtils**: *object*

*Defined in [order-utils/src/signature_utils.ts:26](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/order-utils/src/signature_utils.ts#L26)*

####  addSignedMessagePrefix

▸ **addSignedMessagePrefix**(`message`: string): *string*

*Defined in [order-utils/src/signature_utils.ts:284](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/order-utils/src/signature_utils.ts#L284)*

Adds the relevant prefix to the message being signed.

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`message` | string | Message to sign |

**Returns:** *string*

Prefixed message

####  convertECSignatureToSignatureHex

▸ **convertECSignatureToSignatureHex**(`ecSignature`: `ECSignature`): *string*

*Defined in [order-utils/src/signature_utils.ts:258](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/order-utils/src/signature_utils.ts#L258)*

Combines ECSignature with V,R,S and the EthSign signature type for use in 0x protocol

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`ecSignature` | `ECSignature` | The ECSignature of the signed data |

**Returns:** *string*

Hex encoded string of signature (v,r,s) with Signature Type

####  convertToSignatureWithType

▸ **convertToSignatureWithType**(`signature`: string, `signatureType`: `SignatureType`): *string*

*Defined in [order-utils/src/signature_utils.ts:274](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/order-utils/src/signature_utils.ts#L274)*

Combines the signature proof and the Signature Type.

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`signature` | string | The hex encoded signature proof |
`signatureType` | `SignatureType` | The signature type, i.e EthSign, Wallet etc. |

**Returns:** *string*

Hex encoded string of signature proof with Signature Type

####  ecSignHashAsync

▸ **ecSignHashAsync**(`supportedProvider`: [SupportedProvider](#supportedprovider), `msgHash`: string, `signerAddress`: string): *`Promise<string>`*

*Defined in [order-utils/src/signature_utils.ts:209](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/order-utils/src/signature_utils.ts#L209)*

Signs a hash using `eth_sign` and returns its elliptic curve signature and signature type.

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`supportedProvider` | [SupportedProvider](#supportedprovider) | Web3 provider to use for all JSON RPC requests |
`msgHash` | string | Hex encoded message to sign. |
`signerAddress` | string | The hex encoded Ethereum address you wish to sign it with. This address          must be available via the supplied Provider. |

**Returns:** *`Promise<string>`*

A hex encoded string containing the Elliptic curve signature generated by signing the msgHash and the Signature Type.

####  ecSignOrderAsync

▸ **ecSignOrderAsync**(`supportedProvider`: [SupportedProvider](#supportedprovider), `order`: `Order`, `signerAddress`: string): *`Promise<SignedOrder>`*

*Defined in [order-utils/src/signature_utils.ts:36](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/order-utils/src/signature_utils.ts#L36)*

Signs an order and returns a SignedOrder. First `eth_signTypedData` is requested
then a fallback to `eth_sign` if not available on the supplied provider.

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`supportedProvider` | [SupportedProvider](#supportedprovider) | Web3 provider to use for all JSON RPC requests |
`order` | `Order` | The Order to sign. |
`signerAddress` | string | The hex encoded Ethereum address you wish to sign it with. This address          must be available via the supplied Provider. |

**Returns:** *`Promise<SignedOrder>`*

A SignedOrder containing the order and Elliptic curve signature with Signature Type.

####  ecSignTransactionAsync

▸ **ecSignTransactionAsync**(`supportedProvider`: [SupportedProvider](#supportedprovider), `transaction`: `ZeroExTransaction`, `signerAddress`: string): *`Promise<SignedZeroExTransaction>`*

*Defined in [order-utils/src/signature_utils.ts:117](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/order-utils/src/signature_utils.ts#L117)*

Signs a transaction and returns a SignedZeroExTransaction. First `eth_signTypedData` is requested
then a fallback to `eth_sign` if not available on the supplied provider.

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`supportedProvider` | [SupportedProvider](#supportedprovider) | Web3 provider to use for all JSON RPC requests |
`transaction` | `ZeroExTransaction` | The ZeroExTransaction to sign. |
`signerAddress` | string | The hex encoded Ethereum address you wish to sign it with. This address          must be available via the supplied Provider. |

**Returns:** *`Promise<SignedZeroExTransaction>`*

A SignedTransaction containing the order and Elliptic curve signature with Signature Type.

####  ecSignTypedDataOrderAsync

▸ **ecSignTypedDataOrderAsync**(`supportedProvider`: [SupportedProvider](#supportedprovider), `order`: `Order`, `signerAddress`: string): *`Promise<SignedOrder>`*

*Defined in [order-utils/src/signature_utils.ts:73](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/order-utils/src/signature_utils.ts#L73)*

Signs an order using `eth_signTypedData` and returns a SignedOrder.

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`supportedProvider` | [SupportedProvider](#supportedprovider) | Web3 provider to use for all JSON RPC requests |
`order` | `Order` | The Order to sign. |
`signerAddress` | string | The hex encoded Ethereum address you wish to sign it with. This address          must be available via the supplied Provider. |

**Returns:** *`Promise<SignedOrder>`*

A SignedOrder containing the order and Elliptic curve signature with Signature Type.

####  ecSignTypedDataTransactionAsync

▸ **ecSignTypedDataTransactionAsync**(`supportedProvider`: [SupportedProvider](#supportedprovider), `transaction`: `ZeroExTransaction`, `signerAddress`: string): *`Promise<SignedZeroExTransaction>`*

*Defined in [order-utils/src/signature_utils.ts:166](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/order-utils/src/signature_utils.ts#L166)*

Signs a ZeroExTransaction using `eth_signTypedData` and returns a SignedZeroExTransaction.

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`supportedProvider` | [SupportedProvider](#supportedprovider) | Web3 provider to use for all JSON RPC requests |
`transaction` | `ZeroExTransaction` | The ZeroEx Transaction to sign. |
`signerAddress` | string | The hex encoded Ethereum address you wish to sign it with. This address          must be available via the supplied Provider. |

**Returns:** *`Promise<SignedZeroExTransaction>`*

A SignedZeroExTransaction containing the ZeroExTransaction and Elliptic curve signature with Signature Type.

####  parseValidatorSignature

▸ **parseValidatorSignature**(`signature`: string): *`ValidatorSignature`*

*Defined in [order-utils/src/signature_utils.ts:296](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/order-utils/src/signature_utils.ts#L296)*

Parse a hex-encoded Validator signature into validator address and signature components

**Parameters:**

Name | Type | Description |
------ | ------ | ------ |
`signature` | string | A hex encoded Validator 0x Protocol signature |

**Returns:** *`ValidatorSignature`*

A ValidatorSignature with validatorAddress and signature parameters

<hr />



<hr /> 



<hr /> 




##  Type aliases

####  Callback

Ƭ **Callback**: *function*

*Defined in [subproviders/src/types.ts:131](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/subproviders/src/types.ts#L131)*

##### Type declaration:

▸ (): *void*

___



###  ErrorCallback

Ƭ **ErrorCallback**: *function*

*Defined in [subproviders/src/types.ts:130](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/subproviders/src/types.ts#L130)*

#### Type declaration:

▸ (`err`: `Error` | null, `data?`: any): *void*

**Parameters:**

Name | Type |
------ | ------ |
`err` | `Error` \| null |
`data?` | any |

___










##  Type aliases



###  AssetData

Ƭ **AssetData**: *[SingleAssetData](_types_src_index_.md#singleassetdata) | [MultiAssetData](#interface-multiassetdata) | [MultiAssetDataWithRecursiveDecoding](#interface-multiassetdatawithrecursivedecoding)*

*Defined in [types/src/index.ts:224](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/types/src/index.ts#L224)*

___







###  EventCallback

Ƭ **EventCallback**: *function*

*Defined in [types/src/index.ts:848](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/types/src/index.ts#L848)*

#### Type declaration:

▸ (`err`: null | `Error`, `log?`: [DecodedLogEvent](#interface-decodedlogevent)‹*`ArgsType`*›): *void*

**Parameters:**

Name | Type |
------ | ------ |
`err` | null \| `Error` |
`log?` | [DecodedLogEvent](#interface-decodedlogevent)‹*`ArgsType`*› |

___









###  SingleAssetData

Ƭ **SingleAssetData**: *[ERC20AssetData](#interface-erc20assetdata) | [ERC721AssetData](#interface-erc721assetdata) | [ERC1155AssetData](#interface-erc1155assetdata) | [StaticCallAssetData](#interface-staticcallassetdata)*

*Defined in [types/src/index.ts:204](https://github.com/0xProject/0x-monorepo/blob/62fae9af9/packages/types/src/index.ts#L204)*

<hr />



<hr />

